#include "ChangeLangDlg.h"
#include <boost/lexical_cast.hpp>

ablib::system::Translation::LangInfo ChangeLangDlg::Show(ablib::window::Wnd *parent){
	m_langinfo = ablib::system::Translation::LangInfo(_T(""),0);
	Create(parent,IDD_LANGLIST);
	return m_langinfo;
}

bool ChangeLangDlg::OnInitDialog(ablib::window::Dialog *wnd){
	std::vector<ablib::system::Translation::LangInfo> langinfos = ablib::system::Translation::GetAvailableLanguages();
	ablib::window::Combo langlist(wnd,IDC_LANGLIST);
	m_name2id.clear();
	for(const ablib::system::Translation::LangInfo &li : langinfos){
		m_name2id[li.name] = li.id;
		langlist.AddString(li.name);
		if(li.id == ablib::system::Translation::GetLanguage()){
			langlist.SetCurSel(langlist.GetCount() - 1);
		}
	}
	return true;
}

bool ChangeLangDlg::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDOK:
	{
		ablib::window::Combo langlist(wnd,IDC_LANGLIST);
		ablib::string name = langlist.GetText();
		if(m_name2id.find(name) != m_name2id.end()){
			m_langinfo = ablib::system::Translation::LangInfo(name,m_name2id[name]);
		}
		wnd->Destroy(TRUE);
		return true;
	}
	case IDCANCEL:
		wnd->Destroy(TRUE);
		return true;
	default:
		return false;
	}
}

