#include "stdafx.h"
#include <map>
#include "DllPlugin.h"
#include "setting.h"

extern setting g_setting;

bool DllPlugin::Load(const TCHAR *dll){
	if(m_dll)return false;
	m_dll = ::LoadLibrary(dll);
	if(!m_dll)return false;
	m_Info = reinterpret_cast<INFO>(::GetProcAddress(m_dll,"Info"));
	m_PluginInit = reinterpret_cast<PLUGININIT>(::GetProcAddress(m_dll,"PluginInit"));
	m_Set = reinterpret_cast<SET>(::GetProcAddress(m_dll,"Set"));
	m_GetInfo = reinterpret_cast<GETINFO>(::GetProcAddress(m_dll,"GetInfo"));
	m_IsDefault = reinterpret_cast<ISDEFAULT>(::GetProcAddress(m_dll,"IsDefault"));
	m_GetDownloadData = reinterpret_cast<GETDOWNLOADDATA>(::GetProcAddress(m_dll,"GetDownloadData"));
	m_Install = reinterpret_cast<INSTALL>(::GetProcAddress(m_dll,"Install"));
	m_Reboots = reinterpret_cast<REBOOTS>(::GetProcAddress(m_dll,"Reboots"));
	m_Sets = reinterpret_cast<SETS>(::GetProcAddress(m_dll,"Sets"));
	m_PluginUnInit = reinterpret_cast<PLUGINUNINIT>(::GetProcAddress(m_dll,"PluginUnInit"));
	if(
		m_Info == NULL || m_Set == NULL || m_GetDownloadData == NULL || m_Install == NULL || 
		m_PluginInit == NULL || m_GetInfo == NULL || m_IsDefault == NULL || m_Reboots == NULL ||
		m_Sets == NULL
	){
		::FreeLibrary(m_dll);
		return false;
	}
	
	(*m_PluginInit)(ablib::TransCode::ToChar(g_setting.GetIniFile()).c_str(),ablib::TransCode::ToChar(g_setting.GetLogFile()).c_str());

	::PluginInfo *infos = (*m_Info)();
	int index = 0;
	while(infos->softname){
		m_infos.push_back(SoftInfo(ablib::TransCode::FromChar(infos->softname),ablib::TransCode::FromChar(infos->info)));
		++infos;
	}

	m_dllname = dll;
	return true;
}

bool DllPlugin::Install(HWND hwnd, int index, const std::map<ablib::string,State> &downloadstates){
	::DLResult dlr;
	dlr.size = downloadstates.size();
	dlr.results = new ::DLResult::Result[dlr.size];
	int i = 0;
	for(std::map<ablib::string,State>::const_iterator ite = downloadstates.begin() ; ite != downloadstates.end() ; ++ite,++i){
		dlr.results[i].url = new char[ite->first.length() + 1];
		::lstrcpyA(dlr.results[i].url,ablib::TransCode::ToChar(ite->first).c_str());
		dlr.results[i].state = ite->second;
	}
	bool rv = (*m_Install)(hwnd,ablib::TransCode::ToChar(m_infos[index].softname).c_str(),dlr);
	for(i = 0 ; i < dlr.size ; ++i)delete[] dlr.results[i].url;
	delete dlr.results;
	return rv;
}

PluginInterface::DownloadData DllPlugin::GetDownloadData(int index){
	::DownloadData ddres = (*m_GetDownloadData)(ablib::TransCode::ToChar(m_infos[index].softname).c_str());
	PluginInterface::DownloadData dd;
	dd.downnum = ddres.downnum;
	dd.success = ddres.success;
	PluginInterface::DLFile dlf;
	for(int i = 0 ; i < ddres.downnum ; ++i){
		dlf.file = ablib::TransCode::FromChar(ddres.dls[i].file);
		dlf.size = ddres.dls[i].size;
		dlf.url = ablib::TransCode::FromChar(ddres.dls[i].url);
	}
	return dd;
}
	