#include "stdafx.h"
#include <process.h>
#include <boost/lexical_cast.hpp>
#include <ablib/Pathname.h>
#include "resource.h"
#include "Download.h"
#include "func.h"
#include "Setting.h"
#include "InstallFiles.h"
#include "Plugin.h"

extern setting g_setting;
extern InstallFiles g_InstallFiles;
extern Plugin g_plugin;

namespace{
	const int SUCCESS = 0;
	const int CANCEL = 1;
	const int CONNECTERROR = 2;
	const int NOTHREAD = 3;
	const int FAILED = 4;

	const int WM_TITLE = WM_APP + 88;
	const int WM_ISABORT = WM_APP + 89;
}



int Download::down(ablib::window::Wnd *parent){
	DEBUGSTRING(_T("Download::down Jn"));
	m_isabort = false;
	m_parent = parent;


	m_event = ::CreateEvent(NULL,TRUE,FALSE,_T("AbTeXinst_Download"));
	if(m_event == NULL)return NOTHREAD;
	m_hThread = reinterpret_cast<HANDLE>(::_beginthread(sDialog,0,this));
	DEBUGSTRING(_T("Download::OnInitDialogFXbhCm_hThread = %d"),m_hThread);
	if(m_hThread == NULL)return NOTHREAD;

	::WaitForSingleObject(m_event,INFINITE);
	m_parent->ShowWindow(ablib::window::Wnd::sw_hide);
	int rv = StartDownload();
	GetWindow()->SendMsg(WM_CLOSE,0,0);
	::WaitForSingleObject(m_hThread,1000);
	::TerminateThread(m_hThread,0);

	if(rv != SUCCESS)m_parent->ShowWindow(ablib::window::Wnd::sw_show);
	return rv;

}

void Download::sDialog(void *d){
	Download *me = static_cast<Download*>(d);
	me->Dialog();
}

void Download::Dialog(){
	int rv = BaseModalDlg::Create(NULL,IDD_DOWNLOAD);
}


bool Download::OnInitDialog(ablib::window::Dialog *wnd){
	::SetEvent(m_event);
	return true;
}

bool Download::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDCANCEL:
		{
			LOCK l(this);
			m_isabort = true;
			return true;
		}
	default:
		return false;
	}
}

INT_PTR Download::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_MESSAGE:
		ablib::window::StaticText(wnd,IDC_MSG).SetText(reinterpret_cast<TCHAR*>(lParam));
		return TRUE;
	case WM_TITLE:
		wnd->SetTitle(reinterpret_cast<TCHAR*>(lParam));
		return TRUE;
	default:
		return FALSE;
	}
}

int Download::StartDownload(){
	m_downlist.clear();
	m_totalsize = 0;
	DEBUGSTRING(_T("Download::StartDownloadF{\tg̃_E[hXg쐬"));
	struct{const InstallFiles::Filelist &fl;ablib::string urlhead;} fls[] = {
		{g_InstallFiles.GetW32TeXFileInfo(),g_setting.GetTeXUrl()},
		{g_InstallFiles.GetdvioutFileInfo(),g_setting.GetDVIOUTUrl()},
		{g_InstallFiles.GetGSFileInfo(),g_setting.GetGSUrl()},
//		{g_InstallFiles.GetGVFileInfo(),g_setting.GetGVUrl()}
	};
	for(int i = 0 ; i < /*4*/3 ; ++i){
		for(const InstallFiles::Filelist::value_type &ite : fls[i].fl){
			DownloadList dl;
			if(ite.second.todo_download){
				dl.name = ite.first;
				dl.size = ite.second.size;
				dl.url = fls[i].urlhead + ite.first;
				m_downlist.push_back(dl);
				m_totalsize += dl.size;
			}
		}
	}
	DEBUGSTRING(_T("Download::StartDownloadFvOC̃_E[hXg쐬"));
	std::vector<ablib::string> purls,pfiles;
	std::vector<size_type> psizes;
	g_plugin.GetDownloadList(purls,pfiles,psizes);
	for(std::vector<ablib::string>::size_type i = 0 ; i < purls.size() ; ++i){
		DEBUGSTRING(_T("Download::StartDownload: %s̏ݒ"),pfiles[i].c_str());
		DownloadList dl;
		dl.name = pfiles[i];
		dl.url = purls[i];
		dl.size = psizes[i];
		m_downlist.push_back(dl);
		m_totalsize += dl.size;
	}


	DEBUGSTRING(_T("Download::StartDownloadF_E[hݒ"));
	m_alreadydownsize = 0;
	WriteMsg(ablib::string(_TR("_E[hcc")));
	SetProgress(32768,0);
	ablib::basic_string<char> proxy;
//	INTERNET_PROXY_INFO ipi;
	struct{
		DWORD dwAccessType;
		const char *lpszProxy;
		const char *lpszProxyBypass;
	}ipi;
	if(g_setting.GetPortNum() != 0 && ::lstrcmp(g_setting.GetProxy(),_T("")) != 0){
		proxy = ablib::TransCode::ToChar(ablib::string(g_setting.GetProxy()) + _T(":") + boost::lexical_cast<ablib::string>(g_setting.GetPortNum()));
		ipi.dwAccessType = INTERNET_OPEN_TYPE_PROXY;
		ipi.lpszProxy = proxy.c_str();
		ipi.lpszProxyBypass = "<local>";
		if(::UrlMkSetSessionOption(INTERNET_OPTION_PROXY,&ipi,sizeof(ipi),0) != S_OK){
			g_setting.Log(_TR("proxy̐ݒɎs"));
			return CONNECTERROR;
		}
	}
	
	m_lasttime = m_starttime = ::GetTickCount();
	m_ikutumeka = 0;
	for(m_ite = m_downlist.begin() ; m_ite != m_downlist.end() ; ++m_ite){
		++m_ikutumeka;
		DEBUGSTRING(_T("Download::StartDownloadF%dڂ̃_E[hJnCURL = %s"),m_ikutumeka,m_ite->url.c_str());
		DispRestTime(m_alreadydownsize,true);
		if(g_setting.IsDeleteCache())::DeleteUrlCacheEntry(m_ite->url.c_str());
		::CreateDirectoryReflex((ablib::Pathname(g_setting.GetHozonDir() + m_ite->name).dirname() + _T("\\")).c_str());
		if(::URLDownloadToFile(NULL,m_ite->url.c_str(),(g_setting.GetHozonDir() + m_ite->name).c_str(),0,this) != S_OK){
			::DeleteFile((g_setting.GetHozonDir() + m_ite->name).c_str());
			if(CheckCancel()){
				g_setting.Log(_TR("LZ܂"));
				if(!g_InstallFiles.SetDownloadState(m_ite->name,cancel)){
					g_plugin.SetDownloadState(m_ite->url,cancel);
				}
				::DeleteFile((g_setting.GetHozonDir() + m_ite->name).c_str());
				return CANCEL;
			}else{
				g_setting.Log(ablib::string::sprintf(_TR("%s̃_E[hɎs"),m_ite->url.c_str()));
				if(!g_InstallFiles.SetDownloadState(m_ite->name,fail)){
					g_plugin.SetDownloadState(m_ite->url,fail);
				}
//				return CONNECTERROR;
			}
		}else{
			g_setting.Log(ablib::string::sprintf(_TR("%s_E[h"),m_ite->url.c_str()));
			if(!g_InstallFiles.SetDownloadState(m_ite->name,success)){
				g_plugin.SetDownloadState(m_ite->url,success);
			}
		}
		m_alreadydownsize += m_ite->size;
	}
	return SUCCESS;
}

STDMETHODIMP Download::OnProgress(ULONG ulProgress,ULONG ulProgressMax,ULONG ulStatusCode,LPCWSTR szStatusText){
	TCHAR msg[1024];
	if(CheckCancel())return E_ABORT;
	if(m_ite->name == _T(""))return S_OK;
	// bZ[WXVDuقɂ F /v
/*
	ulProgress = min(ulProgress,m_ite->size);
	SetProgressPos((int)((double)ulProgress/m_ite->size * 32768));
	::wsprintf(msg,_T("%s : %ld/%ld"),m_ite->name.c_str(),ulProgress,m_ite->size);
*/

	ULONG maxsize = ulProgressMax;
	if(ulProgressMax == 0)maxsize = m_ite->size;
	
	ulProgress = min(ulProgress,maxsize);
	SetProgressPos((int)((double)ulProgress/maxsize * 32768));
	::wsprintf(msg,_T("%s : %ld/%ld"),m_ite->name.c_str(),ulProgress,maxsize);



	WriteMsg(msg);

	// ^CgXVu_E[hi/j  c莞ԁFقɂv
	DispRestTime(m_alreadydownsize + ulProgress,false);
	return S_OK;
}

void Download::DispRestTime(size_type downsize,bool force){
	DWORD nowtime = ::GetTickCount();
	if(nowtime - m_lasttime >= 1000 || force){
		TCHAR msg[4096];
		::wsprintf(msg,_TR("t@C̃_E[h   ( %d / %d )"),m_ikutumeka,m_downlist.size());
		WriteTitle(msg);
		if(nowtime - m_starttime >= 5000){
			m_lasttime = nowtime;
			TCHAR str[1024];
			// 1byteɂ鎞(minsec)
			double v = ((double)(nowtime - m_starttime) / downsize);
			int sec = (int)((m_totalsize - downsize) * v / 1000);
			if(sec < 0)sec = 0;
			int hour = sec / 3600;sec -= hour * 3600;
			int min = sec / 60;sec -= min * 60;
			if(hour != 0)::wsprintf(str,_TR("c %d  %d "),hour,min);
			else if(min != 0){
				if(sec <= 30)sec = 30;
				else{sec = 0;++min;}
				::wsprintf(str,_TR("c %d  %d b"),min,sec);
			}else{
				sec = sec / 10;sec = (sec + 1)* 10;
				::wsprintf(str,_TR("c %d b"),sec);
			}
			::lstrcpy(msg,str);
			ablib::window::StaticText(GetWindow(),IDC_RESTTIME).SetText(msg);
		}
	}
}


STDMETHODIMP Download::QueryInterface(REFIID riid,void **ppv){
	*ppv = NULL;
	AddRef();
	if(IsEqualIID(riid,IID_IUnknown) || IsEqualIID(riid,IID_IBindStatusCallback)){
		*ppv = static_cast<IBindStatusCallback*>(this);
		return NOERROR;
	}else{
		Release();
		return E_NOINTERFACE;
	}
}

	

void Download::WriteMsg(ablib::string &msg){
	GetWindow()->SendMsg(WM_MESSAGE,0,reinterpret_cast<LPARAM>(msg.c_str()));
}

void Download::WriteMsg(const TCHAR *msg){
	GetWindow()->SendMsg(WM_MESSAGE,0,reinterpret_cast<LPARAM>(msg));
}

void Download::WriteTitle(ablib::string &title){
	GetWindow()->SendMsg(WM_TITLE,0,reinterpret_cast<LPARAM>(title.c_str()));
}

void Download::WriteTitle(const TCHAR *title){
	GetWindow()->SendMsg(WM_TITLE,0,reinterpret_cast<LPARAM>(title));
}


