#include "stdafx.h"
#include <functional>
#include "envcheck.h"
#include "resource.h"
#include "registory.h"
#include "func.h"
#include <regex>
#include "setting.h"
#include <vector>
#include <system/System.h>

extern setting g_setting;

bool EnvCheck::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::StaticText(wnd,IDC_MSG).SetText(m_msg.c_str());

	ablib::window::ListView list(wnd,IDC_LIST);
	list.EnableCheckBox();

	std::vector<ablib::window::ListView::ColumnData> header;
	header.push_back(ablib::window::ListView::ColumnData(100,_TR("ϐ")));
	header.push_back(ablib::window::ListView::ColumnData(200,_TR("l")));
	list.SetColumn(header);

	ablib::string log;
	for(ablib::string &i : m_envs){
		TCHAR buf[4096];
		buf[0] = '\0';
		::GetEnvironmentVariable(i.c_str(),buf,4096);
		if(::lstrcmp(buf,_T("")) != 0){
			std::vector<ablib::string> data;
			data.push_back(i);
			data.push_back(buf);
			list.AddItem(data,true);
			
			log += ablib::string::sprintf(_TR("u%sv"),i);
		}
	}
	g_setting.Log(ablib::string::sprintf(_TR("ϐ%s"),log.c_str()));
	return true;
}

bool EnvCheck::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDOK:
	{
		ablib::window::ListView list(wnd,IDC_LIST);
		int items = list.GetItemCount();
		bool isdelete = false;
		for(int i = 0 ; i < items ; ++i){
			if(list.GetCheckState(i)){
				DeleteEnvForced(list.GetItem(i)[0].c_str());
				isdelete = true;
			}
		}
		wnd->Destroy(isdelete ? TRUE : FALSE);
		return true;
	}
	case IDCANCEL:
		g_setting.Log(_TR("ϐ폜܂ł"));
		wnd->Destroy(FALSE);
		return true;
	default:
		return false;
	}
}

void EnvCheck::DeleteEnvForced(const TCHAR *env){
	g_setting.Log(ablib::string::sprintf(_TR("ϐu%sv̍폜Jn"),env));

	ablib::system::System sys;
	if(sys.IsNT()){
		const TCHAR RegPath[] = _T("SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment");
		ablib::string path = ablib::string(RegPath) + _T("\\") + env;
		Registory::DeleteValue(HKEY_LOCAL_MACHINE,path.c_str());
		path = ablib::string(_T("Environment\\")) + env;
		Registory::DeleteValue(HKEY_CURRENT_USER,path.c_str());
		DWORD ret;
		::SendMessageTimeout(
			HWND_BROADCAST,
			WM_SETTINGCHANGE,
			0,
			reinterpret_cast<LPARAM>(_T("Environment")),
			SMTO_ABORTIFHUNG,
			5000,
			&ret);
		::SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, 0, 0);
	}

	TCHAR buf[128];
	::GetSystemDirectory(buf,127);
	
	ablib::string autoexec = buf[0];
	autoexec += _T(":\\autoexec.bat");
	
	FILE *fp = ::_tfopen(autoexec.c_str(),_T("r"));
	if(fp){
		TCHAR buf[4096];
		ablib::string regex = ablib::string(_T("^ *set *")) + env + _T(" *=");
#ifdef UNICODE
		std::wregex reg;
#else
		std::regex reg;
#endif
		reg.assign(regex,std::regex::ECMAScript | std::regex::icase);

		std::vector<ablib::string> towrite;
		bool ischange = false;

		while(::_fgetts(buf,4096,fp)){
			if(!std::regex_search(buf,reg))towrite.push_back(buf);
			else ischange = true;
		}
		::fclose(fp);

		if(ischange){
			fp = ::_tfopen(autoexec.c_str(),_T("w"));
			if(fp){
				for(ablib::string &i : towrite)::_ftprintf(fp,_T("%s"),i.c_str());
				::fclose(fp);
				g_setting.Log(ablib::string::sprintf(_TR("ϐu%sv̍폜I"),env));
			}else g_setting.Log(ablib::string::sprintf(_TR("%s̍폜s"),autoexec.c_str()));
		}
	}else g_setting.Log(ablib::string::sprintf(_TR("%s̍폜s"),autoexec));
	return;
}

bool EnvCheck::CheckEnv(){
	for(ablib::string &i : m_envs){
		TCHAR buf[4096];
		if(::GetEnvironmentVariable(i.c_str(),buf,4096) && ::lstrcmp(buf,_T("")) != 0)return true;
	}
	return false;
}

