#include "stdafx.h"
#include <vector>
#include <window/dialog.h>
#include <boost/lexical_cast.hpp>
#include "exttex.h"
#include "resource.h"
#include "setting.h"
#include "InstallFiles.h"

extern setting g_setting;
extern InstallFiles g_InstallFiles;

int ExtTeX::Create(ablib::window::Wnd *parent){
	return BaseModalDlg::Create(parent,IDD_EXTTEX);
}

bool ExtTeX::OnInitDialog(ablib::window::Dialog *wnd){
	std::vector<ablib::window::ListView::ColumnData> data;
	data.push_back(ablib::window::ListView::ColumnData(163,_TR("t@C")));
	data.push_back(ablib::window::ListView::ColumnData(50,_TR("")));
	data.push_back(ablib::window::ListView::ColumnData(70,_TR("TCY")));
	ablib::window::ListView list(wnd,IDC_INSTALL);
	list.EnableCheckBox();
	list.SetColumn(data);
	const InstallFiles::Filelist &fl = g_InstallFiles.GetW32TeXFileInfo();
	std::vector<ablib::string> push;push.resize(3);
	for(const InstallFiles::Filelist::value_type &ite : fl){
		push[0] = ite.first; 
		if(ite.second.todo_download){
			if(ite.second.state_download == success)push[1] = _TR("Â");
			else push[1] = _TR("");
		}else push[1] = _TR("ŐV");
		if(ite.second.size < 1024)push[2] = boost::lexical_cast<ablib::string>(ite.second.size) + _T("B");
		else if(ite.second.size < 1024*1023)push[2] = boost::lexical_cast<ablib::string>(ite.second.size/1024) + _T("KB");
		else{
			int kbyte = ite.second.size / 1024;
			int mbyte = kbyte / 1024;
			kbyte = kbyte - mbyte * 1024;
			kbyte = kbyte / 100;
			// 1024 / 100 != 10肿Ɩ邱ƂD
			if(kbyte == 10){++mbyte;kbyte = 0;}
			push[2] = boost::lexical_cast<ablib::string>(mbyte) + _T(".") + boost::lexical_cast<ablib::string>(kbyte) + _T("MB");
		}
		list.AddItem(push,ite.second.todo_install);
	}
	ablib::window::CheckBox(wnd,IDC_DLINST).SetCheck(g_setting.IsDLInst());
	ablib::window::CheckBox(wnd,IDC_INST).SetCheck(!g_setting.IsDLInst());
	return true;
}

bool ExtTeX::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	ablib::window::CheckBox dlinst(wnd,IDC_DLINST);
	int item;
	switch(id){
	case IDOK:
	{
		if(dlinst.GetCheck()){
			g_setting.SetIsDLInst(true);
			const InstallFiles::Filelist &fl = g_InstallFiles.GetW32TeXFileInfo();
			for(const InstallFiles::Filelist::value_type &ite : fl){
				g_InstallFiles.SetInstall(ite.first,ite.second.todo_download);
			}
		}else{
			g_setting.SetIsDLInst(false);
			ablib::window::ListView list(wnd,IDC_INSTALL);
			int items = list.GetItemCount();
			for(int i = 0 ; i < items ; ++i){
				g_InstallFiles.SetInstall(list.GetItem(i)[0],list.GetCheckState(i));
			}
		}
	wnd->Destroy(TRUE);
		return true;
	}
	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;
	case IDC_ALLCHECK:
	{
		ablib::window::ListView list(wnd,IDC_INSTALL);
		item = list.GetItemCount();
		for(int i = 0 ; i < item ; ++i)list.SetCheckState(i,true);
		return true;
	}
	default:
		return false;
	}
}

bool first = true;;
INT_PTR ExtTeX::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_NOTIFY:
		switch(((LPNMHDR)lParam)->idFrom){
		case IDC_INSTALL:
			switch(((LPNMHDR)lParam)->code){
			case LVN_ITEMCHANGED:
			{
				if(!first)return FALSE;
				NMLISTVIEW *pnmv = (LPNMLISTVIEW)lParam;
				if((pnmv->uNewState & LVIS_STATEIMAGEMASK) != (pnmv->uOldState & LVIS_STATEIMAGEMASK)){
					if((pnmv->uNewState & LVIS_STATEIMAGEMASK) == INDEXTOSTATEIMAGEMASK(2)){
						first = false;
						ablib::window::CheckBox(wnd,IDC_DLINST).SetCheck(false);
						ablib::window::CheckBox(wnd,IDC_INST).SetCheck(true);
						return TRUE;
					}
				}
			}
			}
		}
	}
	return FALSE;
}

