#include "stdafx.h"
#include <process.h>
#include <tlhelp32.h>
#include <stdio.h>
#include <fstream>
#include <algorithm>
#include <functional>
#include <ablib/IsKanji.h>
#include <ablib/Error.h>
#include <regex>
#include <system/FindFile.h>
#include <system/File.h>
#include <system/Process.h>
#include <window/dialog.h>
#include <ablib/TextFile.h>
#include <ablib/Error.h>
#include <ablib/Pathname.h>
#include "Install.h"
#include "resource.h"
#include "setting.h"
#include "ziptool.h"
#include "func.h"
#include "Registory.h"
#include "ShortCut.h"
#include "GetDir.h"
#include "File.h"
#include "EnvCheck.h"
#include "Path.h"
#include "InstallFiles.h"
#include "Plugin.h"

extern InstallFiles g_InstallFiles;
extern setting g_setting;
extern Path g_path;
extern Plugin g_plugin;

extern struct Report{
	ablib::string tex;
	ablib::string dviout;
	ablib::string dvioutset;
	ablib::string gs;
	//ablib::string gv;
	ablib::string gsset;
	ablib::string envset;
	ablib::string plugin;
}g_report;

namespace{
	const int SUCCESS = 0;
	const int EXECERROR = 1;
	const int NOGS = 2;
	const int NOTHREAD = 3;
	const int CANCEL = 4;
}

int Install::Show(ablib::window::Wnd *parent){
	m_parent = parent;

	HANDLE eve = ::CreateEvent(NULL,TRUE,FALSE,_T("Abenori_InstallEvent"));
	if(!eve)return NOTHREAD;
	HANDLE thread = reinterpret_cast<HANDLE>(::_beginthread([](void *d){
		Install *me = reinterpret_cast<Install*>(d);
		me->BaseModalDlg::Create(NULL,IDD_INSTALL);
	},0,this));
	if(!thread){
		::CloseHandle(eve);
		return NOTHREAD;
	}

	::WaitForSingleObject(eve,INFINITE);
	::CloseHandle(eve);

	if(parent->GetWindowState() != ablib::window::Wnd::sw_hide)parent->ShowWindow(ablib::window::Wnd::sw_hide);
	int rv = StartInstall();
	parent->ShowWindow(ablib::window::Wnd::sw_show);
	GetWindow()->Destroy(rv);

	if(::WaitForSingleObject(thread,1000) == WAIT_TIMEOUT)::TerminateThread(thread,FALSE);
	return rv;
}

bool Install::OnInitDialog(ablib::window::Dialog *wnd){
	m_isabort = false;

	HANDLE eve = ::OpenEvent(EVENT_ALL_ACCESS,FALSE,_T("Abenori_InstallEvent"));
	::SetEvent(eve);
	::CloseHandle(eve);
	return true;
}

bool Install::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case WM_COMMAND:
	case IDCANCEL:
		m_isabort = true;
		return true;
	default:
		return false;
	}
}

INT_PTR Install::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_MESSAGE:
	{
		ablib::window::Edit ed(wnd,IDC_INSTALL_MSG);
		ed.SetText(reinterpret_cast<TCHAR *>(lParam));
		ed.ToBottom();
		return TRUE;
	}
	case WM_ADDMESSAGE:
	{
		ablib::window::Edit ed(wnd,IDC_INSTALL_MSG);
		ablib::string s = ed.GetText();
		s += reinterpret_cast<TCHAR*>(lParam);
		ed.SetText(s.c_str());
		ed.ToBottom();
		return TRUE;
	}
	case WM_ISCANCEL:
		::SetWindowLong(wnd->GetHWND(),DWL_MSGRESULT,m_isabort ? TRUE : FALSE);
		return TRUE;
	default:
		return FALSE;
	}
}



#define E m_msg += _TR("s");m_msg += _T("\r\n");WriteMsg(m_msg);/*DeleteW32TeXFiles();*/return false
#define C m_msg += _TR("LZ܂");WriteMsg(m_msg);return CANCEL

int Install::StartInstall(){
	g_report.tex = g_report.dviout = g_report.gs = /*g_report.gv =*/ g_report.gsset = 
		g_report.envset = g_report.dvioutset = _TR("LZ");
	int rv;
	m_msg = _T("");
	WriteMsg(m_msg);
	//W32TeX
	{
		g_setting.Log(_TR("W32TeX̃CXg[Jn"));
		W32TeXInstall();
		g_setting.Log(_TR("W32TeX̃CXg[I"));
	}

	std::vector<ablib::string> envs;
	envs.push_back(_T("TEXMF"));envs.push_back(_T("TEXMFMAIN"));envs.push_back(_T("TEXMFCNF"));
	EnvCheck W32EnvChk(ablib::system::Translation::GetResourceHandle(),envs,
		_TR("ȉ̊ϐ͍ŐVW32TeXł͕svłD폜܂H\n폜ꍇ͍폜ϐɃ`FbNOKĂD\n폜Ȃꍇ̓LZĂ"));
	if(W32EnvChk.CheckEnv()){
		g_setting.Log(_TR("TeX̕svϐ폜Jn"));
		if(W32EnvChk.Create(GetWindow()))g_InstallFiles.Reboot();
		g_setting.Log(_TR("TeX̕svϐ폜I"));
	}

	if(CheckCancel()){C;}

	//Ghostscript
	ablib::string gs;
	InstallFiles::Filelist gsfl = g_InstallFiles.GetGSFileInfo();
	for(InstallFiles::Filelist::value_type &i : gsfl){
		if(i.second.todo_install){gs = i.first;break;}
	}
	if(gs != _T("")){
		if(CheckGSInstall()){
			ablib::string msg = _TR("Ghostscript͊ɃCXg[Ă܂DACXg[܂H\nACXg[Ȃu͂vC\nɃCXg[ȂuvC\nCXg[ȂȂ΁uLZvĂ");
			msg.replace(_T("\n"),_T("\r\n"));
			rv = GetWindow()->MsgBox(msg,_T("abtexinst"),ablib::window::Window::mb_yesnocancel);
			switch(rv){
			case ablib::window::Window::id_yes:
				if(!GSUnInstall()){
					GetWindow()->MsgBox(_TR("ACXg[Ɏs"),_T("abtexinst"));
					break;
				}
				if(CheckCancel()){C;}
				// ̂܂܃CXg[ցD
			case ablib::window::Window::id_no:
				if(GSInstall(gs)){
					if(CheckCancel()){C;}
				}
				break;
			case ablib::window::Window::id_cancel:
				break;
			}
		}else GSInstall(gs);
	}else g_report.gs = g_report.gsset = _TR("CXg[ĂȂ");
	envs.clear();envs.push_back(_T("GS_LIB"));
	EnvCheck GSEnvCheck(ablib::system::Translation::GetResourceHandle(),envs,
		_TR("ȉ̊ϐ͍ŐVGhostscriptł͕svłD폜܂H\n폜ꍇ͍폜ϐɃ`FbNOKĂD\n폜Ȃꍇ̓LZĂ"));
	if(GSEnvCheck.CheckEnv()){
		g_setting.Log(_TR("Ghostscript̕svϐ폜Jn"));
		if(GSEnvCheck.Create(GetWindow()))g_InstallFiles.Reboot();
		g_setting.Log(_TR("Ghostscript̕svϐ폜I"));
	}

	if(CheckCancel()){C;}

	//GSview
	/*
	ablib::string gv;
	InstallFiles::Filelist gvfl = g_InstallFiles.GetGVFileInfo();
	for(InstallFiles::Filelist::value_type &i : gvfl){
		if(i.second.todo_install){gv = i.first;break;}
	}
	if(gv != _T("")){
		if(CheckGVInstall()){
			ablib::string msg = _TR("GSview͊ɃCXg[Ă܂DACXg[܂H\nACXg[Ȃu͂vC\nɃCXg[ȂuvC\nCXg[ȂȂ΁uLZvĂ");
			msg.replace(_T("\n"),_T("\r\n"));
			rv = GetWindow()->MsgBox(msg,_T("abtexinst"),ablib::window::Window::mb_yesnocancel);
			switch(rv){
			case ablib::window::Window::id_yes:
				if(!GVUnInstall()){
					GetWindow()->MsgBox(_TR("ACXg[Ɏs"),_T("abtexinst"));
					break;
				}
				if(CheckCancel()){C;}
			case ablib::window::Window::id_no:
				GVInstall(gv);
				break;
			case ablib::window::Window::id_cancel:
				break;
			}
		}else GVInstall(gv);
	}else g_report.gv = _TR("CXg[ĂȂ");
	if(CheckCancel()){C;}
	*/
	//dviout
	ablib::string dviout;
	InstallFiles::Filelist dvioutfl = g_InstallFiles.GetdvioutFileInfo();
	for(InstallFiles::Filelist::value_type &i : dvioutfl){
		if(i.second.todo_install){dviout = i.first;break;}
	}
	if(dviout != _T("")){
		if(CheckDVIOUTInstall()){
			ablib::string msg = _TR("dviout͊ɃCXg[Ă܂DACXg[܂H\nACXg[Ȃu͂vC\nɃCXg[ȂuvC\nCXg[ȂȂ΁uLZvĂD\n܂CAbvf[g̎uvIł");
			msg.replace(_T("\n"),_T("\r\n"));
			rv = GetWindow()->MsgBox(msg,_T("abtexinst"),ablib::window::Window::mb_yesnocancel);
			switch(rv){
			case ablib::window::Window::id_yes:
				if(!DVIOUTUnInstall()){
					GetWindow()->MsgBox(_TR("ACXg[Ɏs"),_T("abtexinst"));
					break;
				}
				if(CheckCancel()){C;}
			case ablib::window::Window::id_no:
				if(DVIOUTInstall(dviout)){
					if(CheckCancel()){C;}
					DVIOUTSetting();
				}
				break;
			case ablib::window::Window::id_cancel:
				break;
			}
		}else if(DVIOUTInstall(dviout))DVIOUTSetting();
	}else{
		g_report.dviout = _TR("CXg[ĂȂ");
		g_report.dvioutset = _TR("CXg[ĂȂ");
	}

	// ̑̃\tgFvOCN
	bool isinstall = false;
	for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
		if(g_plugin.IsInstall(i)){
			isinstall = true;
			break;
		}
	}
	if(!isinstall){
		g_report.plugin = _TR("CXg[ĂȂ");
	}else{
		g_setting.Log(_TR("̑̃\tgEFÃCXg[Jn"));
		m_msg += _TR("̑̃\tgEFÃCXg[");
		m_msg += _T("\r\n");
		WriteMsg(m_msg);
		
		g_report.plugin = g_plugin.Install(GetWindow()->GetHWND()) ? _TR("") : _TR("s");
		g_setting.Log(ablib::string::sprintf(_TR("̑̃\tgEFÃCXg[%s܂"),g_report.plugin.c_str()));
	}

	//ϐҏW
	AddMsg(_T("\r\n"));
	AddMsg(_TR("PATH̐ݒcc"));
	g_path.SetPath();
	AddMsg(g_report.envset);
	AddMsg(_T("\r\n"));
	if(CheckCancel()){C;}
	if(g_InstallFiles.DoesUpdatelsr())Updatelsr();
	if(CheckCancel()){C;}
	
	if(g_plugin.Reboots())g_InstallFiles.Reboot();


	return SUCCESS;
}

bool Install::W32TeXInstall(){
	const InstallFiles::Filelist &w32texs = g_InstallFiles.GetW32TeXFileInfo();
	bool toinstall = false;
	for(const InstallFiles::Filelist::value_type &i : w32texs){
		if(i.second.todo_install &&(
			(i.second.todo_download && i.second.state_download == success) ||
			(!i.second.todo_download)
		)){
			toinstall = true;
			break;
		}
	}
	if(!toinstall){
		g_report.tex = _TR("CXg[ĂȂ");
		return true;
	}
	CreateDirectoryReflex(g_setting.GetInstallDir());
	ablib::string cmd,pattern,file;
	bool b = true;
	m_msg += _TR("W32TeX̃CXg[");
	m_msg += _T("\r\n");
	WriteMsg(m_msg);
	ablib::string listdir = g_setting.GetHozonDir();listdir += _T("filelist\\");
	if(g_setting.IsWriteHozonDir())CreateDirectoryReflex(listdir.c_str());
	for(const InstallFiles::Filelist::value_type &i : w32texs){
		if(!(i.second.todo_install &&(
			(i.second.todo_download && i.second.state_download == success) ||
			(!i.second.todo_download)
		)))continue;
		std::vector<ablib::string> uninstfile;
		if(W32TeXCheckUnInstall(i.first,uninstfile)){
			for(auto f : uninstfile)W32TeXUnInstall(f);
		}
	}
	for(const InstallFiles::Filelist::value_type &i : w32texs){
		if(!(i.second.todo_install &&(
			(i.second.todo_download && i.second.state_download == success) ||
			(!i.second.todo_download)
		)))continue;
		g_InstallFiles.Updatelsr();
		cmd = _T("\"");
		cmd += g_setting.GetTmpDir() + ablib::string(_T("texinst\\tar.exe\" "));
		if(::lstrcmpi(i.first.c_str() + i.first.length() - 3 , _T("bz2")) == 0)cmd += _T("jxvf");
		else if(::lstrcmpi(i.first.c_str() + i.first.length() - 2,_T("xz")) == 0)cmd += _T("Jxvf");
		else cmd += _T("zxvf");
		cmd += _T(" \"");
		ablib::string file = g_setting.GetHozonDir() + i.first;
		file.replace(_T("\\"),_T("/"));
		file.erase(0,file.rfind(_T("\\")) + 1);
		cmd += file;
		cmd += _T("\"");
		m_msg += ablib::string::sprintf(_TR("%s𓀁cc"),i.first.c_str());
		WriteMsg(m_msg);
		if(CheckCancel()){b = false;break;}
		int el = 0;
//		ablib::string outstr;
/*
		struct ErrFoundFunc{
			ErrFoundFunc() : err(false),search("Too many errors"){}
			ablib::BaseKR<ablib::KR_detail::KRSearchCore<char>,char> search;
			bool err;
			void operator()(const char* s){if(search.Match(s))err = true;}
		}errfndfunc;
*/
		bool kaitou_success = true;
		ablib::basic_string<char> outstr;
		if(Exec(cmd.c_str(),g_setting.GetInstallDir(),el,outstr,false)){
			if(g_setting.IsWriteHozonDir()){
				ablib::string listfile = listdir + i.first + _T(".txt");
				listfile.replace(_T("/"),_T("\\"));
				::CreateDirectoryReflex((ablib::Pathname(listfile).dirname() + _T("\\")).c_str());
				FILE *fp = ::_tfopen(listfile.c_str(),_T("w"));
				if(fp){
					::fprintf(fp,"%s",outstr.c_str());
					::fclose(fp);
				}
			}
			if((el != 0 && el != 2) || outstr.find("Too many errors") != ablib::basic_string<char>::npos)kaitou_success = false;
		}else kaitou_success = false;
		if(kaitou_success){
			g_setting.Log(ablib::string::sprintf(_TR("%s̃CXg[ɐ"),i.first.c_str()));
			m_msg += _TR("");
			m_msg += _T("\r\n");
			g_InstallFiles.SetInstallState(i.first,success);
		}else{
			g_setting.Log(ablib::string::sprintf(_TR("%s̃CXg[Ɏs"),i.first.c_str()));
			m_msg += _TR("s");
			m_msg += _T("\r\n");
			g_InstallFiles.SetInstallState(i.first,fail);
			b = false;
		}
		if(CheckCancel()){b = false;break;}
		WriteMsg(m_msg);
	}
	if(g_setting.IsTeXUpdatePath())g_path.AddPath(ablib::string(g_setting.GetInstallDir()) + _T("bin"));
	
	if(!b){g_report.tex = _TR("s");E;}
	else{
		if(CheckCancel())return false;
		g_report.tex = _TR("");
	}
	return true;
}


std::vector<ablib::string> installedfiles;
bool isfirst = true;
bool Install::W32TeXCheckUnInstall(const ablib::string &f,std::vector<ablib::string> &file){
	if(isfirst){
		ablib::system::FindFile ff;
		if(!ff.Begin(ablib::string(g_setting.GetHozonDir()) + _T("filelist\\*.txt")))return false;
		WIN32_FIND_DATA wfd;
		while(ff.Next(&wfd)){
			ablib::string f = wfd.cFileName;
			f.erase(f.length() - 4);
			installedfiles.push_back(f);
		}
		ff.Close();
		isfirst = false;
	}
	bool rv = false;
	for(ablib::string &i : installedfiles){
		int issimilar = g_setting.IsSimilarFile(f,i);
		if(issimilar){
			if(std::find(m_w32texuninstalledfile.begin(),m_w32texuninstalledfile.end(),i) != m_w32texuninstalledfile.end())continue;
			if(f == i || issimilar == 1){file.push_back(i);rv = true;continue;}
			else{
				ablib::string msg = ablib::string::sprintf(_TR("CXg[悤ƂĂt@C%sɂ悭Õt@C%sCXg[Ă܂D\n$炭o[WȂǂύXꂽ̂ł͂ȂƎv܂D\n%s̃CXg[̑O%sACXg[܂H"),f.c_str(),i.c_str(),f.c_str(),i.c_str());
				msg.replace(_T("\n"),_T("\r\n"));
				if(GetWindow()->MsgBox(msg,_T("abtexinst"),ablib::window::Wnd::mb_yesno) == ablib::window::Wnd::id_yes){
					file.push_back(i);rv = true;continue;
				}else continue;
			}
		}
	}
	return rv;
}

bool Install::W32TeXUnInstall(const ablib::string &f){
	ablib::TextFile tf;
	g_setting.Log(ablib::string::sprintf(_TR("%sACXg["),f.c_str()));
	m_msg += ablib::string::sprintf(_TR("%sACXg[cc"),f.c_str());WriteMsg(m_msg);
	if(!tf.Open(ablib::string(g_setting.GetHozonDir()) + _T("filelist\\") + f + _T(".txt"),ablib::TextFile::read)){
		m_msg += ablib::string::sprintf(_TR("%sJ܂ł") ,(ablib::string(g_setting.GetHozonDir()) + _T("filelist\\") + f + _T(".txt")).c_str());
		m_msg += _TR("ACXg[Ɏs");
		m_msg += _TR("s");m_msg += _T("\r\n");WriteMsg(m_msg);
		return false;
	}
	TCHAR buf[4096];
	bool rv = true;
	std::vector<ablib::string> dirs;
	while(tf.ReadLine(buf,4095)){
		int len;
		for(len = 0 ; buf[len] != '\0' && buf[len] != '\r' && buf[len] != '\n' ; ++len);
		buf[len] = '\0';
		if(len == 0)continue;
		for(int i = 0 ; i < len ; ++i){
			// IsKanji `FbNȂ
			if(buf[i] == '/')buf[i] = '\\';
		}
		auto file = ablib::string(g_setting.GetInstallDir()) + buf;
		if(buf[len - 1] == '\\'){
			dirs.push_back(file);
		}
		else {
			if(!::DeleteFile(file.c_str())) {
				if(::GetFileAttributes(file.c_str()) != -1) {
					g_setting.Log(ablib::string::sprintf(_TR("%s̍폜Ɏs"), file.c_str()));
					rv = false;
				}
			}
		}
	}
	tf.Close();
	for(int i = dirs.size() - 1; i >= 0; --i) ::RemoveDirectory(dirs[i].c_str());
	::DeleteFile((ablib::string(g_setting.GetHozonDir()) + _T("filelist\\") + f + _T(".txt")).c_str());
	m_msg += _TR("");m_msg += _T("\r\n");WriteMsg(m_msg);
	m_w32texuninstalledfile.push_back(f);
	return rv;
}

bool Install::GSInstall(const ablib::string &gs){
	m_msg += _TR("Ghostscript̃CXg[");
	m_msg += _T("\r\n");
	g_setting.Log(_TR("Ghostscript̃CXg[Jn"));
	WriteMsg(m_msg);
	if(gs.length() >= 4 && gs.substr(gs.length() - 4) == _T(".exe")){
		m_msg += _TR("CXg[scc");
		ablib::system::Process process;
		ablib::system::Process::ProcessStartInfo s;
		s.Arguments = ablib::string(_T("\"")) + g_setting.GetHozonDir() + gs + _T("\"");
		s.FileName = _T("");
		s.WorkingDirectory = g_setting.GetHozonDir();
		s.RedirectStandardError = false;
		s.RedirectStandardInput = false;
		s.RedirectStandardOutput = false;
		s.ShowState = ablib::system::Process::ProcessStartInfo::show;
		s.CreateNoWindow = false;
		process.StartInfo(s);
		if(!process.Start()){
			g_setting.Log(_TR("CXg[̎sɎs") + ablib::Error::ErrorCodeToStr(ablib::system::GetLastError()));
			g_InstallFiles.SetInstallState(gs,fail);
			g_report.gs = _TR("s");E;
		}else{
			process.WaitForExit();
			g_report.gs = _TR("");
			g_InstallFiles.SetInstallState(gs,success);
			m_msg += _TR("");
			m_msg += _T("\r\n");
			WriteMsg(m_msg);
		}
	}else{
		ablib::string cmd;
		ziptool z(m_appint);
		if(CheckandSetTmp(g_setting.GetHozonDir())){
			m_msg += _TR("ꎞfBNg̕ύXcc");
			m_msg += _T("\r\n");
			WriteMsg(m_msg);
		}
		m_msg += ablib::string::sprintf(_TR("%s𓀁cc"),(g_setting.GetHozonDir() + gs).c_str());
		WriteMsg(m_msg);

	//	ablib::string dir = g_setting.GetHozonDir();
		ablib::string dir = g_setting.GetTmpDir();
		dir += _T("Ghostscript\\");
		File::DeleteFiles(dir.c_str());
		if(!z.DeCompresDlg(GetWindow(),(g_setting.GetHozonDir() + gs).c_str(),dir.c_str())){
			g_setting.Log(ablib::string::sprintf(_TR("%s̉𓀂Ɏs"),(g_setting.GetHozonDir() + gs).c_str()));
			g_InstallFiles.SetInstallState(gs,fail);
			g_report.gs = _TR("s");E;
		}else{
			if(CheckCancel()){g_InstallFiles.SetInstallState(gs,cancel);g_setting.Log(_TR("LZ܂"));return false;}
			m_msg += _TR("");
			m_msg += _T("\r\n");
			m_msg += _TR("setupgs.exescc");
			WriteMsg(m_msg);

			ablib::system::Process::ProcessStartInfo s;
			s.Arguments = _T("\"");
			s.Arguments += dir;
			s.Arguments += _T("setupgs.exe\"");

			ablib::system::Process process;
			s.FileName = _T("");
			s.WorkingDirectory = dir;
			s.RedirectStandardError = false;
			s.RedirectStandardOutput = false;
			s.RedirectStandardInput = false;
			s.ShowState = ablib::system::Process::ProcessStartInfo::show;
			s.CreateNoWindow = false;
			process.StartInfo(s);
			if(!process.Start()){
				g_setting.Log(_TR("setupgs.exe̎sɎs܂") + ablib::Error::ErrorCodeToStr(ablib::system::GetLastError()));
				g_InstallFiles.SetInstallState(gs,fail);
				g_report.gs = _TR("s");E;
			}
			process.WaitForInputIdle();
		
			HWND hwnd = NULL;

			::EnumThreadWindows(process.GetThreadID(),[](HWND hwnd,LPARAM lParam) -> BOOL{
				(*reinterpret_cast<HWND*>(lParam)) = hwnd;
				return FALSE;
			},reinterpret_cast<LPARAM>(&hwnd));

			if(hwnd){
#ifdef UNICODE
				std::wregex reg;
#else
				std::regex reg;
#endif
				reg.assign(_T("Use Windows TrueType fonts for"),std::regex::ECMAScript | std::regex::icase);
				::EnumChildWindows(hwnd,[](HWND hwnd,LPARAM lParam){
#ifdef UNICODE
					std::wregex *reg = reinterpret_cast<std::wregex*>(lParam);;
#else
					std::regex *reg = reinterpret_cast<std::regex*>(lParam);;
#endif
					TCHAR text[1024];
					::GetWindowText(hwnd,text,1023);
					if(std::regex_search(text,*reg)){
						ablib::window::CheckBox(hwnd).SetCheck(true);
						return FALSE;
					}else return TRUE;
				},reinterpret_cast<LPARAM>(&reg));
			}
			process.WaitForExit();
			int errlevel = process.ExitCode();

			if(errlevel != 0){
				g_setting.Log(_TR("setupgs.exe̎sɎs܂"));
				g_InstallFiles.SetInstallState(gs,fail);
				g_report.gs = _TR("s");E;
			}else{
				if(CheckCancel()){g_setting.Log(_TR("LZ܂"));g_InstallFiles.SetInstallState(gs,cancel);return false;}
				File::DeleteFiles(dir.c_str());
				g_report.gs = _TR("");
				m_msg += _TR("");
				m_msg += _T("\r\n");
				g_InstallFiles.SetInstallState(gs,success);
				WriteMsg(m_msg);
			}
		}
	}
	ablib::string path = GetGSDir();
	if(path != _T("")){
		g_path.AddPath(path + _T("bin"));
		g_path.AddPath(path + _T("lib"));
	}else g_setting.Log(_TR("Ghostscript̃CXg[pX擾ɎŝŁCPATH̐ݒs܂"));
	g_setting.Log(_TR("Ghostscript̃CXg[I"));
	WriteMsg(m_msg);
	return true;
}

bool Install::CheckGSInstall(){
#ifdef UNICODE
	std::wregex reg;
#else
	std::regex reg;
#endif
	reg.assign(_T("(AFPL|GNU|GPL|ESP) Ghostscript (gs)?[0-9]*\\.[0-9]*"));
	std::vector<ablib::string> keys;
	if(!Registory::EnumKey(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"),keys))return false;
	for(ablib::string &key : keys){
		if(std::regex_match(key,reg))return true;
	}
	return false;
}

bool Install::GSUnInstall(){
	m_msg += _TR("Ghostscript̃ACXg[cc");
	WriteMsg(m_msg);
	g_setting.Log(_TR("Ghostscript̃ACXg[Jn"));

#ifdef UNICODE
	std::wregex gs,gsfont;
	std::wsmatch match;
#else
	std::regex gs,gsfont;
	std::smatch match;
#endif
	gs.assign(_T("(AFPL|GNU|GPL|ESP) Ghostscript (gs)?([0-9]*\\.[0-9]*)"));
	gsfont.assign(_T("(AFPL|GNU|GPL|ESP) Ghostscript Fonts"));
	std::vector<ablib::string> keys;
	if(!Registory::EnumKey(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"),keys)){E;}
	ablib::string val;
	for(ablib::string &key : keys){
		bool not_font = false;
		ablib::string version = _T("");
		if(std::regex_search(key,match,gs)){
			not_font = true;
			version = match.str(3);
		}
		if(std::regex_match(key,gsfont) || not_font){
			val = _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\");
			val += key;
			ablib::string str;
			if(!Registory::ReadSZ(HKEY_LOCAL_MACHINE,val.c_str(),_T("UninstallString"),str)){
				g_setting.Log(_TR("WXgJ܂ł"));
				E;
			}

			ablib::string path;
			if(not_font){
				path = ExecToPath(str);
				path.erase(path.rfind(_T("\\")));
				if(::GetFileAttributes((path + _T("\\bin\\gswin32.exe")).c_str()) == -1){
					path += _T("\\gs");
					path += version;
					path += _T("\\");
				}
			}


			ablib::system::Process::ProcessStartInfo si;
			si.Arguments = str;si.FileName = _T("");si.WorkingDirectory = g_setting.GetHozonDir();
			si.RedirectStandardError = si.RedirectStandardOutput = si.RedirectStandardInput = false;
			si.CreateNoWindow = false;
			si.ShowState = ablib::system::Process::ProcessStartInfo::show;
			ablib::system::Process process;
			process.StartInfo(si);
			if(!process.Start()){
				g_setting.Log(ablib::string::sprintf(_TR("%s̎sɎs"),str.c_str()) + ablib::Error::ErrorCodeToStr(ablib::system::GetLastError()));
				E;
			}
			process.WaitForExit(500);
			if(process.HasExited()){
				// 9.05ȍ~ƌȂD
				// ACXg[ꎞfBNgɖ{̂쐬ĂsĂ̂ŁC
				// ACXg[g̏I҂ĂʁD
				// ̎qvZX𔭌Ă҂D
				HANDLE snapshot = ::CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
				if(snapshot == INVALID_HANDLE_VALUE){
					g_setting.Log(_TR("GhostscriptACXg[IĎɎsisnapshot̍쐬Ɏsj"));
				}else{
					PROCESSENTRY32 procent;
					procent.dwSize = sizeof(PROCESSENTRY32);
					BOOL b = ::Process32First(snapshot,&procent);
					while(b){
						if(procent.th32ParentProcessID == process.Id()){
							HANDLE handle = ::OpenProcess(PROCESS_ALL_ACCESS,TRUE,procent.th32ProcessID);
							if(handle != NULL){
								::WaitForSingleObject(handle,INFINITE);
								break;
							}
						}
						b = ::Process32Next(snapshot,&procent);
					}
					::CloseHandle(snapshot);
				}
			}else process.WaitForExit();
			if(not_font){
				g_path.DeletePath(path + _T("bin"));
				g_path.DeletePath(path + _T("lib"));
			}
		}
	}
	m_msg += _TR("");
	m_msg += _T("\r\n");
	WriteMsg(m_msg);
	g_setting.Log(_TR("Ghostscript̃ACXg[I"));
	return true;
}

/*
bool Install::GVInstall(const ablib::string &gv){
	ablib::string cmd;
	m_msg += _TR("GSview̃CXg[cc");
	WriteMsg(m_msg);
	g_setting.Log(_TR("GSview̃CXg[Jn"));

	cmd = _T("\"");
	cmd += g_setting.GetHozonDir();
	cmd += gv;
	cmd += _T("\"");
	int el;
	ablib::basic_string<char> dummy;
	if(!Exec(cmd.c_str(),g_setting.GetHozonDir(),el,dummy) || el != 0){
		g_setting.Log(ablib::string::sprintf(_TR("%s̎sɎs"),(g_setting.GetHozonDir() + gv).c_str()));
		g_InstallFiles.SetInstallState(gv,fail);
		g_report.gv = _TR("s");E;
	}else{
		if(CheckCancel())return false;
		g_report.gv = _TR("");
		g_InstallFiles.SetInstallState(gv,success);
		m_msg += _TR("");
		m_msg += _T("\r\n");
	}
	WriteMsg(m_msg);
	g_setting.Log(_TR("GSview̃CXg[I"));
	return true;
}

bool Install::CheckGVInstall(){
#ifdef UNICODE
	std::wregex reg;
#else
	std::regex reg;
#endif
	reg.assign(_T("GSview [0-9]*\\.[0-9]*"));
	std::vector<ablib::string> keys;
	if(!Registory::EnumKey(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"),keys))return false;
	for(ablib::string &key : keys){
		if(std::regex_match(key,reg))return true;
	}
	return false;
}

bool Install::GVUnInstall(){
	m_msg += _TR("GSview̃ACXg[cc");
	WriteMsg(m_msg);
	g_setting.Log(_TR("GSview̃ACXg[Jn"));
#ifdef UNICODE
	std::wregex gv;
#else
	std::regex gv;
#endif
	gv.assign(_T("GSview [0-9]*\\.[0-9]*"));
	std::vector<ablib::string> keys;
	if(!Registory::EnumKey(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"),keys))return false;
	ablib::string val;
	for(ablib::string &key : keys){
		if(std::regex_match(key,gv)){
			val = _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\");
			val += key;
			ablib::string str;
			if(!Registory::ReadSZ(HKEY_LOCAL_MACHINE,val.c_str(),_T("UninstallString"),str)){
				g_setting.Log(_TR("WXgJ܂ł"));
				E;
			}
			ablib::system::Process::ProcessStartInfo si;
			si.Arguments = str.c_str();si.FileName = _T("");si.WorkingDirectory = g_setting.GetHozonDir();
			si.RedirectStandardError = si.RedirectStandardOutput = si.RedirectStandardInput = false;
			si.CreateNoWindow = false;
			si.ShowState = ablib::system::Process::ProcessStartInfo::show;
			ablib::system::Process process;
			process.StartInfo(si);
			if(!process.Start()){
				g_setting.Log(ablib::string::sprintf(_TR("%s̎sɎs"),str.c_str()));
				E;
			}
			process.WaitForExit();
		}
	}
	m_msg += _TR("");
	m_msg += _T("\r\n");
	WriteMsg(m_msg);
	g_setting.Log(_TR("GSview̃ACXg[I"));
	return true;
}
*/

bool Install::DVIOUTInstall(const ablib::string &dviout){
	ablib::string cmd;
	m_msg += _TR("dviout̃CXg[cc");
	WriteMsg(m_msg);
	g_setting.Log(_TR("dviout̃CXg[Jn"));
	ablib::string str;
	// CXg[fBNǧ
	GetDir gd(m_appint);
	str = g_setting.GetInstallDir();
	str += _T("dviout\\");
	if(!gd.Create(GetWindow(),_TR("dvioutCXg[fBNgw肵Ă"),str)){g_report.dviout = _TR("s");E;}
	if(str != _T("") && str[str.length() - 1] != '\\')str += _T("\\");
	g_setting.SetDVIOUTInstallDir(str.c_str());

	// 
	ziptool z(m_appint);
	if(!z.DeCompresDlg(GetWindow(),(g_setting.GetHozonDir() + dviout).c_str(),g_setting.GetDVIOUTInstallDir())){
		g_setting.Log(ablib::string::sprintf(_TR("%s̉𓀂Ɏs"),(g_setting.GetHozonDir() + dviout).c_str()));
		g_report.dviout = _TR("s");E;
		g_InstallFiles.SetInstallState(dviout,fail);
	}else g_report.dviout = _TR("");
	m_msg += _TR("");
	m_msg += _T("\r\n");
	g_InstallFiles.SetInstallState(dviout,success);
	WriteMsg(m_msg);
	g_setting.Log(_TR("dviout̃CXg[I"));
    return true;
}

bool Install::CheckDVIOUTInstall(){
	ablib::string str;
	if(Registory::ReadSZ(HKEY_CURRENT_USER,_T("Software\\SHIMA\\DVIOUT\\para0"),_T("TEXPK"),str)){
        if(str != _T(""))return true;
	}
	if(Registory::ReadSZ(HKEY_CURRENT_USER,_T("Software\\SHIMA\\DVIOUT\\para0"),_T("TEXROOT"),str)){
		if(str != _T(""))return true;
	}
	return false;
}

/*
bool Install::DVIOUTSetting(){
	TCHAR shimapath[] = _T("Software\\SHIMA\\DVIOUT\\para0");
	m_msg += _T("dviout̐ݒcc");
	WriteMsg(m_msg);
	g_setting.Log(_T("dviout̐ݒJn"));

	ablib::string installpar = ablib::string(g_setting.GetDVIOUTInstallDir()) + _T("install.par");
	if(::GetFileAttributes(installpar.c_str()) != 0xFFFFFFFF){
		g_setting.Log(installpar + _T("݂̂Őݒs܂"));
		g_report.dvioutset = _T("sv");
		m_msg += _T("sv\r\n");
		WriteMsg(m_msg);
		g_setting.Log(_T("dviout̐ݒI"));
		return true;
	}
	std::ofstream fp(installpar.c_str());
	if(!fp){
		g_setting.Log(ablib::string(g_setting.GetDVIOUTInstallDir()) + _T("install.paȑ݂Ɏs"));
		g_report.dvioutset = _T("s");
		E;
	}
	fp << _T("Set=!j!k") << std::endl;
	fp << _T("TEXPK=^r\\tfm\\\\^s^tfm;^r\\pk\\\\^s.^dpk;^r\\vf\\\\^s.vf;^r\\ovf\\\\^s.ovf;^r\\tfm\\\\^s.tfm\n") << std::endl;
	fp << _T("TEXROOT=") << 
		g_setting.GetInstallDir() << _T("share\\texmf\\fonts;") <<
		g_setting.GetInstallDir() << _T("share\\texmf-local\\fonts;")  << std::endl;
	fp << _T("gen=\"`") << g_setting.GetInstallDir() << _T("bin\\mktexpk.exe --dpi ^d --bdpi ^D --mag ^M ^s\"") << std::endl;

	ablib::string gsdir = GetGSDir();
	if(gsdir != _T("")){
		ablib::string gsdir2 = gsdir;
		gsdir2.erase(gsdir.length() - 1);
		gsdir2.erase(gsdir2.rfind(_T("\\")) + 1);
		// pX݂̂ɂ܂Ddviout̎ݒ݂D
//		data = gsdir + _T("bin\\gswin32c.exe^-I") + gsdir2 + _T("fonts;") + gsdir + _T("lib;") + gsdir + _T("kanji");
		ablib::string data = gsdir + _T("bin\\gswin32c.exe");
		fp << _T("gsx=\"") << data.c_str() << _T("\"") << std::endl;
	}

//	fp << _T("y=A4P") << std::endl;
//	fp << _T("dpi=300") << std::endl;

	fp.close();

	ablib::system::Process::StartInfo si;
	si.Arg = ablib::string(g_setting.GetDVIOUTInstallDir()) + _T("dviout.exe");
	si.ReadStdErr = si.ReadStdOut = si.WriteStdIn = false;
	si.Window = true;
	si.ShowState = ablib::system::Process::StartInfo::hide;
//	si.ShowState = ablib::system::Process::StartInfo::show;
	si.WorkDir = g_setting.GetDVIOUTInstallDir();

	ablib::system::Process process;
	process.SetStartInfo(si);
	if(!process.Start()){
		g_setting.Log(_T("dviout̋NɎs"));
		g_report.dvioutset = _T("s");
		E;
	}
	::Sleep(500);
	if(!process.WaitForInputIdle(60000)){
		OUTPUTLASTERROR();
		g_setting.Log(_T("dviout̋NɎԂ܂Dݒ肪łĂȂ܂"));
	}
	::Sleep(500);
	DWORD id = process.GetID();
	::EnumWindows(SearchDVIOUTWndProc,reinterpret_cast<LPARAM>(&id));
	if(!process.WaitForExit(10000)){
		::EnumWindows(SearchDVIOUTWndProc,reinterpret_cast<LPARAM>(&id));
		::Sleep(500);
	}
	if(!process.IsExited()){
		OUTPUTLASTERROR();
		g_setting.Log(_T("dvioutI܂Dݒ肪łĂȂ܂"));
		process.Kill();
	}

	if(::CopyFile(
		(ablib::string(g_setting.GetDVIOUTInstallDir()) + _T("GRAPHIC\\LATEX2E\\dviout.def")).c_str(),
		(ablib::string(g_setting.GetInstallDir()) + _T("share\\texmf\\tex\\latex\\graphics\\dviout.def")).c_str(),
		FALSE) == FALSE)g_setting.Log(_T("dviout.def̃Rs[Ɏs"));


	g_report.dvioutset = _T("");
	m_msg += _T("\r\n");
	WriteMsg(m_msg);
	g_setting.Log(_T("dviout̐ݒI"));
	return true;
}
*/
bool Install::DVIOUTSetting(){
	TEXVAR texmf(_T("TEXMFMAIN"));
	TEXVAR texmflocal(_T("TEXMFLOCAL"));
	TCHAR shimapath[] = _T("Software\\SHIMA\\DVIOUT\\para0");
	m_msg += _TR("dviout̐ݒcc");
	WriteMsg(m_msg);
	g_setting.Log(_TR("dviout̐ݒJn"));

	// TEXPK
	ablib::string str;
	if(!Registory::ReadSZ(HKEY_CURRENT_USER,shimapath,_T("TEXPK"),str) || str == _T("")){
		if(!Registory::WriteSZ(HKEY_CURRENT_USER,shimapath,_T("TEXPK"),_T("^r\\tfm\\\\^s^tfm;^r\\pk\\\\^s.^dpk;^r\\vf\\\\^s.vf;^r\\ovf\\\\^s.ovf;^r\\tfm\\\\^s.tfm"))){
			g_setting.Log(_TR("WXgJ܂ł"));
			E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	// fontpX
	if(!Registory::ReadSZ(HKEY_CURRENT_USER,shimapath,_T("TEXROOT"),str) || str == _T("")){
		ablib::string data = texmf.Get() + _T("fonts;");
		data += texmflocal.Get() + _T("fonts");
		if(!Registory::WriteSZ(HKEY_CURRENT_USER,shimapath,_T("TEXROOT"),data.c_str())){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	// mktexpk
	if(!Registory::ReadSZ(HKEY_CURRENT_USER,shimapath,_T("gen"),str) || str == _T("")){
		ablib::string data = _T("`");
		data += g_setting.GetInstallDir();
		data += _T("bin\\mktexpk.exe --dpi ^d --bdpi ^D --mag ^M ^s");
		if(!Registory::WriteSZ(HKEY_CURRENT_USER,shimapath,_T("gen"),data.c_str())){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	// Ghostscript
	if(Registory::ReadSZ(HKEY_CURRENT_USER,shimapath,_T("gsx"),str) || str == _T("")){
		ablib::string gsdir = GetGSDir();
		if(gsdir != _T("")){
			ablib::string gsdir2 = gsdir;
			gsdir2.erase(gsdir.length() - 1);
			gsdir2.erase(gsdir2.rfind(_T("\\")) + 1);
			// pX݂̂ɂ܂Ddviout̎ݒ݂D
//			data = gsdir + _T("bin\\gswin32c.exe^-I") + gsdir2 + _T("fonts;") + gsdir + _T("lib;") + gsdir + _T("kanji");
			ablib::string data = gsdir + _T("bin\\gswin32c.exe");
			if(!Registory::WriteSZ(HKEY_CURRENT_USER,shimapath,_T("gsx"),data.c_str())){
				g_setting.Log(_TR("WXgւ̏ݎs"));
				g_report.dvioutset = _TR("s");E;
			}
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	// TCY
	if(!Registory::ReadSZ(HKEY_CURRENT_USER,shimapath,_T("y"),str) || str == _T("")){
		if(!Registory::WriteSZ(HKEY_CURRENT_USER,shimapath,_T("y"),_T("A4P"))){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	// dpi
	if(Registory::ReadDWORD(HKEY_CURRENT_USER,shimapath,_T("dpi")) == 0){
		if(!Registory::WriteDWORD(HKEY_CURRENT_USER,shimapath,_T("dpi"),0x12c)){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	// ֘AÂ
	if(!Registory::ReadSZ(HKEY_CLASSES_ROOT,_T(".dvi"),_T(""),str) || str == _T("")){
		if(!Registory::WriteSZ(HKEY_CLASSES_ROOT,_T(".dvi"),_T(""),_T("dvifile"))){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	if(!Registory::ReadSZ(HKEY_CLASSES_ROOT,_T("dvifile"),_T(""),str) || str == _T("")){
		if(!Registory::WriteSZ(HKEY_CLASSES_ROOT,_T("dvifile"),_T(""),_T("TeX DVI file"))){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	if(!Registory::ReadSZ(HKEY_CLASSES_ROOT,_T("dvifile\\Defaulticon"),_T(""),str) || str == _T("")){
		ablib::string data = g_setting.GetDVIOUTInstallDir();
		data += _T("dviout.exe,1");
		if(!Registory::WriteSZ(HKEY_CLASSES_ROOT,_T("dvifile\\Defaulticon"),_T(""),data.c_str())){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	if(!Registory::ReadSZ(HKEY_CLASSES_ROOT,_T("dvifile\\Shell\\open\\command"),_T(""),str) || str == _T("")){
		ablib::string data = g_setting.GetDVIOUTInstallDir();
		data += _T("dviout.exe %1");
		if(!Registory::WriteSZ(HKEY_CLASSES_ROOT,_T("dvifile\\Shell\\open\\command"),_T(""),data.c_str())){
			g_setting.Log(_TR("WXgւ̏ݎs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	
	// V[gJbg쐬
	TCHAR todir[4096];
	if(!File::GetProgramFolder(todir)){g_setting.Log(_TR("X^[gj[ptH_܂ł"));E;}
	::lstrcat(todir,_T("dviout\\"));
	CreateDirectoryReflex(todir);
	ablib::string dir = g_setting.GetDVIOUTInstallDir();
	dir.erase(dir.length() - 1);

	ablib::string from = g_setting.GetDVIOUTInstallDir();
	from += _T("dviout.exe");
	ablib::string to = todir;
	to += _T("dviout for Windows.lnk");
	if(!ShortCut::CreateShortCut(from.c_str(),_T(""),dir.c_str(),to.c_str())){
		g_setting.Log(_TR("V[gJbg̍쐬Ɏs"));
		g_report.dvioutset = _TR("s");E;
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	from = g_setting.GetDVIOUTInstallDir();
	from += _T("dviout.hlp");
	to = todir;
	to += _T("Help for dviout.lnk");
	if(::GetFileAttributes(to.c_str()) == -1){
		if(!ShortCut::CreateShortCut(from.c_str(),_T(""),dir.c_str(),to.c_str())){
			g_setting.Log(_TR("V[gJbg̍쐬Ɏs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	from = g_setting.GetDVIOUTInstallDir();
	from += _T("dvioute.hlp");
	to = todir;
	to += _T("Help in English.lnk");
	if(::GetFileAttributes(to.c_str()) == -1){
		if(!ShortCut::CreateShortCut(from.c_str(),_T(""),dir.c_str(),to.c_str())){
			g_setting.Log(_TR("V[gJbg̍쐬Ɏs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	from = g_setting.GetDVIOUTInstallDir();
	from += _T("HYPERTEX\\hyper2.dvi");
	to = todir;
	to += _T("sample dvi file.lnk");
	dir += _T("\\hypertex");
	if(::GetFileAttributes(to.c_str()) == -1){
		if(!ShortCut::CreateShortCut(from.c_str(),_T(""),dir.c_str(),to.c_str())){
			g_setting.Log(_TR("V[gJbg̍쐬Ɏs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	from = g_setting.GetDVIOUTInstallDir();
	from += _T("DOC\\dvioutQA.html");
	to = todir;
	to += _T("Troubles in dviout.lnk");
	dir = g_setting.GetDVIOUTInstallDir();
	dir += _T("DOC");
	if(::GetFileAttributes(to.c_str()) == -1){
		if(!ShortCut::CreateShortCut(from.c_str(),_T(""),dir.c_str(),to.c_str())){
			g_setting.Log(_TR("V[gJbg̍쐬Ɏs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}
	from = g_setting.GetDVIOUTInstallDir();
	from += _T("DOC\\dviouttips.html");
	to = todir;
	to += _T("Troubles in dviout.lnk");
	if(::GetFileAttributes(to.c_str()) == -1){
		if(!ShortCut::CreateShortCut(from.c_str(),_T(""),dir.c_str(),to.c_str())){
			g_setting.Log(_TR("V[gJbg̍쐬Ɏs"));
			g_report.dvioutset = _TR("s");E;
		}
	}
	if(CheckCancel()){g_setting.Log(_TR("LZ܂"));C;}

/* W32TeXɊ܂܂悤ɂȂ̂ŕsvɂȂD
	if(::CopyFile(
		(ablib::string(g_setting.GetDVIOUTInstallDir()) + _T("GRAPHIC\\LATEX2E\\dviout.def")).c_str(),
		(texmf.Get() + _T("tex\\latex\\graphics\\dviout.def")).c_str(),
		FALSE) == FALSE)g_setting.Log(_TR("dviout.def̃Rs[Ɏs: GetLastError = ") + boost::lexical_cast<ablib::string>(::GetLastError()));
*/

	g_report.dvioutset = _TR("");
	m_msg += _TR("");
	m_msg += _T("\r\n");
	WriteMsg(m_msg);
	g_setting.Log(_TR("dviout̐ݒI"));
	return true;
}

/*
BOOL Install::SearchDVIOUTWndProc(HWND hwnd,LPARAM lParam){
	DWORD id = *(reinterpret_cast<DWORD*>(lParam)),targetid;
	::GetWindowThreadProcessId(hwnd,&targetid);
	if(id == targetid){
		::PostMessage(hwnd,WM_CLOSE,0,0);
		return FALSE;
	}else return TRUE;
}
*/

bool Install::DVIOUTUnInstall(){
	m_msg += _TR("dviout̃ACXg[cc");
	WriteMsg(m_msg);
	g_setting.Log(_TR("dviout̃ACXg[Jn"));
	if(!Registory::DeleteKey(HKEY_CURRENT_USER,_T("Software\\SHIMA\\DVIOUT"))){g_setting.Log(_TR("WXg폜Ɏs"));E;}
	if(!Registory::DeleteKey(HKEY_CLASSES_ROOT,_T(".dvi"))){g_setting.Log(_TR("WXg폜Ɏs"));E;}
	if(!Registory::DeleteKey(HKEY_CLASSES_ROOT,_T("dvifile"))){g_setting.Log(_TR("WXg폜Ɏs"));E;}
	TCHAR str[4096];
	if(!File::GetProgramFolder(str)){g_setting.Log(_TR("X^[gj[ptH_܂ł"));E;}
	::lstrcat(str,_T("\\dviout"));
	File::DeleteFiles(str);
//	::DeleteFile((ablib::string(g_setting.GetDVIOUTInstallDir()) + _T("install.par")).c_str());
	OUTPUTLASTERROR();
	m_msg += _TR("");
	m_msg += _T("\r\n");
	WriteMsg(m_msg);
	g_setting.Log(_TR("dviout̃ACXg[I"));
	return true;
}

bool Install::Updatelsr(){
	// KvȂmktexlsrs
	TEXVAR texmf(_T("TEXMFMAIN"));
	if(ablib::system::File::IsExist(texmf.Get() + _T("ls-R"))){
		AddMsg(_TR("ls-RAbvf[gcc"));
		ablib::system::Process::ProcessStartInfo si;
		si.FileName = ablib::string(g_setting.GetInstallDir()) + _T("bin\\mktexlsr.exe");
		si.Arguments = _T("");
		si.WorkingDirectory = g_setting.GetInstallDir();
		si.RedirectStandardOutput = si.RedirectStandardError = true;
		si.RedirectStandardInput = false;
		ablib::system::Process p;
		p.StartInfo(si);
		bool b = p.Start();
		int err_code = 0;
		ablib::string msg = _T("");
		if(b) {
			while(!p.HasExited()) {
				char buf[4096];
				buf[p.Read(buf, 4095)] = '\0';
				msg += ablib::TransCode::FromChar(buf);
			}
			err_code = p.ExitCode();
		}
		if(b && err_code == 0){
			p.WaitForExit();
			g_setting.Log(_TR("mktexlsr̎sɐ"));
			AddMsg(_TR(""));
			AddMsg(_T("\r\n"));
			return true;
		}else{
			ablib::string err_str = _T("");
			if(!b)err_str = _T("Error code = ") + boost::lexical_cast<ablib::string>(ablib::system::GetLastError());
			if(err_code != 0)err_str += _T(", error level = ") + boost::lexical_cast<ablib::string>(err_code);
			if(msg != _T(""))err_str += _T(", ") + msg;
			g_setting.Log(_TR("mktexlsr̎sɎs") + err_str);
			AddMsg(_TR("s"));
			AddMsg(_T("\r\n"));
			return false;
		}
	}else return true;
}
ablib::string Install::ExecToPath(const ablib::string &exec){
	ablib::string target = exec;
	bool dq = false;
	ablib::string::size_type p = 0;
	for(;p < target.length() ; ++p){
		if(target[p] == '"')dq = !dq;
		else if(target[p] == ' ' && !dq){
			ablib::string c;
			c.assign(target,0,p);c.replace(_T("\""),_T(""));
			break;
//			if(::GetFileAttributes(c.c_str()) != -1)break;
//			else if(::GetFileAttributes((c + _T(".exe")).c_str()) != -1)break;
		}
#ifndef UNICODE
		else if(ablib::IsKanji(target[p]))++p;
#endif
	}
	target.erase(p);target.replace(_T("\""),_T(""));
/*
	if(::GetFileAttributes(target.c_str()) == -1){
		target += _T(".exe");
		if(::GetFileAttributes(target.c_str()) == -1)return _T("");
	}
*/
	return target;
}



bool Install::Exec(const TCHAR *cmd,const TCHAR *curdir,int &errlevel,ablib::basic_string<char> &outstr,bool show){
	outstr = "";
	outstr.reserve(10000);
	ablib::system::Process process;
	ablib::system::Process::ProcessStartInfo s;
	s.FileName = _T("");
	s.Arguments = cmd;
	s.WorkingDirectory = curdir;
	// tar.exe͕Wo͂JĂȂƃG[𔭂D
	s.RedirectStandardOutput = true;
	s.RedirectStandardError = true;
	s.RedirectStandardInput = false;
	s.ShowState = show ? ablib::system::Process::ProcessStartInfo::show : ablib::system::Process::ProcessStartInfo::hide;
	s.CreateNoWindow = false;
	process.StartInfo(s);
	DEBUGSTRING(_T("Kakuto3::Install::Exec : %ss"),cmd);
	if(!process.Start()){
		g_setting.Log(ablib::string::sprintf(_TR("%s̎sɎs"),cmd));
		return false;
	}

	// ǂ܂ȂƎsrŎ~܂D
//	FILE *fp = NULL;
//	if(output)fp = ::_tfopen(output,_T("w"));
	char buf[65536];
//	outputstr = "";
	while(!process.HasExited()){
		DWORD size = process.Read(buf,65535);
		if(!size)::Sleep(100);
		buf[size] = '\0';
		outstr += buf;
//		if(fp)::fwrite(buf,sizeof(char),size,fp);
	}
	while(DWORD size = process.Read(buf,65535)){
		buf[size] = '\0';
		outstr += buf;
//		if(fp)::fwrite(buf,sizeof(char),size,fp);
	}
//	if(fp)::fclose(fp);
	errlevel = process.ExitCode();
	return true;
}

ablib::string Install::GetGSDir(){
	if(m_gsdir != _T(""))return m_gsdir;
#ifdef UNICODE
	std::wregex reg;
	std::wsmatch match;
#else
	std::regex reg;
	std::smatch match;
#endif
	reg.assign(_T("(AFPL|GNU|GPL|ESP) Ghostscript (gs)?([0-9]*\\.[0-9]*)"));
	std::vector<ablib::string> keys;
	if(!Registory::EnumKey(HKEY_LOCAL_MACHINE,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall"),keys))return _T("");
	for(ablib::string &key : keys){
		if(std::regex_match(key,match,reg)){
			ablib::string val = _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\");
			val += key;
			ablib::string str;
			if(!Registory::ReadSZ(HKEY_LOCAL_MACHINE,val.c_str(),_T("UninstallString"),str))return _T("");
			bool dq = false;
			ablib::string::size_type p = 0;
			str = ExecToPath(str);
			if(str != _T("")){
				m_gsdir = str;
				m_gsdir.erase(m_gsdir.rfind(_T("\\")));
				m_gsdir += _T("\\");
				if(::GetFileAttributes((m_gsdir + _T("bin\\gswin32.exe")).c_str()) == -1){
					m_gsdir += _T("gs");
					m_gsdir += match.str(3);
					m_gsdir += _T("\\");
				}
				DEBUGSTRING(_T("Install::GetGSDir : GSDir = %s"),m_gsdir.c_str());
				return m_gsdir;
			}
		}
	}
	return m_gsdir;
}

ablib::string Install::GetEnv(const TCHAR *env){
	DWORD size = ::GetEnvironmentVariable(env,NULL,0);
	if(size == 0)return _T("");
	++size;
	TCHAR *s = new TCHAR[size];
	::GetEnvironmentVariable(env,s,size);
	ablib::string rv = s;
	delete[] s;
	return rv;
}

void Install::WriteMsg(const ablib::string &msg){
	GetWindow()->SendMsg(WM_MESSAGE,0,reinterpret_cast<LPARAM>(msg.c_str()));
}

void Install::AddMsg(const ablib::string &msg){
	GetWindow()->SendMsg(WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(msg.c_str()));
}

ablib::string Install::GetMsg(){
	return ablib::window::Edit(GetWindow(),IDC_INSTALL_MSG).GetText();
}

bool Install::CheckandSetTmp(const TCHAR *dir){
	ablib::basic_string<char> dchar = ablib::TransCode::ToChar(dir);
	ablib::string d;
	for(ablib::string::size_type i = 0 ; i < dchar.length() ; ++i){
		if(ablib::IsKanji(dchar[i])){
			d = GetEnv(_T("windir"));
			d += _T("\\temp");
		}
	}
	bool a,b;
	a = CheckandSetTmpEnv(_T("TMP") ,d.c_str());
	b = CheckandSetTmpEnv(_T("TEMP"),d.c_str());
	if(a || b)::CreateDirectoryReflex(d.c_str());
	return (a || b);
}

bool Install::CheckandSetTmpEnv(const TCHAR *env,const TCHAR *dir){
	ablib::basic_string<char> var = ablib::TransCode::ToChar(GetEnv(env));
	for(ablib::string::size_type i = 0 ; i < var.length() ; ++i){
		if(ablib::IsKanji(var[i])){
			::SetEnvironmentVariable(env,dir);
			return true;
		}
	}
	return false;
}

std::map<ablib::string,ablib::string> Install::TEXVAR::m_texvars;


Install::TEXVAR::TEXVAR(const TCHAR *varname){
	if(m_texvars[varname] == _T("")){
		ablib::basic_string<char> out;
		int err;
		if(Install::Exec(
			(ablib::string(g_setting.GetInstallDir()) + _T("bin\\kpsewhich.exe -expand-path=$") + varname).c_str(),
			g_setting.GetInstallDir(),err,out)
		){
			if(err == 0){
				m_var = ablib::TransCode::FromChar(out);
				
#ifdef UNICODE
				std::wregex reg;
#else
				std::regex reg;
#endif
				reg.assign(_T("^ *(.*?)[\\n\\r ]*$"));
				m_var = std::regex_replace(m_var,reg,ablib::string(_T("$1")));
				m_var.replace(_T("/"),_T("\\"));
				if(m_var != _T("")){
					if(m_var[m_var.length() - 1] != '\\')m_var += _T("\\");
					m_texvars[varname] = m_var;
				}
			}
		}
		if(m_var == _T("")){
			m_var = defaultvar(varname);
		}
	}else m_var = m_texvars[varname];
}

ablib::string Install::TEXVAR::defaultvar(const TCHAR *varname){
	if(::lstrcmp(varname,_T("TEXMFMAIN")) == 0)return ablib::string(g_setting.GetInstallDir()) + _T("share\\texmf-dist\\");
	else if(::lstrcmp(varname,_T("TEXMFLOCAL")) == 0)return ablib::string(g_setting.GetInstallDir()) + _T("share\\texmf-local\\");
	else return _T("");
}

