#include "stdafx.h"
#include <vector>
#include <system/FindFile.h>
#include <system/Time.h>
#include <system/File.h>
#include <algorithm>
#include <boost/lexical_cast.hpp>
#include <Oniguruma/RegEx.h>
#include "func.h"
#include "InstallFiles.h"
#include "Setting.h"

extern setting g_setting;

bool InstallFiles::Set(const std::vector<FileData> &w32texnetfiles, const std::vector<FileData> &dvioutnetfiles, const std::vector<FileData> &gsnetfiles/*, const std::vector<FileData> &gvnetfiles*/){
	bool rv = true;
	ablib::string filestateini = ablib::string(g_setting.GetHozonDir()) + _T("filelist\\filestate.ini");

	m_w32tex.clear();
	for(const FileData &j : w32texnetfiles){
		FileInfo fi;
		fi.size = j.size;
		fi.time = j.time;
		ablib::system::Time ftime = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + j.file);
		if(ftime + ablib::system::Time(0,0,1) > j.time)fi.todo_download = false;
		else fi.todo_download = true;
		// filestate.iniǂ
		// dl͂Ƃ肠ŁD
		// [last_download]
		// (filename)=(State)
		// [last_install]
		// (filename)=(State)
		fi.state_download = static_cast<State>(GetIniInt(filestateini,_T("last_download"),j.file));
		fi.state_install = static_cast<State>(GetIniInt(filestateini,_T("last_install"),j.file));
		if(g_setting.IsUseNetwork()){
			if(fi.state_download == success && fi.state_install != success){
				g_setting.Log(ablib::string::sprintf(_T("%s was downloaded but not installed"), j.file));
				fi.todo_install = true;rv = false;
			}else fi.todo_install = fi.todo_download;
		}else{
			fi.todo_install = ablib::system::File::IsExist(g_setting.GetHozonDir() + j.file);
		}
		m_w32tex[j.file] = fi;
	}

	//W32TeXȊO̓_E[h/CXg[t@CTdɑIԁD
	struct{const std::vector<FileData> &from;std::map<ablib::string,FileInfo> &to;} filess[] = {
		{dvioutnetfiles,m_dviout},{gsnetfiles,m_gs}/*,{gvnetfiles,m_gv}*/
	};
	for(int i = 0 ; i < /*3*/2 ; ++i){
		filess[i].to.clear();
		int max = GetLatest(filess[i].from);
		for(std::vector<FileData>::size_type j = 0 ; j < filess[i].from.size() ; ++j){
			FileInfo fi;
			if(max == j){
				ablib::system::Time ftime = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + filess[i].from[j].file);
				if(ftime + ablib::system::Time(0,0,1) > filess[i].from[j].time)fi.todo_download = false;
				else fi.todo_download = true;
				// filestate.iniǂ
				// dl͂Ƃ肠ŁD
				// [last_download]
				// (filename)=(State)
				// [last_install]
				// (filename)=(State)
				fi.state_download = static_cast<State>(GetIniInt(filestateini,_T("last_download"),filess[i].from[j].file));
				fi.state_install = static_cast<State>(GetIniInt(filestateini,_T("last_install"),filess[i].from[j].file));
				if(g_setting.IsUseNetwork()){
					if(fi.state_download == success && fi.state_install != success){
						g_setting.Log(ablib::string::sprintf(_T("%s was downloaded but not installed"), filess[i].from[j].file));
						// _E[h悤ύX
						fi.todo_download = true;
						fi.todo_install = true;
					}else fi.todo_install = fi.todo_download;
				}else{
					fi.todo_install = ablib::system::File::IsExist(g_setting.GetHozonDir() + filess[i].from[j].file);
				}
			}else{
				fi.todo_download = false;
				fi.todo_install = false;
				fi.state_download = static_cast<State>(GetIniInt(filestateini,_T("last_download"),filess[i].from[j].file));
				fi.state_install = static_cast<State>(GetIniInt(filestateini,_T("last_install"),filess[i].from[j].file));
			}
			fi.time = filess[i].from[j].time;
			fi.size = filess[i].from[j].size;
			filess[i].to[filess[i].from[j].file] = fi;
		}
	}
	return rv;
}

bool InstallFiles::SetDownload(const ablib::string &f,bool check){
	std::map<ablib::string,FileInfo>::iterator ite;
	if((ite = m_w32tex.find(f))	!= m_w32tex.end())	{ite->second.todo_download = check;return true;}
	if((ite = m_dviout.find(f))	!= m_dviout.end())	{ite->second.todo_download = check;return true;}
	if((ite = m_gs.find(f))		!= m_gs.end())		{ite->second.todo_download = check;return true;}
//	if((ite = m_gv.find(f))		!= m_gv.end())		{ite->second.todo_download = check;return true;}
	return false;
}

bool InstallFiles::SetDownloadState(const ablib::string &f,State state){
	std::map<ablib::string,FileInfo>::iterator ite;
	if((ite = m_w32tex.find(f)) != m_w32tex.end()){
		ite->second.state_download = state;
		if(state == success)ite->second.state_install = not_done;
		return true;
	}
	if((ite = m_dviout.find(f)) != m_dviout.end()){
		ite->second.state_download = state;
		if(state == success)ite->second.state_install = not_done;
		return true;
	}
	if((ite = m_gs.find(f)) != m_gs.end()){
		ite->second.state_download = state;
		if(state == success)ite->second.state_install = not_done;
		return true;
	}
	/*
	if((ite = m_gv.find(f)) != m_gv.end()){
		ite->second.state_download = state;
		if(state == success)ite->second.state_install = not_done;
		return true;
	}
	*/
	return false;
}

bool InstallFiles::SetInstall(const ablib::string &f,bool check){
	std::map<ablib::string,FileInfo>::iterator ite;
	if((ite = m_w32tex.find(f))	!= m_w32tex.end())	{ite->second.todo_install = check;return true;}
	if((ite = m_dviout.find(f))	!= m_dviout.end())	{ite->second.todo_install = check;return true;}
	if((ite = m_gs.find(f))		!= m_gs.end())		{ite->second.todo_install = check;return true;}
//	if((ite = m_gv.find(f))		!= m_gv.end())		{ite->second.todo_install = check;return true;}
	return false;
}

bool InstallFiles::SetInstallState(const ablib::string &f,State state){
	std::map<ablib::string,FileInfo>::iterator ite;
	if((ite = m_w32tex.find(f))	!= m_w32tex.end())	{ite->second.state_install = state;return true;}
	if((ite = m_dviout.find(f))	!= m_dviout.end())	{ite->second.state_install = state;return true;}
	if((ite = m_gs.find(f))		!= m_gs.end())		{ite->second.state_install = state;return true;}
//	if((ite = m_gv.find(f))		!= m_gv.end())		{ite->second.state_install = state;return true;}
	return false;
}

int InstallFiles::GetLatest(const std::vector<FileData> &files) const{
	if(files.size() == 0)return 0;
	Oniguruma::RegEx reg;
	reg.Compile(_T("[0-9]+"));
	std::vector<size_type> version;
	for(const FileData &i : files){
		if(!reg.Match(i.file.c_str()))version.push_back(0);
		else version.push_back(boost::lexical_cast<int>(reg.GetMatchStr()));
	}
	std::vector<size_type>::iterator max = std::max_element(version.begin(),version.end());
	if(max == version.end())return 0;
	else return max - version.begin();
}

int InstallFiles::GetIniInt(const ablib::string &file, const ablib::string &sec, const ablib::string &key) const{
	return ::GetPrivateProfileInt(sec.c_str(),key.c_str(),0,file.c_str());
}

void InstallFiles::Save(){
	::CreateDirectoryReflex((ablib::string(g_setting.GetHozonDir()) + _T("filelist\\")).c_str());
	ablib::string filestateini = ablib::string(g_setting.GetHozonDir()) + _T("filelist\\filestate.ini");
	if(!m_w32tex.empty() && !m_dviout.empty() && !m_gs.empty() && !m_gv.empty())::DeleteFile(filestateini.c_str());

	struct{const Filelist &target;} filess[] = {
		{m_w32tex},{m_dviout},{m_gs}/*,{m_gv}*/
	};
	for(int i = 0 ; i < 3 ; ++i){
		for(const Filelist::value_type &ite : filess[i].target){
			::WritePrivateProfileString(_T("last_download"),ite.first.c_str(),boost::lexical_cast<ablib::string>(static_cast<int>(ite.second.state_download)).c_str(),filestateini.c_str());
			::WritePrivateProfileString(_T("last_install"), ite.first.c_str(),boost::lexical_cast<ablib::string>(static_cast<int>(ite.second.state_install)).c_str() ,filestateini.c_str());
		}
	}
}
