#include "stdafx.h"
#include "resource.h"
#include <window/dialog.h>
#include <boost/lexical_cast.hpp>
#include <ablib/IsKanji.h>
#include <system/Power.h>
#include <system/File.h>
#include "MainDlg.h"
#include "ChangeLangDlg.h"
#include "ExtTeXSet.h"
#include "setting.h"
#include "file.h"
#include "texinfo.h"
#include "download.h"
#include "ziptool.h"
#include "Install.h"
#include "ExtTeX.h"
#include "Path.h"
#include "InstallFiles.h"
#include "HtmlHelp.h"
#include "Plugin.h"

extern InstallFiles g_InstallFiles;
extern setting g_setting;
extern Path g_path;
extern Plugin g_plugin;


struct Report {
	ablib::string tex;
	ablib::string dviout;
	ablib::string dvioutset;
	ablib::string gs;
	//ablib::string gv;
	ablib::string gsset;
	ablib::string envset;
	ablib::string plugin;
}g_report;

MainDlg::MainDlg() : BaseWizard(ablib::system::Translation::GetResourceHandle()),
	m_dlgprop0(IDD_DIALOG0),m_dlgprop1(IDD_DIALOG1),m_dlgprop2(IDD_DIALOG2),
	m_dlgprop3(IDD_DIALOG3),m_dlgprop4(IDD_DIALOG4),
	m_pluginprop(IDD_PLUGIN),m_otherinfoprop(IDD_OTHERSOFTWARE){
	m_dlgprop0.SetParent(this);
	m_dlgprop2.SetParent(this);
	m_dlgprop3.SetParent(this);
	m_dlgprop4.SetParent(this);
	m_pluginprop.SetParent(this);
	m_otherinfoprop.SetParent(this);

	AddSheet(&m_dlgprop0);
	AddSheet(&m_dlgprop1);
	AddSheet(&m_dlgprop2);
	AddSheet(&m_pluginprop);
	AddSheet(&m_dlgprop3);
	AddSheet(&m_otherinfoprop);
	AddSheet(&m_dlgprop4);
}


int MainDlg::Create(){
	m_rv = 0;
	BaseWizard::CreateWizard(NULL,_TR("TeX̃CXg["));
	return m_rv;
}

bool MainDlg::DlgProp0::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::string msg = _TR("WindowspTeX̊{Iȃ\tgEFAQłȉ_E[hCXg[܂D\n\npɂW32TeX\ndviout for Windows\nGhostscript\n");
	msg.replace(_T("\n"),_T("\r\n"));
	for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
		msg += g_plugin.SoftName(i);
		msg += _T("\r\n");
	}
	ablib::window::StaticText(wnd,IDC_MSG).SetText(msg);
	return true;
}

bool MainDlg::DlgProp1::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::Combo combo_url(wnd,IDC_COMBO_URL);
//	TCHAR **url = g_url;
	for(const ablib::string &i : g_setting.GetTeXURLlist()){
		combo_url.AddString(i);
	}
//	do combo_url.AddString(*url);while(*(++url));
    if(!g_setting.IsTeXUrlList()){
		ablib::window::CheckBox(wnd,IDC_ISURLLIST).SetCheck(true);
		combo_url.Enabled(false);
		ablib::window::Edit(wnd,IDC_EDIT_URL).SetText(g_setting.GetTeXUrl());
		combo_url.SetCurSel(0);
	}else{
		ablib::window::Edit(wnd,IDC_EDIT_URL).SetReadOnly(true);
		int num = combo_url.GetCount();
		for(int i = 0 ; i < num ; ++i){
			ablib::string text = combo_url.GetText(i);
			if(text == g_setting.GetTeXUrl()){
				combo_url.SetCurSel(i);
				break;
			}
		}
	}
	ablib::window::Edit(wnd,IDC_HOZON).SetText(g_setting.GetHozonDirRaw());
	ablib::window::Edit(wnd,IDC_INSTALL).SetText(g_setting.GetInstallDir());
	ablib::window::Edit(wnd,IDC_PROXY).SetText(g_setting.GetProxy());
	if(g_setting.GetPortNum())ablib::window::Edit(wnd,IDC_PORT).SetText(boost::lexical_cast<ablib::string>(g_setting.GetPortNum()));
	else ablib::window::Edit(wnd,IDC_PORT).SetText(_T(""));
	ablib::window::CheckBox(wnd,IDC_TEXUPDATEPATH).SetCheck(g_setting.IsTeXUpdatePath());
	ablib::window::CheckBox(wnd,IDC_CHECKDELCACHE).SetCheck(g_setting.IsDeleteCache());
	ablib::window::CheckBox(wnd,IDC_USENETWORK).SetCheck(!g_setting.IsUseNetwork());
	if(!g_setting.IsUseNetwork()){
		ablib::window::List(wnd,IDC_COMBO_URL).Enabled(false);
		ablib::window::CheckBox(wnd,IDC_ISURLLIST).Enabled(false);
		ablib::window::Edit(wnd,IDC_EDIT_URL).SetReadOnly(true);
		ablib::window::Edit(wnd,IDC_PROXY).SetReadOnly(true);
		ablib::window::Edit(wnd,IDC_PORT).SetReadOnly(true);
		ablib::window::CheckBox(wnd,IDC_CHECKDELCACHE).Enabled(false);
	}
	return true;
}

bool MainDlg::DlgProp0::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_CHANGELANG:
	{
		ChangeLangDlg cld(ablib::system::Translation::GetResourceHandle());
		ablib::system::Translation::LangInfo li = cld.Show(wnd);
		if(li.name != _T("") && li.id != ablib::system::Translation::GetLanguage()){
			ablib::system::Translation::SetLanguage(li.id);
			m_parent->m_rv = CHANGE_LANGUAGE;
			m_parent->GetWindow()->Destroy();
		}
		return true;
	}
	default:
		return false;
	}
}

LPCTSTR MainDlg::DlgProp1::OnWizNext(ablib::window::Dialog *wnd){
	ablib::basic_string<char> textc;
	textc = ablib::TransCode::ToChar(ablib::window::Edit(wnd,IDC_HOZON).GetText());
	for(ablib::string::size_type i = 0 ; i < textc.length() ; ++i){
		if(textc[i] == ' ' || ablib::IsKanji(textc[i])){
			wnd->MsgBox(
				_TR("ۑfBNgɋ󔒂܂͑Spi{̕j܂܂Ă܂Dݒ肵ȂĂ"),
				_T("AbTeXinst"));
			return MAKEINTRESOURCE(-1);
		}
	}
	textc = ablib::TransCode::ToChar(ablib::window::Edit(wnd,IDC_INSTALL).GetText());
	for(ablib::string::size_type i = 0 ; i < textc.length() ; ++i){
		if(textc[i] == ' ' || ablib::IsKanji(textc[i])){
			wnd->MsgBox(
				_TR("CXg[fBNgɋ󔒂܂͑Spi{̕j܂܂Ă܂Dݒ肵ȂĂ"),
				_T("AbTeXinst"));
			return MAKEINTRESOURCE(-1);
		}
	}

	ablib::string text;
	text = ablib::window::Edit(wnd,IDC_HOZON).GetText();
	g_setting.SetHozonDir(text.c_str());
	text = ablib::window::Edit(wnd,IDC_INSTALL).GetText();
	g_setting.SetInstallDir(text.c_str());
	text = ablib::window::Edit(wnd,IDC_PROXY).GetText();
	g_setting.SetProxy(text.c_str());
	text = ablib::window::Edit(wnd,IDC_PORT).GetText();
	try{g_setting.SetPortNum(boost::lexical_cast<int>(text));}catch(boost::bad_lexical_cast e){g_setting.SetPortNum(0);}
	if(ablib::window::CheckBox(wnd,IDC_ISURLLIST).GetCheck()){
		text = ablib::window::Edit(wnd,IDC_EDIT_URL).GetText();
		g_setting.SetIsTeXUrlList(false);
	}else{
		text = ablib::window::Combo(wnd,IDC_COMBO_URL).GetText();
		g_setting.SetIsTeXUrlList(true);
	}
	g_setting.SetIsTeXUpdatePath(ablib::window::CheckBox(wnd,IDC_TEXUPDATEPATH).GetCheck());
	g_setting.SetTeXUrl(text.c_str());
	g_setting.SetIsDeleteCache(ablib::window::CheckBox(wnd,IDC_CHECKDELCACHE).GetCheck());
	g_setting.SetIsUseNetwork(!ablib::window::CheckBox(wnd,IDC_USENETWORK).GetCheck());
	return 0;
}

bool MainDlg::DlgProp1::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	ablib::string text;
	switch(id){
	case IDC_HOZON_SANSYO:
		if(ablib::window::CommonDlg(wnd).SelectDir(text,_TR("ۑfBNgIł"),_T("AbTeXinst.exe"))){
			ablib::window::Edit(wnd,IDC_HOZON).SetText(text);
			return true;
		}else return false;
	case IDC_INSTALL_SANSYO:
		if(ablib::window::CommonDlg(wnd).SelectDir(text,_TR("CXg[fBNgIł"),_T("AbTeXinst.exe"))){
			ablib::window::Edit(wnd,IDC_INSTALL).SetText(text);
			return true;
		}else return false;
	case IDC_W32TEXEXTSET:
	{
		ExtTeXSet ets(ablib::system::Translation::GetResourceHandle());
		ets.Create(wnd);
	}
	case IDC_ISURLLIST:
		if(ablib::window::CheckBox(wnd,IDC_ISURLLIST).GetCheck()){
			ablib::window::Combo(wnd,IDC_COMBO_URL).Enabled(false);
			ablib::window::Edit(wnd,IDC_EDIT_URL).SetReadOnly(false);
		}else{
			ablib::window::Combo(wnd,IDC_COMBO_URL).Enabled(true);
			ablib::window::Edit(wnd,IDC_EDIT_URL).SetReadOnly(true);
		}
		return true;
	case IDC_USENETWORK:
		if(ablib::window::CheckBox(wnd,IDC_USENETWORK).GetCheck()){
			ablib::window::List(wnd,IDC_COMBO_URL).Enabled(false);
			ablib::window::CheckBox(wnd,IDC_ISURLLIST).Enabled(false);
			ablib::window::Edit(wnd,IDC_EDIT_URL).SetReadOnly(true);
			ablib::window::Edit(wnd,IDC_PROXY).SetReadOnly(true);
			ablib::window::Edit(wnd,IDC_PORT).SetReadOnly(true);
			ablib::window::CheckBox(wnd,IDC_CHECKDELCACHE).Enabled(false);
		}else{
			ablib::window::CheckBox(wnd,IDC_ISURLLIST).Enabled(true);
			ablib::window::Edit(wnd,IDC_PROXY).SetReadOnly(false);
			ablib::window::Edit(wnd,IDC_PORT).SetReadOnly(false);
			ablib::window::CheckBox(wnd,IDC_CHECKDELCACHE).Enabled(true);
			if(ablib::window::CheckBox(wnd,IDC_ISURLLIST).GetCheck()){
				ablib::window::Edit(wnd,IDC_EDIT_URL).SetReadOnly(false);
			}else{
				ablib::window::Combo(wnd,IDC_COMBO_URL).Enabled(true);
			}
		}
		return true;
	default:
		return false;
	}
}

bool MainDlg::DlgProp2::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::Combo combo_dviout(wnd,IDC_COMBO_DVIOUTURL);
	for(const ablib::string &url : g_setting.GetDVIOUTURLlist()){combo_dviout.AddString(url);}
//	TCHAR **url = g_dviouturl;
//	do combo_dviout.AddString(*url);while(*(++url));
	if(!g_setting.IsDVIOUTUrlList()){
		ablib::window::CheckBox(wnd,IDC_ISDVIOUTURLLIST).SetCheck(true);
		combo_dviout.Enabled(false);
		combo_dviout.SetCurSel(0);
		ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).SetText(g_setting.GetDVIOUTUrl());
	}else{
		ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).SetReadOnly(true);
		int num = combo_dviout.GetCount();
		for(int i = 0 ; i < num ; ++i){
			ablib::string text = combo_dviout.GetText(i);
			if(text == g_setting.GetDVIOUTUrl()){
				combo_dviout.SetCurSel(i);
				break;
			}
		}
	}

	ablib::window::Combo combo_gs(wnd,IDC_COMBO_GSURL);
	for(const ablib::string &url : g_setting.GetGSURLlist()){combo_gs.AddString(url);}
//	url = g_gsurl;
//	do combo_gs.AddString(*url);while(*(++url));
	if(!g_setting.IsGSUrlList()){
		ablib::window::CheckBox(wnd,IDC_ISGSURLLIST).SetCheck(true);
		combo_gs.Enabled(false);
		combo_gs.SetCurSel(0);
		ablib::window::Edit(wnd,IDC_EDIT_GSURL).SetText(g_setting.GetGSUrl());
	}else{
		ablib::window::Edit(wnd,IDC_EDIT_GSURL).SetReadOnly(true);
		int num = combo_gs.GetCount();
		for(int i = 0 ; i < num ; ++i){
			ablib::string text = combo_gs.GetText(i);
			if(text == g_setting.GetGSUrl()){
				combo_gs.SetCurSel(i);
				break;
			}
		}
	}

/*
	ablib::window::Combo combo_gv(wnd,IDC_COMBO_GVURL);
//	url = g_gvurl;
//	do combo_gv.AddString(*url);while(*(++url));
	for(const ablib::string &url : g_setting.GetGVURLlist()){combo_gv.AddString(url);}
	if(!g_setting.IsGVUrlList()){
		ablib::window::CheckBox(wnd,IDC_ISGVURLLIST).SetCheck(true);
		combo_gv.Enabled(false);
		combo_gv.SetCurSel(false);
		ablib::window::Edit(wnd,IDC_EDIT_GVURL).SetText(g_setting.GetGVUrl());
	}else{
		ablib::window::Edit(wnd,IDC_EDIT_GVURL).SetReadOnly(true);
		int num = combo_gv.GetCount();
		for(int i = 0 ; i < num ; ++i){
			ablib::string text = combo_gv.GetText(i);
			if(text == g_setting.GetGVUrl()){
				combo_gv.SetCurSel(i);
				break;
			}
		}
	}
*/
	return true;
}

LPCTSTR MainDlg::DlgProp2::OnSetActive(ablib::window::Dialog *wnd){
	if(g_setting.IsUseNetwork()){
		if(ablib::window::CheckBox(wnd,IDC_ISDVIOUTURLLIST).GetCheck()){
			ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).SetReadOnly(false);
		}else{
			ablib::window::Combo(wnd,IDC_COMBO_DVIOUTURL).Enabled(true);
		}
		ablib::window::CheckBox(wnd,IDC_ISDVIOUTURLLIST).Enabled(true);

		if(ablib::window::CheckBox(wnd,IDC_ISGSURLLIST).GetCheck()){
			ablib::window::Edit(wnd,IDC_EDIT_GSURL).SetReadOnly(false);
		}else{
			ablib::window::Combo(wnd,IDC_COMBO_GSURL).Enabled(true);
		}
		ablib::window::CheckBox(wnd,IDC_ISGSURLLIST).Enabled(true);

		/*
		if(ablib::window::CheckBox(wnd,IDC_ISGVURLLIST).GetCheck()){
			ablib::window::Edit(wnd,IDC_EDIT_GVURL).SetReadOnly(false);
		}else{
			ablib::window::Combo(wnd,IDC_COMBO_GVURL).Enabled(true);
		}
		ablib::window::CheckBox(wnd,IDC_ISGVURLLIST).Enabled(true);
		*/
	}else{
		ablib::window::Combo(wnd,IDC_COMBO_DVIOUTURL).Enabled(false);
		ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).SetReadOnly(true);
		ablib::window::CheckBox(wnd,IDC_ISDVIOUTURLLIST).Enabled(false);

		ablib::window::Combo(wnd,IDC_COMBO_GSURL).Enabled(false);
		ablib::window::Edit(wnd,IDC_EDIT_GSURL).SetReadOnly(true);
		ablib::window::CheckBox(wnd,IDC_ISGSURLLIST).Enabled(false);

		/*
		ablib::window::Combo(wnd,IDC_COMBO_GVURL).Enabled(false);
		ablib::window::Edit(wnd,IDC_EDIT_GVURL).SetReadOnly(true);
		ablib::window::CheckBox(wnd,IDC_ISGVURLLIST).Enabled(false);
		*/
	}
	return 0;
}



bool MainDlg::DlgProp2::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_ISDVIOUTURLLIST:
		if(ablib::window::CheckBox(wnd,IDC_ISDVIOUTURLLIST).GetCheck()){
			ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).SetReadOnly(false);
			ablib::window::Combo(wnd,IDC_COMBO_DVIOUTURL).Enabled(false);
		}else{
			ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).SetReadOnly(true);
			ablib::window::Combo(wnd,IDC_COMBO_DVIOUTURL).Enabled(true);
		}
		return true;
	case IDC_ISGSURLLIST:
		if(ablib::window::CheckBox(wnd,IDC_ISGSURLLIST).GetCheck()){
			ablib::window::Edit(wnd,IDC_EDIT_GSURL).SetReadOnly(false);
			ablib::window::Combo(wnd,IDC_COMBO_GSURL).Enabled(false);
		}else{
			ablib::window::Edit(wnd,IDC_EDIT_GSURL).SetReadOnly(true);
			ablib::window::Combo(wnd,IDC_COMBO_GSURL).Enabled(true);
		}
		return true;
	/*
	case IDC_ISGVURLLIST:
		if(ablib::window::CheckBox(wnd,IDC_ISGVURLLIST).GetCheck()){
			ablib::window::Edit(wnd,IDC_EDIT_GVURL).SetReadOnly(false);
			ablib::window::Combo(wnd,IDC_COMBO_GVURL).Enabled(false);
		}else{
			ablib::window::Edit(wnd,IDC_EDIT_GVURL).SetReadOnly(true);
			ablib::window::Combo(wnd,IDC_COMBO_GVURL).Enabled(true);
		}
		return true;
	*/
	default:
		return false;
	}
}

LPCTSTR MainDlg::DlgProp2::OnWizNext(ablib::window::Dialog *wnd){
	ablib::string text;
	if(ablib::window::CheckBox(wnd,IDC_ISDVIOUTURLLIST).GetCheck()){
		text = ablib::window::Edit(wnd,IDC_EDIT_DVIOUTURL).GetText();
		g_setting.SetIsDVIOUTUrlList(false);
	}else{
		text = ablib::window::Combo(wnd,IDC_COMBO_DVIOUTURL).GetText();
		g_setting.SetIsDVIOUTUrlList(true);
	}
	g_setting.SetDVIOUTUrl(text.c_str());

	if(ablib::window::CheckBox(wnd,IDC_ISGSURLLIST).GetCheck()){
		text = ablib::window::Edit(wnd,IDC_EDIT_GSURL).GetText();
		g_setting.SetIsGSUrlList(false);
	}else{
		text = ablib::window::Combo(wnd,IDC_COMBO_GSURL).GetText();
		g_setting.SetIsGSUrlList(true);
	}
	g_setting.SetGSUrl(text.c_str());

	/*
	if(ablib::window::CheckBox(wnd,IDC_ISGVURLLIST).GetCheck()){
		text = ablib::window::Edit(wnd,IDC_EDIT_GVURL).GetText();
		g_setting.SetIsGVUrlList(false);
	}else{
		text = ablib::window::Combo(wnd,IDC_COMBO_GVURL).GetText();
		g_setting.SetIsGVUrlList(true);
	}
	g_setting.SetGVUrl(text.c_str());
	*/

	return 0;
}

bool MainDlg::PluginProp::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::ListView list(wnd,IDC_PLUGINLIST);
	list.EnableFullRowSelect();
	std::vector<ablib::window::ListView::ColumnData> cdata;
	cdata.push_back(ablib::window::ListView::ColumnData(150,_TR("\tg")));
	cdata.push_back(ablib::window::ListView::ColumnData(390,_TR("")));
	list.SetColumn(cdata);
	for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
		std::vector<ablib::string> data;
		if(g_plugin.Sets(i)){
			data.push_back(g_plugin.SoftName(i));
			data.push_back(g_plugin.Info(i));
			list.AddItem(data);
		}
	}
	return true;
}

LPCTSTR MainDlg::PluginProp::OnSetActive(ablib::window::Dialog *wnd){
	for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
		if(g_plugin.Sets(i))return 0;
	}

	if(IsPreviousID(IDD_DIALOG2)){
		SetPreviousID();
		return MAKEINTRESOURCE(IDD_DIALOG3);
	}else{
		SetPreviousID();
		return MAKEINTRESOURCE(IDD_DIALOG2);
	}
}

INT_PTR MainDlg::PluginProp::OnOtherMessage(ablib::window::Dialog *wnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	switch(uMsg){
	case WM_NOTIFY:
	{
		LPNMHDR lpnmhdr = reinterpret_cast<LPNMHDR>(lParam);
		if(lpnmhdr->idFrom != IDC_PLUGINLIST)return FALSE;
		switch(lpnmhdr->code){
		case NM_DBLCLK:
		{
			ablib::window::ListView list(wnd,IDC_PLUGINLIST);
			int index = list.GetCurSel();
			if(index < 0)return FALSE;
			for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
				if(g_plugin.Sets(i))--index;
				if(index == -1){
					g_plugin.Set(wnd->GetParent()->GetHWND(),i);
					break;
				}
			}
			return TRUE;
		}
		default:
			return ::DefWindowProc(wnd->GetHWND(),uMsg,wParam,lParam);
		}
	}
	default:
		return FALSE;
	}
}


bool MainDlg::DlgProp3::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::ListView listtex(wnd,IDC_TEXINFO);
	std::vector<ablib::window::ListView::ColumnData> data;
	data.push_back(ablib::window::ListView::ColumnData(163,_TR("t@C")));
	data.push_back(ablib::window::ListView::ColumnData(50,_TR("")));
	data.push_back(ablib::window::ListView::ColumnData(60,_TR("TCY")));
	listtex.SetColumn(data);
	listtex.EnableCheckBox();

	ablib::window::ListView listdvi(wnd,IDC_DVIOUTINFO);
	data[0].width = 135;
	listdvi.SetColumn(data);
	listdvi.EnableCheckBox();

	ablib::window::ListView listgs(wnd,IDC_GSINFO);
	listgs.SetColumn(data);
	listgs.EnableCheckBox();

	/*
	ablib::window::ListView listgv(wnd,IDC_GVINFO);
	listgv.SetColumn(data);
	listgv.EnableCheckBox();
	*/
	return true;
}

LPCTSTR MainDlg::DlgProp3::OnSetActive(ablib::window::Dialog *wnd){
	if(g_setting.IsUseNetwork()){
		ablib::window::StaticText(wnd,IDC_MSG).SetText(_TR("_E[hCXg[t@CIł"));
	}else{
		ablib::window::StaticText(wnd,IDC_MSG).SetText(_TR("CXg[t@CIł"));
	}
	
	if(IsPreviousID(IDD_PLUGIN)){
		TeXInfo ti(ablib::system::Translation::GetResourceHandle());
		switch(ti.GetInfo(wnd->GetParent(),m_parent->m_dlgprop3.GetWindow())){
		case 0:
		{
			// Xgr[ɐݒ
			struct{const std::map<ablib::string,InstallFiles::FileInfo> &files;int id;} targets[] = {
				{g_InstallFiles.GetW32TeXFileInfo(),IDC_TEXINFO},
				{g_InstallFiles.GetdvioutFileInfo(),IDC_DVIOUTINFO},
				{g_InstallFiles.GetGSFileInfo(),IDC_GSINFO},
//				{g_InstallFiles.GetGVFileInfo(),IDC_GVINFO}
			};
			for(int i = 0 ; i < /*4*/3 ; ++i){
				ablib::window::ListView list(wnd,targets[i].id);
				list.DeleteAllItems();
				std::vector<ablib::string> push;push.resize(3);

				for(std::map<ablib::string,InstallFiles::FileInfo>::const_iterator ite = targets[i].files.begin() ; ite != targets[i].files.end() ; ++ite){
					push[0] = ite->first;
					bool check;
					if(g_setting.IsUseNetwork()){
						if(::GetFileAttributes((g_setting.GetHozonDir() + ite->first).c_str()) == -1){
							push[1] = _TR("");
						}else{
							// lbg[N̎̎擾ɎsĂꍇ͂ǂ邩H
							ablib::system::Time ntime = ite->second.time;
							ablib::system::Time ltime = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + ite->first);
							ltime += ablib::system::Time(0,0,1);
							if(ltime > ntime)push[1] = _TR("ŐV");
							else push[1] = _TR("Â");
						}
						check = ite->second.todo_download;
					}else{
						if(::GetFileAttributes((g_setting.GetHozonDir() + ite->first).c_str()) == -1)push[1] = _TR("");
						else push[1] = _TR("");
						check = ite->second.todo_install;
					}
					if(ite->second.size < 1024)push[2] = boost::lexical_cast<ablib::string>(ite->second.size) + _T("B");
					else if(ite->second.size < 1024*1023)push[2] = boost::lexical_cast<ablib::string>(ite->second.size/1024) + _T("KB");
					else{
						int kbyte = ite->second.size / 1024;
						int mbyte = kbyte / 1024;
						kbyte = kbyte - mbyte * 1024;
						kbyte = kbyte / 100;
						// 1024 / 100 != 10肿Ɩ邱ƂD
 						if(kbyte == 10){++mbyte;kbyte = 0;}
						push[2] = boost::lexical_cast<ablib::string>(mbyte) + _T(".") + boost::lexical_cast<ablib::string>(kbyte) + _T("MB");
					}
					list.AddItem(push,check);
				}
			}
			if(!g_setting.IsDLInst()){
				ablib::string msg = _TR("炭O̎sŃ_E[ĥ݂ꂽȂǂ̗RɂC\n_E[ht@CƃCXg[t@CႤݒɂȂĂ܂D\nW32TeXɂĂ̐ݒύXꍇCyуCXg[t@CύXꍇ\nuxȐݒv{^ĂD\nȊÕ\tgɂẮCݒ̕ύX͂ł܂");
				msg.replace(_T("\n"),_T("\r\n"));
				wnd->MsgBox(msg,_T("AbTeXinst.exe"));
			}
			return 0;
		}
		case 1:
			wnd->MsgBox(_TR("LZ܂"),_T("AbTeXinst.exe"));
			break;
		case 2:
			wnd->MsgBox(_TR("ڑɃG["),_T("AbTeXinst.exe"));
			break;
		case 3:
			wnd->MsgBox(_TR("Xbh쐬Ɏs"),_T("AbTeXinst.exe"));
			break;
		case 4:
			wnd->MsgBox(_TR("sȃG[DOt@CƉ킩邩܂"),_T("AbTeXinst.exe"));
			break;
		}
		SetPreviousID();
		return MAKEINTRESOURCE(IDD_PLUGIN);
	}else return 0;
}


bool MainDlg::DlgProp3::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_TEXADV:
	{
		ExtTeX et(ablib::system::Translation::GetResourceHandle());
		et.Create(wnd);
		return true;
	}
	case IDC_DELETECHECKS:
	{
		ablib::window::ListView list(wnd,IDC_TEXINFO);
		int count = list.GetItemCount();
		// g[^ł̃_E[h邽߂ɁuS`FbNv{^͂Ȃ
		// ESHIFTȂ炾ƃ`FbNO{^Ń`FbNĂ܂悤ɂĂD
		// pD
		bool check = false;
		if(::GetKeyState(VK_RSHIFT) & 0x80)check = true;
		for(int i = 0 ; i < count ; ++i)list.SetCheckState(i,check);
		return true;
	}
	default:
		return false;
	}
}

LPCTSTR MainDlg::DlgProp3::OnWizNext(ablib::window::Dialog *wnd){
	int ids[] = { IDC_TEXINFO,IDC_DVIOUTINFO,IDC_GSINFO };// , IDC_GVINFO
	for(int i = 0 ; i < sizeof(ids)/sizeof(int) ; ++i){
		std::vector<ablib::string> data;
		ablib::window::ListView list(wnd,ids[i]);
		int itemcount = list.GetItemCount();
		for(int j = 0 ; j < itemcount ; ++j){
			data = list.GetItem(j);
			ASSERT(!data.empty());
			if(!data.empty()){
				bool check = list.GetCheckState(j);
				if(g_setting.IsUseNetwork())g_InstallFiles.SetDownload(data[0],check);
				else g_InstallFiles.SetDownload(data[0],false);
				if(g_setting.IsDLInst())g_InstallFiles.SetInstall(data[0],check);
			}
		}
	}
	return 0;
}

bool MainDlg::OtherSoftProp::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::ListView list(wnd,IDC_PLUGINLIST);
	list.EnableCheckBox();
	list.EnableFullRowSelect();
	std::vector<ablib::window::ListView::ColumnData> cdata;
	cdata.push_back(ablib::window::ListView::ColumnData(150,_TR("\tg")));
	cdata.push_back(ablib::window::ListView::ColumnData(390,_TR("")));
	list.SetColumn(cdata);
	for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
		std::vector<ablib::string> data;
		if(g_plugin.Sets(i)){
			data.push_back(g_plugin.SoftName(i));
			data.push_back(g_plugin.Info(i));
			list.AddItem(data,g_plugin.IsDefault(i));
		}
	}
//	ablib::window::ListView list(wnd,IDC_PLUGINLIST);
	list.DeleteAllItems();
	for(int i = 0 ; i < g_plugin.GetPluginNum() ; ++i){
		std::vector<ablib::string> data;
		data.push_back(g_plugin.SoftName(i));
		data.push_back(g_plugin.Info(i));
		list.AddItem(data,g_plugin.IsDefault(i));
	}
	return true;
}

LPCTSTR MainDlg::OtherSoftProp::OnSetActive(ablib::window::Dialog *wnd){
	bool ispreviousdlg3 = IsPreviousID(IDD_DIALOG3);
	if(g_plugin.GetPluginNum() == 0){
		SetPreviousID();
		return ispreviousdlg3 ? MAKEINTRESOURCE(IDD_DIALOG4) : MAKEINTRESOURCE(IDD_DIALOG3);
	}
	return 0;
}

LPCTSTR MainDlg::OtherSoftProp::OnWizNext(ablib::window::Dialog *wnd){
	ablib::window::ListView list(wnd,IDC_PLUGINLIST);
	for(int i = 0 ; i < list.GetItemCount() ; ++i){
		g_plugin.SetDL(i,list.GetCheckState(i));
	}

	return 0;
}


bool MainDlg::DlgProp4::OnWizFinish(ablib::window::Dialog *wnd){
	if(g_InstallFiles.DoesReboot()){
		if(wnd->MsgBox(_TR("ċNKvłDċN܂H"),_T("AbTeXinst.exe"),ablib::window::Wnd::mb_yesno) == ablib::window::Wnd::id_yes){
			ablib::system::Power().Reboot();
		}
	}
	return true;
}

LPCTSTR MainDlg::DlgProp4::OnSetActive(ablib::window::Dialog *wnd){
	Download d(ablib::system::Translation::GetResourceHandle());
	Install ins(ablib::system::Translation::GetResourceHandle());

	if(!g_setting.IsUseNetwork()){
		switch(ins.Show(wnd->GetParent())){
		case 3:
			wnd->MsgBox(_TR("Xbh쐬Ɏs"),_T("AbTeXinst"));
			break;
		default:
			SetLastMsg(wnd);
			return 0;
		}
//		return MAKEINTRESOURCE(-1);
		return MAKEINTRESOURCE(IDD_OTHERSOFTWARE);
	}

	switch(d.down(wnd->GetParent())){
	case 0:
		switch(ins.Show(wnd->GetParent())){
		case 3:
			wnd->MsgBox(_TR("Xbh쐬Ɏs"),_T("AbTeXinst.exe"));
			// Install::ShowłĂ̂łȂ͂Ȃ񂾂ǁccD
			wnd->ShowWindow(ablib::window::Wnd::sw_show);
			return MAKEINTRESOURCE(-1);
		default:
			wnd->ShowWindow(ablib::window::Wnd::sw_show);
			SetLastMsg(wnd);
			wnd->ShowWindow(ablib::window::Wnd::sw_show);
			return 0;
		}
	case 1:
		wnd->MsgBox(_TR("LZ܂"),_T("AbTeXinst.exe"));
		break;
	case 2:
		wnd->MsgBox(_TR("ڑɃG["),_T("AbTeXinst.exe"));
		break;
	case 3:
		wnd->MsgBox(_TR("Xbh쐬Ɏs"),_T("AbTeXinst.exe"));
		break;
	default:
		break;
	}
//	return MAKEINTRESOURCE(-1);
	return MAKEINTRESOURCE(IDD_OTHERSOFTWARE);
}

void MainDlg::DlgProp4::SetLastMsg(ablib::window::Dialog *wnd){
//	g_report.tex = g_report.dviout= g_report.dvioutset = g_report.gs = g_report.gv = g_report.envset = g_report.plugin = _T("");
	ablib::string file = g_setting.GetIniFile();
	file.erase(file.rfind(_T(".")));
	file += _T("_log.txt");
	file.erase(0,file.rfind(_T("\\")) + 1);
	ablib::string msg = _TR("CXg[I܂");
	if(g_InstallFiles.DoesReboot())msg += _TR("SȏÏׂɂ͍ċNKvłD\n");
	msg += _T("\n\n");
	msg += ablib::string::sprintf(
		_TR("CXg[\nW32TeX                \t: %s\ndviout                \t: %s\ndviout̐ݒ          \t: %s\nGhostscript           \t: %s" /*\nGSview                \t: %s*/ "\nϐ              \t: %s\n̑̃\tgEFA  \t: %s\n\nCXg[ɎsꍇreadmeQlɂĎ蓮CXg[݂ĂD\n܂ڍׂȃCXg[ʋyуG[%sɕۑĂ܂"),g_report.tex.c_str(),g_report.dviout.c_str(),g_report.dvioutset.c_str(),g_report.gs.c_str()/*,g_report.gsset.c_str(),g_report.gv.c_str()*/,g_report.envset.c_str(),g_report.plugin.c_str(),file.c_str());
	msg.replace(_T("\n"),_T("\r\n"));
	ablib::window::StaticText(wnd,IDC_MSG).SetText(msg.c_str());
}

