#include "stdafx.h"
#include <system/FindFile.h>
#include "plugin.h"
#include "setting.h"
#include "resource.h"
#include "DllPlugin.h"
#include "RubyPlugin.h"

extern setting g_setting;

void Plugin::Load(){
	UnLoad();
	// plugińikakuto3̂fBNgj\\pluginɂĂD
	TCHAR me[4096];
	::GetModuleFileName(NULL,me,4095);
	ablib::string plugindir = me;
	plugindir.erase(plugindir.rfind(_T("\\")));
	plugindir += _T("\\plugin");
	ablib::string pattern = plugindir + _T("\\*.dll");
	ablib::system::FindFile ff;
	if(ff.Begin(pattern)){
		WIN32_FIND_DATA wfd;
		while(ff.Next(&wfd)){
			ablib::string dllname = plugindir + _T("\\") + wfd.cFileName;
			DllPlugin *dll = new DllPlugin();
			if(!SetPlugin(dll,dllname.c_str()))delete dll;
		}
		ff.Close();
	}

	pattern = plugindir + _T("\\*.rb");
	if(ff.Begin(pattern)){

		WIN32_FIND_DATA wfd;
		while(ff.Next(&wfd)){
			ablib::string scriptname = plugindir + _T("\\") + wfd.cFileName;
			RubyPlugin *ruby = new RubyPlugin();
			if(!SetPlugin(ruby,scriptname.c_str()))delete ruby;
		}
		ff.Close();
	}
	return;
}

void Plugin::AddPlugin(PluginInterface *plugin){
	for(int i = 0 ; i < plugin->GetSoftNum() ; ++i){
		PluginData pd;
		pd.plugin = plugin;
		pd.isinstall = true;
		pd.index = i;
		m_plugindata.push_back(pd);
	}
}

bool Plugin::SetPlugin(PluginInterface *plugin,const TCHAR *file){
	if(plugin->Load(file)){
		AddPlugin(plugin);
		return true;
	}else{
		plugin->UnLoad();
		return false;
	}
}

void Plugin::UnLoad(){
	for(PluginData &i : m_plugindata){
		if(i.index == 0){
			i.plugin->UnLoad();
			delete i.plugin;
		}
	}
	m_plugindata.clear();
}

bool Plugin::GetDownloadList(std::vector<ablib::string> &urls,std::vector<ablib::string> &files,std::vector<size_type> &sizes){
	std::vector<PluginInterface::DownloadData> dd;
	for(PluginData &i : m_plugindata){
		if(i.isinstall){
			PluginInterface::DownloadData d = i.plugin->GetDownloadData(i.index);
			if(!d.success)return false;
			dd.push_back(d);
		}
	}
	for(PluginInterface::DownloadData &i : dd){
		for(int j = 0 ; j < i.downnum ; ++j){
			urls.push_back(i.dls[j].url);
			files.push_back(i.dls[j].file);
			sizes.push_back(i.dls[j].size);
		}
	}
	return true;
}



bool Plugin::Reboots(){
	for(std::vector<PluginData>::size_type i = 0 ; i < m_plugindata.size() ; ++i){
		if(m_plugindata[i].index == 0){
			if(m_plugindata[i].isinstall && m_plugindata[i].plugin->Reboots())return true;
		}
	}
	return false;
}

bool Plugin::GetInfo(HWND hwnd){
	for(std::vector<PluginData>::size_type i = 0 ; i < m_plugindata.size() ; ++i){
		if(m_plugindata[i].index == 0){
//			g_setting.Log(m_plugindata[i].plugin->PluginFile() + ablib::string(_T("FGetInfo")));
			if(!m_plugindata[i].plugin->GetInfo(hwnd))return false;
		}
	}
	return true;
}

bool Plugin::Install(HWND hwnd){
	bool rv = true;
	for(std::vector<PluginData>::size_type i = 0 ; i < m_plugindata.size() ; ++i){
		if(m_plugindata[i].isinstall){
			if(!m_plugindata[i].plugin->Install(hwnd,m_plugindata[i].index,m_downloadstate))rv = false;
		}
	}
	return rv;
}

void Plugin::UnInit(){
	for(PluginData &i : m_plugindata){
		if(i.index == 0){
			i.plugin->UnInit();
		}
	}
}

