#include "stdafx.h"
#include <boost/lexical_cast.hpp>
#include "setting.h"
// ruby.hx߂includeȂƃRpCG[cc
#include "RubySys.h"
#include "RubyPlugin.h"

extern setting g_setting;


bool RubyPlugin::InitializePlugin(){
	Ruby::AddProtectGCList(m_module);
	int state;
	VALUE infos = rb_protect(sInfo,m_module,&state);
	if(state != 0)return false;
	if(TYPE(infos) != T_ARRAY)return false;
	for(int i = 0 ; i < RARRAY_LEN(RARRAY(infos)) ; ++i){
		VALUE softname = rb_hash_aref(::rb_ary_entry(infos,i),rb_str_new2("softname"));
		VALUE info = rb_hash_aref(::rb_ary_entry(infos,i),rb_str_new2("info"));
		if(softname == Qnil || info == Qnil)return false;
		m_infos.push_back(SoftInfo(Ruby::FromRubyString(softname),Ruby::FromRubyString(info)));
	}

	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);
	::rb_ary_push(args,Ruby::ToRubyString(g_setting.GetIniFile()));
	::rb_ary_push(args,Ruby::ToRubyString(g_setting.GetLogFile()));
	::rb_protect(sInit,args,&state);

	return true;
}

VALUE RubyPlugin::sInfo(VALUE module){
	return rb_funcall(module,rb_intern("info"),0);
}

VALUE RubyPlugin::sInit(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE ini = ::rb_ary_shift(val);VALUE log = ::rb_ary_shift(val);
	return rb_funcall(module,rb_intern("plugin_init"),2,ini,log);
}

bool RubyPlugin::Load(const ablib::string &name,const ablib::string &file,VALUE mod){
	m_modulename = name;
	m_filename = file;
	m_module = mod;
	return InitializePlugin();
}

bool RubyPlugin::Load(const TCHAR *file){
	m_modulename = file;
	if(m_modulename.rfind(_T("\\")) != ablib::string::npos)m_modulename.erase(0,m_modulename.rfind(_T("\\")) + 1);
	if(m_modulename.length() > 3)m_modulename.erase(m_modulename.length() - 3);
	m_modulename.tolower();m_modulename[0] = m_modulename[0] - 'a' + 'A';
	m_filename = file;

	Ruby::ResetRegisterPluginCalled();
	int state;
	rb_load_protect(Ruby::ToRubyString(file),0,&state);
	if(state != 0){WriteExceptionLog(_T("[h"));return false;}

	if(!Ruby::IsRegisterPluginCalled()){
/*
	ID modid = ::rb_intern(m_modulename.c_str());
	if(!top_const_get(modid,&m_module)){
		g_setting.Log(m_modulename + _T("`Ă܂"));
		return false;
	}
*/
		m_module = rb_eval_string_protect(ablib::TransCode::ToChar(m_modulename).c_str(),&state);
		if(state != 0){WriteExceptionLog(ablib::string::sprintf(_TR("%s]"),m_modulename.c_str()));return false;}

		return InitializePlugin();
	}else return false;
}

VALUE RubyPlugin::sSet(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE hwnd = ::rb_ary_shift(val);VALUE index = ::rb_ary_shift(val);
	return rb_funcall(module,rb_intern("set"),2,hwnd,index);
}

void RubyPlugin::Set(HWND hwnd,int index){
	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);::rb_ary_push(args,INT2NUM((int)hwnd));::rb_ary_push(args,Ruby::ToRubyString(m_infos[index].softname));
	int state;
	rb_protect(sSet,args,&state);
	if(state != 0){
		MessageBox(hwnd,ablib::string::sprintf(_TR("%ssetŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("set"));
	}
}

VALUE RubyPlugin::sGetInfo(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE hwnd = ::rb_ary_shift(val);
	return rb_funcall(module,rb_intern("get_info"),1,hwnd);
}

bool RubyPlugin::GetInfo(HWND hwnd){
	int state;
	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);::rb_ary_push(args,INT2NUM((int)hwnd));
	VALUE rv = rb_protect(sGetInfo,args,&state);
	if(state != 0){
		MessageBox(hwnd,ablib::string::sprintf(_TR("%sget_infoŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("get_info"));
		return false;
	}
//	g_setting.Log(m_modulename + _T(": get_info ߂l  ") + (rv == Qtrue ? _T("true") : _T("false")));
	return rv == Qtrue ? true : false;
}

VALUE RubyPlugin::sIsDefault(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE index = ::rb_ary_shift(val);
	return rb_funcall(module,rb_intern("default?"),1,index);
}

bool RubyPlugin::IsDefault(int index){
	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);::rb_ary_push(args,Ruby::ToRubyString(m_infos[index].softname));
	int state;
	VALUE rv = rb_protect(sIsDefault,args,&state);
	if(state != 0){
		::MessageBox(NULL,ablib::string::sprintf(_TR("%sdefault?ŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("default?"));
		return false;
	}
	return rv == Qtrue ? true : false;
}

VALUE RubyPlugin::sGetDownloadData(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE index = ::rb_ary_shift(val);
	return ::rb_funcall(module,::rb_intern("download_data"),1,index);
}

PluginInterface::DownloadData RubyPlugin::GetDownloadData(int index){
//	{VALUE *p;g_setting.Log(_T(__FILE__ "(") + boost::lexical_cast<ablib::string>(__LINE__) + _T("): ruby_stack_length = ") + boost::lexical_cast<ablib::string>(ruby_stack_length(&p)));}
	m_downloaddata.success = false;
	m_downloaddata.downnum = 0;
	m_downloaddata.dls.clear();
	int state;
	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);::rb_ary_push(args,Ruby::ToRubyString(m_infos[index].softname));
	VALUE val = rb_protect(sGetDownloadData,args,&state);
	if(state != 0){
		::MessageBox(NULL,ablib::string::sprintf(_TR("%sdownload_dataŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("download_data"));
		return m_downloaddata;
	}
	if(TYPE(val) != T_HASH){
		MessageBox(NULL,ablib::string::sprintf(_TR("%sdownload_data̖߂lnbVႠ܂"),m_modulename.c_str()).c_str(),NULL,0);
		return m_downloaddata;
	}
	bool success = (rb_hash_aref(val,rb_str_new2("success")) == Qtrue ? true : false);
	VALUE dls = rb_hash_aref(val,rb_str_new2("download_files"));
	if(TYPE(dls) != T_ARRAY){
		MessageBox(NULL,ablib::string::sprintf(_TR("%sdownload_data̖߂ldownload_filesz񂶂Ⴀ܂"),m_modulename.c_str()).c_str(),NULL,0);
		return m_downloaddata;
	}
	int downnum = RARRAY_LEN(RARRAY(dls));
	m_downloaddata.success = success;
	m_downloaddata.downnum = downnum;
	PluginInterface::DLFile dlf;
	for(int i = 0 ; i < downnum ; ++i){
		VALUE dlfile = *(RARRAY_PTR(RARRAY(dls)) + i);
		VALUE s = rb_hash_aref(dlfile,rb_str_new2("url"));
		dlf.url = Ruby::FromRubyString(s);

		s = rb_hash_aref(dlfile,rb_str_new2("file"));
		dlf.file = Ruby::FromRubyString(s);

		dlf.size = NUM2INT(rb_hash_aref(dlfile,rb_str_new2("size")));
		m_downloaddata.dls.push_back(dlf);
	}
	return m_downloaddata;
}

VALUE RubyPlugin::sInstall(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE hwnd = ::rb_ary_shift(val);VALUE index = ::rb_ary_shift(val);
	VALUE dlstates = ::rb_ary_shift(val);
	return rb_funcall(module,rb_intern("install"),3,hwnd,index,dlstates);
}

bool RubyPlugin::Install(HWND hwnd,int index,const std::map<ablib::string,State> &dlstates){
	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);::rb_ary_push(args,INT2NUM((int)hwnd));::rb_ary_push(args,Ruby::ToRubyString(m_infos[index].softname));
	VALUE dlstates_val = ::rb_hash_new();
	for(std::map<ablib::string,State>::const_iterator ite = dlstates.begin() ; ite != dlstates.end() ; ++ite){
		::rb_hash_aset(dlstates_val,Ruby::ToRubyString(ite->first),INT2NUM(ite->second));
	}
	::rb_ary_push(args,dlstates_val);
	int state;
	VALUE rv = rb_protect(sInstall,args,&state);
	if(state != 0){
		::MessageBox(hwnd,ablib::string::sprintf(_TR("%sinstallŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("install"));
		return false;
	}
	return rv == Qtrue ? true : false;
}

VALUE RubyPlugin::sSets(VALUE val){
	VALUE module = ::rb_ary_shift(val);VALUE index = ::rb_ary_shift(val);
	return rb_funcall(module,rb_intern("set?"),1,index);
}

bool RubyPlugin::Sets(int index){
	int state;
	VALUE args = ::rb_ary_new();
	::rb_ary_push(args,m_module);::rb_ary_push(args,Ruby::ToRubyString(m_infos[index].softname));
	VALUE rv = rb_protect(sSets,args,&state);
	if(state != 0){
		::MessageBox(NULL,ablib::string::sprintf(_TR("%sset?ŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("set?"));
		return true;
	}
	return rv == Qtrue ? true : false;
}

VALUE RubyPlugin::sReboots(VALUE module){
	return rb_funcall(module,rb_intern("reboot?"),0);
}

bool RubyPlugin::Reboots(){
	int state;
	VALUE rv = rb_protect(sReboots,m_module,&state);
	if(state != 0){
		::MessageBox(NULL,ablib::string::sprintf(_TR("%sreboot?ŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
		WriteExceptionLog(_T("reboot?"));
		return false;
	}
	return rv == Qtrue ? true : false;
}

VALUE RubyPlugin::sUnInit(VALUE module){
	return ::rb_funcall(module,::rb_intern("plugin_uninit"),0);
}

void RubyPlugin::UnInit(){
	if(::rb_respond_to(m_module,::rb_intern("plugin_uninit"))){
		int state;
		VALUE rv = ::rb_protect(sUnInit,m_module,&state);
		if(state != 0){
			::MessageBox(NULL,ablib::string::sprintf(_TR("%splugin_uninitŗO܂"),m_modulename.c_str()).c_str(),_T("AbTeXinst"),0);
			WriteExceptionLog(_T("plugin_uninit"));
			return;
		}
	}else return;
}

void RubyPlugin::WriteExceptionLog(const ablib::string &func){
	int state;
	VALUE rv = rb_protect(sGetLastError,Qnil,&state);
	if(state == 0 && TYPE(rv) == T_STRING){
		g_setting.Log(m_modulename + _T("::") + func + _T(" : ") + ablib::TransCode::FromChar(ruby_sourcefile) + _T("(") + boost::lexical_cast<ablib::string>(ruby_sourceline) + _T(") ") + Ruby::FromRubyString(rv));
	}
}

VALUE RubyPlugin::sGetLastError(VALUE module){
//	return rb_funcall(rb_errinfo(),rb_intern(_T("to_s")),0);
	return rb_funcall(ruby_errinfo,rb_intern("to_s"),0);
}


