#pragma once

#include "Tar.h"
#include "Plugin.h"
#include <ruby.h>

class Ruby{
public:
	Ruby();
	~Ruby(){delete m_Tar;::ruby_finalize();}

	static void ResetRegisterPluginCalled(){m_registerplugin_called = false;}
	static bool IsRegisterPluginCalled(){return m_registerplugin_called;}

	static void AddProtectGCList(VALUE val);

	static ablib::string FromRubyString(VALUE str);
	static VALUE ToRubyString(const ablib::string &str);
private:
	VALUE m_abtexinstmodule;
	VALUE m_settingmodule;

	static VALUE ZIP(VALUE self,VALUE file,VALUE dir);
	static VALUE ZIPDLG(VALUE self,VALUE hwnd,VALUE file,VALUE dir);
	static VALUE ISTARAVAILABLE(VALUE self);
	static VALUE TARDLG(VALUE self,VALUE hwnd,VALUE file,VALUE targetdir);
	static VALUE DIRINPUT(VALUE self,VALUE hwnd,VALUE title,VALUE def);
	static VALUE SETSYSTEMENV(VALUE self,VALUE name,VALUE value);
	static VALUE SETUSERENV(VALUE self,VALUE name,VALUE value);
	static VALUE SETMESSAGE(VALUE self,VALUE hwnd,VALUE str);
	static VALUE ADDMESSAGE(VALUE self,VALUE hwnd,VALUE str);
	static VALUE ISCANCEL(VALUE self,VALUE hwnd);
	static VALUE MESSAGEBOX(VALUE self,VALUE hwnd,VALUE msg);
	static VALUE QUESTIONBOX(VALUE self,VALUE hwnd,VALUE msg);
	static VALUE WRITEINISTR(VALUE self,VALUE file,VALUE sec,VALUE key,VALUE str);
	static VALUE WRITEINIINT(VALUE self,VALUE file,VALUE sec,VALUE key,VALUE val);
	static VALUE GETINISTR(VALUE self,VALUE file,VALUE sec,VALUE key);
	static VALUE GETINIINT(VALUE self,VALUE file,VALUE sec,VALUE key);
	static VALUE GETSPECIALFOLDER(VALUE self,VALUE dirtype);
	static VALUE CREATESHORTCUT(VALUE self,VALUE from,VALUE arg,VALUE dir,VALUE to);
	static VALUE ADDPATH(VALUE self,VALUE path);
	static VALUE DELETEPATH(VALUE self,VALUE path);
	static VALUE GETIEPROXYINFO(VALUE self);
	static VALUE GETWINDOWPOS(VALUE self,VALUE hwnd);
	static VALUE REGISTERPLUGIN(VALUE self,VALUE name,VALUE cls);
	static VALUE ENABLEWINDOW(VALUE self,VALUE hwnd,VALUE b);
	static VALUE SETHWNDTOVROBJ(VALUE self,VALUE obj,VALUE hwnd);
	static VALUE GETLANGUAGE(VALUE self);
	static VALUE UPDATELSR(VALUE self);

	static VALUE SETTING_HOZONDIR(VALUE self);
	static VALUE SETTING_INSTALLDIR(VALUE self);
	static VALUE SETTING_PROXY(VALUE self);
	static VALUE SETTING_PORT(VALUE self);
	static VALUE SETTING_USESNETWORK(VALUE self);
	static VALUE SETTING_WRITESINI(VALUE self);
	static VALUE SETTING_SETHOZONDIR(VALUE self,VALUE dir);
	static VALUE SETTING_SETINSTALLDIR(VALUE self,VALUE dir);
	static VALUE SETTING_SETPROXY(VALUE self,VALUE proxy);
	static VALUE SETTING_SETPORT(VALUE self,VALUE port);


	typedef VALUE (*RUBY_FUNCTION)(...);

	static Tar *m_Tar;

private:
	void SetCSIDL();
	static VALUE sClassNew(VALUE cls);
	static VALUE sGetLastError(VALUE module);
	static bool m_registerplugin_called;
};

