# coding: Shift_JIS

require 'net/http'
require 'uri'
require 'time'
require 'nkf'
require 'tmpdir'
require 'pathname'
require 'vr/vruby'
require 'vr/vrdialog'
require 'vr/vrcontrol'

Net::HTTP.version_1_2


module XypicMod
	URLLIST = [
		'http://www.ring.gr.jp/pub/text/CTAN/macros/generic/diagrams/xypic/xy.zip',
		'http://www.dnsbalance.ring.gr.jp/pub/text/CTAN/macros/generic/diagrams/xypic/xy.zip',
		'http://core.ring.gr.jp/pub/text/CTAN/macros/generic/diagrams/xypic/xy.zip'
	];

	class SetForm < VRModalDialog
		def construct
			left,right,top,bottom = AbTeXinst::get_windowpos(hParent);
			move(left,top,580,120);
			@font = @screen.factory.newfont("lr oSVbN",12);
			self.caption = 'Xy-pic: ݒ';
			addControl(VRStatic,'URL','URL',10,13,30,20);
			@URL.setFont(@font);
			addControl(VRCombobox,'list','',50,10,500,200);
			@list.setFont(@font);
			@list.setListStrings(URLLIST);
			addControl(VRButton,'OK','OK',400,50,40,20);
			@OK.setFont(@font);
			addControl(VRButton,'Cancel','ݾ',470,50,80,20);
			@Cancel.setFont(@font);
			
			set_URL(options['URL']);
	 	end
	 	
	 	def list_selchanged
			@tmplisturl = @list.getTextOf(@list.selectedIndex);
	 	end
	 	
	 	def set_URL(url)
	 		@listurl = url;
	 		ind = URLLIST.index(url);
	 		if ind != nil then
	 			@list.select(ind);
	 		end
	 		@tmplisturl = url;
	 	end
	 	
	 	def OK_clicked
	 		close(@tmplisturl);
	 	end
	 	
	 	def Cancel_clicked
	 		close(nil);
	 	end
	end


	class Xypic
		def initialize
			@ini = ""
			@log = ""
			
			@url = URLLIST[0];
			@localfile = "xy.zip";
			@size = 0
			@success = false
			@definstall = true
			
			@inisec = 'plugin_Xypic';
		end
		
		def info
			return [{"softname" => "Xy-pic", "info" => "}Ȃǂ`ɕ֗TeX}ND"}]
		end
		
		
		def plugin_init(ini,log)
			@ini = ini
			@log = log
			url = AbTeXinst::get_ini_str(@ini,@inisec,'URL');
	 		if URLLIST.index(url) == nil then
	 			@url = URLLIST[0];
	 		else
	 			@url = url
	 		end
		end
		
		
		def reboot?()
			return false
		end
		
		
		def set?(soft)
			return true;
		end
		
		
		def set(hwnd,soft)
			if AbTeXinst::Setting::use_network? == true then
#				parentpos = AbTeXinst::get_windowpos(hwnd);
#				setfrm = VRLocalScreen.showForm(SetForm,parentpos["left"],parentpos["top"],680,120);
#				setfrm.set_URL(@url);
#				VRLocalScreen.messageloop;
#				@url = setfrm.get_URL;
				par = SWin::LWFactory.new(SWin::Application.hInstance).newwindow(nil,SWin::Window);
				AbTeXinst::sethwndtovrobj(par,hwnd);
				rv = VRLocalScreen.modalform(par,nil,SetForm,nil,{'URL'=>@url});
				if rv then @url = rv; end
			else
				VRLocalScreen.newform.messageBox("lbg[NgȂȂΐݒ̕Kv͂܂D","Xy-pic",0);
			end
			return
		end
		
		
		def get_info(hwnd)
			Log("Xy-pic̏擾Jn")
			if AbTeXinst::Setting::use_network? == false then
				begin
				@definstall = File.exist?(AbTeXinst::Setting::hozon_dir + @localfile);
				rescue
					@definstall = false;
				end
				return true;
			end
			uri = URI.parse(@url)
			if uri.scheme != "http" then
				Log("httpłȂƂ܂D")
				return false
			end
			AbTeXinst::add_message(hwnd,"\r\n\r\nXy-pic̏擾Jn\r\n")
			response = nil
			
			proxy = AbTeXinst::Setting::proxy;
			if proxy == nil then
				proxy = AbTeXinst::get_IEproxy_info;
			end
			if proxy == nil or proxy["server"] == "" then
				proxy = {"server" => nil,"port" => nil};
			end
			AbTeXinst::add_message(hwnd,"" + uri.host + "ɐڑ擾܂D\r\n");
			Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
				response = http.head(uri.path)
			}
			
			
			if response == nil then
				AbTeXinst::add_message(hwnd,"擾Ɏs\r\n")
				Log("擾Ɏs")
				return false
			end
			
			
			@size = response['Content-Length'].to_i
			nettime = Time.parse(response['last-modified']) + 120
			begin
				localtime = File.mtime(AbTeXinst::Setting::hozon_dir + @localfile);
				@definstall = (localtime < nettime)
			rescue
				@definstall = true
			end
			
			Log("Xy-pic̏擾I")
			AbTeXinst::add_message(hwnd,"\r\n")
			@success = true
			return true
		end
		
		
		def download_data(soft)
			if AbTeXinst::Setting::use_network? == 0 then
				return {
					"success" => true,
					"download_files" => []};
			else
				return {
					"success" => @success,
					"download_files" => [{
						"url" => @url,
						"file" => @localfile,
						"size" => @size}]}
			end
		end
		
		
		def default?(soft)
			return @definstall
		end
		
		
		def install(hwnd,soft,dlresult)
			Log("Xypic̃CXg[");
			if AbTeXinst::Setting::use_network? == true then
				if dlresult[@url] == nil or dlresult[@url] != AbTeXinst::SUCCESS then
					return false
				end
			end
			
			Dir.mktmpdir{|tmpdir|
				from = AbTeXinst::Setting::hozon_dir + @localfile;
				AbTeXinst::add_message(hwnd,"Xy-pic̃CXg[cc");
				if AbTeXinst::zipdlg(hwnd,from,tmpdir) == false then
					AbTeXinst::add_message(hwnd"s\r\n");
					Log("Xy-pic̃CXg[ɎsF" + @localfile + "̓WJɎs");
				end
				
				# glob̓fBNg̋؂肪/łȂƂ߂ۂD
				
				tmpdir = Dir.glob(Pathname(tmpdir).to_s + '/*')[0] + '/';
#				tmpdir = File.expand_path(tmpdir);
				
				texmf = AbTeXinst::Setting::install_dir + "share/texmf-local/";
				# Macros
				FileUtils.mkdir_p(texmf + "tex/generic/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "/texinputs/*"),texmf + "tex/generic/xypic");
				# Metric
				FileUtils.mkdir_p(texmf + "fonts/tfm/public/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "/texfonts/*.tfm"),texmf + "fonts/tfm/public/xypic");
				# METAFONT
				FileUtils.mkdir_p(texmf + "fonts/source/public/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "/mfinputs/*.mf"),texmf + "fonts/source/public/xypic");
				# Type1 fonts
				FileUtils.mkdir_p(texmf + "fonts/type1/public/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "/type1/*.pfb"),texmf + "fonts/type1/public/xypic");
				# PS Font Metric
				FileUtils.mkdir_p(texmf + "fonts/pfm/public/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "/pfm/*.pfm"),texmf + "fonts/pfm/public/xypic");
				# Adobe Metric
				FileUtils.mkdir_p(texmf + "fonts/afm/public/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "/afm/*.afm"),texmf + "fonts/afm/public/xypic");
				# PS Font Map
				FileUtils.mkdir_p(texmf + "fonts/map/dvips/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "ps/*"),texmf + "fonts/map/dvips/xypic");
				# PDF Font Map
				FileUtils.mkdir_p(texmf + "fonts/enc/dvips/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "enc/*"),texmf + "fonts/enc/dvips/xypic");
				# Docs
				FileUtils.mkdir_p(texmf + "doc/generic/xypic");
				FileUtils.cp(Dir.glob(tmpdir + "doc/*"),texmf + "doc/generic/xypic");
			}
			
			if system('"' + AbTeXinst::Setting::install_dir + 'bin\updmap.exe" --add xypic.map') == false then
				Log("xypic.map̓o^Ɏs");
				AbTeXinst::add_message(hwnd,"s\r\n")
				Log("Xy-pic̃CXg[Ɏs");
				return false;
			end
			
			AbTeXinst::update_lsr();

			AbTeXinst::add_message(hwnd,"\r\n")
			Log("Xy-pic̃CXg[ɐ")
			return true
		end
		
		def plugin_uninit
			if AbTeXinst::Setting::write_ini? then
				AbTeXinst::write_ini_str(@ini,@inisec,'URL',@url);
			end
		end

	private
		def Log(l)
			begin
				fp = File.open(@log,"a+")
			rescue
				return
			end
			fp.write(l + "\n");
			fp.close()
		end
	end
end

AbTeXinst::register_plugin('Xy-pic',XypicMod::Xypic);

