# -*- encoding: Shift_JIS -*-

require 'net/http'
require 'uri'
require 'time'
require 'nkf'
require 'win32/registry'
require 'FileUtils'

Net::HTTP.version_1_2

class HidefortexClass
	
	def initialize
		@ini = ""
		@log = ""
		
		@success = false
		
		@url = {
			"秀丸" => "http://hide.maruo.co.jp/software/hidemaru.html",
			"祝鳥" => "http://www.ms.u-tokyo.ac.jp/~abenori/mycreate/fortex.html"}
		@fileurl = {
			"秀丸" => "",
			"祝鳥" => ""}
		@size = {
			"秀丸" => 0,
			"祝鳥" => 0}
		@definstall = {
			"秀丸" => true,
			"祝鳥" => true}
		return true
	end
	
	
	def Info
		return [
			{"softname" => "秀丸", "info" => "Windowsの定番テキストエディタ"},
			{"softname" => "祝鳥", "info" => "秀丸上で動くTeX用のマクロ"}
			]
	end
	
	
	def Init(ini,log)
		@ini = ini
		@log = log
	end
	
	
	def IsNeedReboot()
		return false
	end
	
	
	def IsNeedSetting(soft)
		return false
	end
	
	
	def Set(hwnd,soft)
		return
	end
	
	
	def GetInfo(hwnd)
		# 秀丸情報取得
		Log("秀丸の情報取得開始")
		uri = URI.parse(@url['秀丸'])
		if uri.scheme != "http" then
			Log("httpでないとダメです．")
			return false
		end
		Kakuto3::ADDMESSAGE(hwnd,"\r\n\r\n♪秀丸の情報取得開始♪\r\n");

		response = nil
		Kakuto3::ADDMESSAGE(hwnd,uri.host + "に接続し情報を取得します．\r\n")
		
		Net::HTTP.start(uri.host){|http|
			response = http.get(uri.path)
		}
		
		if response == nil then
			Kakuto3::ADDMESSAGE(hwnd,"情報取得に失敗．\r\n")
			Log("情報取得に失敗．")
			return false
		end
		
		/hm[0-9]*_signed\.exe/ =~ response.body
		hides = $~.to_a
		max = 0
		for i in hides
			/hm([0-9]*)/ =~ i
			if max < Integer($1) then
				max = Integer($1)
				file = i
			end
		end
		
		/<a href="(.*?)">#{file}/i =~ response.body
		hideurl = $1
		/^(.*)\/[^\/]*$/ =~ uri.path
		@fileurl['秀丸'] = "http://" + uri.host + $1 + "/" + hideurl

		
		/#{file}.*?([0-9]*)KB.*?([0-9]*)\/([0-9]*)\/([0-9]*).*?<\/tr>/im =~ response.body
		@size['秀丸'] = Integer($1) * 1024
		nettime = Time.local(Integer($2),Integer($3),Integer($4)) + 60*60*24 #一日後
		
		begin
			localtime = File.atime(Kakuto3::GETINISTR(@ini,"Dir","Hozon") + "hidemaru.exe");
			@definstall['秀丸'] = (localtime < nettime)
		rescue
			@definstall['秀丸'] = true
		end
		
		Kakuto3::ADDMESSAGE(hwnd,"秀丸の情報取得完了")
		
		
		#こっから祝鳥
		Log("祝鳥の情報取得開始")
		uri = URI.parse(@url['祝鳥'])
		if uri.scheme != "http" then
			Log("httpでないとダメです．")
			return false
		end
		Kakuto3::ADDMESSAGE(hwnd,"\r\n\r\n♪祝鳥の情報取得開始♪\r\n");

		response = nil
		Kakuto3::ADDMESSAGE(hwnd,uri.host + "に接続し情報を取得します．\r\n")
		
		Net::HTTP.start(uri.host){|http|
			response = http.get(uri.path)
		}
		
		if response == nil then
			Kakuto3::ADDMESSAGE(hwnd,"情報取得に失敗．\r\n")
			Log("情報取得に失敗．")
			return false
		end
		
		/<a href="(.*fortex[a-z0-9_]*\.zip)">最新版/i =~ NKF.nkf('-s',response.body)
		if $1 == nil then
			Kakuto3::ADDMESSAGE(hwnd,"失敗")
			Log("HTML解析に失敗．")
			return false
		end
		fortexurl = $1
		/^(.*)\/[^\/]*$/ =~ uri.path
		@fileurl['祝鳥'] = "http://" + uri.host + $1 + "/" + fortexurl
		
		response = nil
		uri = URI.parse(@fileurl['祝鳥'])
		Net::HTTP.start(uri.host){|http|
			response = http.head(uri.path)
		}
		
		if response == nil then
			Kakuto3::ADDMESSAGE(hwnd,"情報取得に失敗．\r\n")
			Log("情報取得に失敗．")
			return false
		end
		
		@size['祝鳥'] = response['Content-Length'].to_i
		
		
		begin
			localtime = File.atime(Kakuto3::GETINISTR(@ini,"Dir","Hozon") + "fortex.zip");
			nettime = Time.parse(response['last-modified']) + 120
			@definstall['祝鳥'] = (localtime < nettime)
		rescue
			@definstall['祝鳥'] = true
		end
		
		Kakuto3::ADDMESSAGE(hwnd,"祝鳥の情報取得完了")
		
		
		@success = true
		
		return true
	end
	
	
	def GetDownloadData(soft)
		if soft == "秀丸" then
			return {
			"success" => @success,
			"downnum" => 1,
			"dls" => [
				{
					"url" => @fileurl['秀丸'],
					"file" => "hidemaru.exe",
					"size" => @size['秀丸']
				}]};
		else
			return {
			"success" => @success,
			"downnum" => 1,
			"dls" => [
				{
					"url" => @fileurl['祝鳥'],
					"file" => "fortex.zip",
					"size" => @size['祝鳥']
				}]};
		
		end
	end
	
	
	def IsDefaultInstall(soft)
		return @definstall[soft]
	end
	
	
	def Install(hwnd,soft)
		if soft == "秀丸" then
			begin
				if exec(KAKUTO3::GETINISTR(@ini,"Dir","Hozon") + "hidemaru.exe") == 0 then
					return true;
				else
					return false;
				end
			rescue
				return false;
			end
		else
			# 秀丸インストールチェック＆インストールディレクトリの取得
			begin
				reg = Win32::Registry.open(Win32::Registry::HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\Hidemaru');
				hidedir = reg['InstallLocation'];
				reg.close();
			rescue
				Log("秀丸がインストールされてないような気がします．");
				return false;
			end
			# マクロディレクトリの登録や取得とか．
			begin
				reg = Win32::Registry.open(Win32::Registry::HKEY_CURRENT_USER,'Software\Hidemaruo\Hidemaru\Env');
				macrodir = reg['MacroPath'];
				if macrodir == "" then raise; end;
			rescue
				macrodir = Kakuto3::DIRINPUT(hwnd,"マクロディレクトリを入れてください．",hidedir + "\\macros");
				begin
					reg = Win32::Registry.create(Win32::Registry::HKEY_CURRENT_USER,'Software\Hidemaruo\Hidemaru\Env',Win32::Registry::KEY_ALL_ACCESS);
					reg['MacroPath'] = macrodir;
				rescue
					Log("マクロディレクトリの登録に失敗．");
					return false;
				end
			end
			FileUtils.makedirs(macrodir);
			
			
		end
		return true
	end


private
	def Log(l)
		begin
			fp = File.open(@log,"a+")
		rescue
			return
		end
		fp.write(l + "\n");
		fp.close()
	end
end

Hidefortex = HidefortexClass.new

