# encode: Shift_JIS

require 'net/http'
require 'uri'
require 'time'

Net::HTTP.version_1_2

class IpaexClass

  def initialize
    @ini = ""
    @log = ""
    @url = ""
    @size = 0
    @success = false
    @definstall = true
    return true
  end

  def info
    return [{"softname" => "IPAex_fonts", "info" => "IPAexフォントとIPAexフォント埋込み用のcid-x.mapをtexmf-localに配置します．"}]
  end

  def plugin_init(ini,log)
    @ini = ini
    @log = log
  end

  def reboot?()
    return false
  end

  def set?(soft)
    return false
  end

  def set(hwnd,soft)
    return
  end

  def get_info(hwnd)
    Log("IPAex_fontsの情報取得開始");
    if AbTeXinst::Setting::use_network? == false then
      begin
        @definstall = File.exist?(AbTeXinst::Setting::hozon_dir + "ipaex-local.zip");
        @success = true
      rescue
        @definstall = false;
      end
      return true;
    end
    Log("IPAex_fontsの情報取得終了")
    AbTeXinst::add_message(hwnd,"完了\r\n")
    @success = true
    return true
  end


  def download_data(soft)
    return {
      "success" => true,
      "download_files" => []};
  end

  def default?(soft)
    return @definstall
  end

  def install(hwnd,soft,dlresult)
    AbTeXinst::add_message(hwnd,"IPAex_fontsのインストール……")
    Log("IPAex_fontsのインストール");
    dir = AbTeXinst::Setting::install_dir + "share\\texmf-local\\"
    from = AbTeXinst::Setting::hozon_dir + "ipaex-local.zip"
    if AbTeXinst::zipdlg(hwnd,from,dir) then
      AbTeXinst::add_message(hwnd,"成功\r\n")
      Log("IPAex_fontsのインストールに成功")
      return true
    else
      AbTeXinst::add_message(hwnd,"失敗\r\n")
      Log("IPAex_fontsのインストールに失敗")
      return false
    end
  end

  private
  def Log(l)
    begin
      fp = File.open(@log,"a+")
    rescue
      return
    end
    fp.write(l + "\n");
    fp.close()
  end

end

Ipaex = IpaexClass.new

