# coding: Shift_JIS

require 'net/http'
require 'uri'
require 'time'
require 'nkf'
require 'tmpdir'
require 'pathname'
require 'vr/vruby'
require 'vr/vrdialog'
require 'vr/vrcontrol'


Net::HTTP.version_1_2
module ISpellMod
	URLLIST = [
		"http://www.ring.gr.jp/pub/text/TeX/ptex-win32/w32/",
		"http://www.dnsbalance.ring.gr.jp/archives/text/TeX/ptex-win32/w32/",
		"http://core.ring.gr.jp/pub/text/TeX/ptex-win32/w32/",
	];



	class ISpell
		class SetForm < VRModalDialog
			def construct
				left,right,top,bottom = AbTeXinst::get_windowpos(hParent);
				move(left,top,600,110);
				@font = @screen.factory.newfont("lr oSVbN",12);
				self.caption = 'ispell: ݒ';
				addControl(VRStatic,'URL','URL',10,13,30,20);
				@URL.setFont(@font);
				addControl(VRCombobox,'list','',50,10,500,200);
				@list.setFont(@font);
				@list.setListStrings(URLLIST);
				addControl(VRButton,'OK','OK',400,50,40,20);
				@OK.setFont(@font);
				addControl(VRButton,'Cancel','ݾ',470,50,80,20);
				@Cancel.setFont(@font);
				
				set_URL(options['URL']);
		 	end
		 	
		 	def list_selchanged
				@tmplisturl = @list.getTextOf(@list.selectedIndex);
		 	end
		 	
		 	def set_URL(url)
		 		@listurl = url;
		 		ind = URLLIST.index(url);
		 		if ind != nil then
		 			@list.select(ind);
		 		end
		 		@tmplisturl = url;
		 	end
		 	
		 	def OK_clicked
		 		close(@tmplisturl);
		 	end
		 	
		 	def Cancel_clicked
		 		close(nil);
		 	end
		end

		def initialize
			@ini = ""
			@log = ""
			
			@dirurl = URLLIST[0];
			@url = "";
			@localfile = "ispell.tar.xz";
			@size = 0
			@success = false
			@definstall = true
			@reboot = false;
			
			@inisec = 'plugin_ISpell';
		end
		
		def info
			return [{"softname" => "ispell", "info" => "Xy`FbJ[ispell̊pɂڐAłłD"}];
		end
		
		
		def plugin_init(ini,log)
			@ini = ini;
			@log = log;
			url = AbTeXinst::get_ini_str(@ini,@inisec,'URL');
	 		if URLLIST.index(url) == nil then
	 			@dirurl = URLLIST[0];
	 		else
	 			@dirurl = url
	 		end
		end
		
		
		def reboot?()
			return @reboot;
		end
		
		
		def set?(soft)
			return true;
		end
		
		
		def set(hwnd,soft)
			if AbTeXinst::Setting::use_network? == true then
				par = SWin::LWFactory.new(SWin::Application.hInstance).newwindow(nil,SWin::Window);
				AbTeXinst::sethwndtovrobj(par,hwnd);
				rv = VRLocalScreen.modalform(par,nil,SetForm,nil,{'URL'=>@dirurl});
				if rv then @dirurl = rv; end
			else
				VRLocalScreen.newform.messageBox("lbg[NgȂȂΐݒ̕Kv͂܂D","ispell",0);
			end
			return
		end
		
		
		def get_info(hwnd)
			Log("ispell̏擾Jn")
			if AbTeXinst::Setting::use_network? == false then
				begin
					@definstall = File.exist?(AbTeXinst::Setting::hozon_dir + @localfile);
				rescue
					@definstall = false;
				end
				return true;
			end

			# proxy̐ݒ
			proxy = AbTeXinst::Setting::proxy;
			if proxy == nil then
				proxy = AbTeXinst::get_IEproxy_info;
			end
			if proxy == nil or proxy["server"] == "" then
				proxy = {"server" => nil,"port" => nil};
			end

			
			uri = URI.parse(@dirurl)
			if uri.scheme != "http" then
				Log("httpłȂƂ܂D")
				return false
			end
			AbTeXinst::add_message(hwnd,"\r\n\r\nispell̏擾Jn\r\n")
			response = nil
			
			AbTeXinst::add_message(hwnd,"" + uri.host + "ɐڑ擾܂D\r\n");
			Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
				response = http.get(uri.path)
			}

			if response == nil then
				AbTeXinst::add_message(hwnd,"擾Ɏs\r\n")
				Log("擾Ɏs")
				return false
			end

			
			flist = [];
			response.body.scan(/href[ \t]*=[ \t]*"([^\n\r"]+)"[^\n\r]*?([0-9]*)-([A-Za-z]*)-([0-9]*)[ \t]*([0-9]*):([0-9]*)[^\n\r]*?([0-9\.]*[KMB])/){|file,day,month,year,hour,min,size|
				flist.push({
					"file" => file,
					"size" => size,
					"time" => Time.local(year,month,day,hour,min)
				});
			}
			
			flist.reject!{|f| not /ispell.*-w32\.tar\.xz/ =~ f["file"]}
			ispell = flist.max{|a,b|
				a["file"].gsub(/[^0-9]/,"").to_i <=> b["file"].gsub(/[^0-9]/,"").to_i
			}
			if not ispell then
				AbTeXinst::add_message(hwnd,"s\r\n");
				Log("ispell̔Ɏs");
				return false;
			end

			/^([0-9\.]*)(.)/ =~ ispell["size"];
			@size = Regexp.last_match[1].to_f;
			case Regexp.last_match[2]
			when 'M'
				@size = @size * 1024 * 1024;
			when 'K'
				@size = @size * 1024;
			end
			@size = @size.to_i;

			nettime = ispell["time"] + 120;
			begin
				localtime = File.mtime(AbTeXinst::Setting::hozon_dir + @localfile);
				@definstall = (localtime < nettime)
			rescue
				@definstall = true
			end
			@url = @dirurl + ispell["file"];
			
			Log("ispell̏擾I")
			AbTeXinst::add_message(hwnd,"\r\n")
			@success = true
			return true
		end
		
		
		def download_data(soft)
			if AbTeXinst::Setting::use_network? == 0 then
				return {
					"success" => true,
					"download_files" => []};
			else
				return {
					"success" => @success,
					"download_files" => [{
						"url" => @url,
						"file" => @localfile,
						"size" => @size}]}
			end
		end
		
		
		def default?(soft)
			return @definstall
		end
		
		
		def install(hwnd,soft,dlresult)
			Log("ispell̃CXg[");
			AbTeXinst::add_message(hwnd,"ispell̃CXg[Jn\r\n");
			
			dictdir_envname = 'ISPELL_DICTDIR';
			
			if AbTeXinst::tar_available? == false
				Log(".tar.**𓀂ł܂D");
				AbTeXinst::add_message(hwnd,"s\r\n");
			end
			
			if AbTeXinst::Setting::use_network? == true then
				if dlresult[@url] == nil or dlresult[@url] != AbTeXinst::SUCCESS then
					return false
				end
			end

			if ENV[dictdir_envname] == nil || ENV[dictdir_envname] == "" then
				sysdir = AbTeXinst::Setting::install_dir + 'ispell\dic';
			else
				sysdir = ENV[dictdir_envname];
			end
			sysdir = AbTeXinst::dir_input(hwnd,"ispell̃VXeCXg[ꏊIłD",sysdir);
			
			if sysdir == nil || sysdir == "" then
				Log("VXẽCXg[ꏊݒ肳܂łD");
				AbTeXinst::add_message(hwnd,"s\r\n");
				return false;
			end
			
			
			if ENV["HOME"] == nil || ENV["HOME"] == "" then
				homepath = ENV["HOMEPATH"];
				homedrive = ENV["HOMEDRIVE"];
				if homepath != nil && homepath != "" && homedrive != nil && homedrive != "" then
					home = (homedrive + homepath).to_s;
				else
					home = AbTeXinst::get_specialfolder(AbTeXinst::CSIDL_PERSONAL);
				end
			else
				home = ENV["HOME"];
			end
			
			home = AbTeXinst::dir_input(hwnd,"HOMȄꏊw肵ĂD",home);
			if home == nil || home == "" then
				Log("HOMȄꏊw肳܂łD");
				AbTeXinst::add_message(hwnd,"s\r\n");
				return false;
			end
			
			result = true;
			
			Dir.mktmpdir{|tmpdir|
				AbTeXinst::add_message(hwnd,"ispell𓀁cc");
				if AbTeXinst::tardlg(hwnd,AbTeXinst::Setting::hozon_dir + @localfile,tmpdir) == false then
					Log("ispell̉𓀂Ɏs");
					AbTeXinst::add_message(hwnd,"s\r\n");
				end
				
				AbTeXinst::add_message(hwnd,"\r\nt@C̃Rs[cc");
				
				FileUtils.cp(Dir.glob(tmpdir + '/ispell-w32/bin/*.exe'),AbTeXinst::Setting::install_dir + 'bin');
				
				FileUtils.makedirs(sysdir);
				FileUtils.cp(Dir.glob(tmpdir + '/ispell-w32/dic/*'),sysdir);
				
				AbTeXinst::add_message(hwnd,'\r\nispellp̐ݒcc');
				
				if sysdir != ENV[dictdir_envname] then
					if !AbTeXinst::set_systemenv(dictdir_envname,sysdir) then
						Log("ϐ#{dictdir_envname}̏Ɏs");
						result = false;
					else
						Log("ϐ#{dictdir_envname}#{sysdir}ݒ");
						@reboot = true;
					end
				end
				if home != ENV['HOME'] then
					if !AbTeXinst::set_userenv('HOME',home) then
						Log('ϐHOMȄɎs');
						result = false;
					else
						Log("ϐHOME#{home}ݒ");
						@reboot = true;
					end
				end
			}

			if result then
				AbTeXinst::add_message(hwnd,"\r\n")
				Log("ispell̃CXg[ɐ")
			else
				AbTeXinst::add_message(hwnd,"s\r\n")
				Log("ispell̃CXg[Ɏs")
			end
			return result;
		end
		
		def plugin_uninit
			if AbTeXinst::Setting::write_ini? then
				AbTeXinst::write_ini_str(@ini,@inisec,'URL',@dirurl);
			end
		end
		
	private
		def Log(l)
			begin
				fp = File.open(@log,"a+")
			rescue
				return
			end
			fp.write(l + "\n");
			fp.close()
		end
		
	end
end

AbTeXinst::register_plugin('ispell',ISpellMod::ISpell);

