#include "stdafx.h"
#include "shortcut.h"

bool ShortCut::CreateShortCut(const TCHAR *from,const TCHAR *arg,const TCHAR *dir,const TCHAR *to){
	IShellLink *isl;
	IPersistFile *ipf;
	
	::CoInitialize(NULL);
	if(FAILED(::CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&isl))){
		::CoUninitialize();
		return false;
	}

	isl->SetPath(from);
	isl->SetArguments(arg);
	isl->SetWorkingDirectory(dir);
	isl->SetShowCmd(SW_SHOWDEFAULT);

	if(FAILED(isl->QueryInterface(IID_IPersistFile,(void**)&ipf))){
		isl->Release();
		::CoUninitialize();
		return false;
	}

#ifdef UNICODE
	const WCHAR *link = to;
#else
	WCHAR *link = new WCHAR[::lstrlen(to) * 2 + 1];
	::MultiByteToWideChar(CP_ACP,0,to,-1,link,::lstrlen(to) * 2 + 1);
#endif
	bool rv = FAILED(ipf->Save(link,TRUE)) ? false : true;

#ifndef UNICODE
	delete[] link;
#endif
	ipf->Release();
	isl->Release();
	::CoUninitialize();
	return rv;
}


