#include "stdafx.h"
#include <process.h>
#include "tar.h"
#include "func.h"
#include "setting.h"
#include "resource.h"

extern setting g_setting;

Tar::~Tar(){
	if(m_dll)::FreeLibrary(m_dll);
}

bool Tar::IsAvailable(){
	if(m_dll)return true;
	m_dll = ::LoadLibrary(_T("tar32.dll"));
	if(m_dll)return true;
	if(::GetFileAttributes((ablib::string(g_setting.GetTmpDir()) + _T("texinst\\tar.exe")).c_str()) != -1)return true;
	return false;
}

typedef int (WINAPI *TAR)(const HWND hWnd,LPCSTR szCmdLine,LPSTR szOutput,const DWORD dwSize);

bool Tar::Exec(ablib::window::Wnd *wnd,const TCHAR *file,const TCHAR *dir){
	m_file = file;
	char typeopt;
	if(::lstrcmpi(file + ::lstrlen(file) - 3,_T("bz2")) == 0)typeopt = 'j';
	else if(::lstrcmpi(file + ::lstrlen(file) - 2,_T("xz")) == 0)typeopt = 'J';
	else typeopt = 'z';;

	if(m_dll == NULL)m_dll = ::LoadLibrary(_T("tar32.dll"));
	if(m_dll && typeopt != 'J'){// tar32.dll.xz͖ΉccƎvD
		TAR func = reinterpret_cast<TAR>(::GetProcAddress(m_dll,"Tar"));
		if(func){
			ablib::basic_string<char> cmd;
			cmd = typeopt + "xvf";
			cmd += " \"";
			cmd += ablib::TransCode::ToChar(file);
			cmd += "\" -o \"";
			cmd += ablib::TransCode::ToChar(dir);
			cmd += "\"";
			if((*func)(wnd ? wnd->GetHWND() : NULL,cmd.c_str(),NULL,0) == 0)return true;
			else return false;
		}
	}
	ablib::string tarexe;
	ablib::system::Process::ProcessStartInfo si;
/*
	if(si.Arg == _T("")){
		tarexe = ablib::string(g_setting.GetInstallDir()) + _T("tar.exe");
		if(::GetFileAttributes(tarexe.c_str()) != -1)si.Arg = _T("\"") + tarexe + _T("\"");
	}
*/
	if(si.Arguments == _T("")){
		tarexe = ablib::string(g_setting.GetTmpDir()) + _T("texinst\\tar.exe");
		if(::GetFileAttributes(tarexe.c_str()) != -1)si.Arguments = _T("\"") + tarexe + _T("\"");
	}
	si.Arguments += _T(" ");

	si.Arguments += typeopt;
	si.Arguments += _T("xvf");
	si.Arguments += _T(" \"");
	si.Arguments += file;
	si.Arguments += _T("\"");

	si.FileName = _T("");
	si.WorkingDirectory= dir;
	si.RedirectStandardOutput = si.RedirectStandardError = true;
	si.RedirectStandardInput = false;
	si.CreateNoWindow = false;si.ShowState = ablib::system::Process::ProcessStartInfo::hide;
	m_process.StartInfo(si);

	::CreateDirectoryReflex(dir);

	return Create(wnd,IDD_ZIPDLG) ? true : false;

}

bool Tar::OnInitDialog(ablib::window::Dialog *wnd){
	m_thread = reinterpret_cast<HANDLE>(::_beginthread(sRead,0,this));
	if(m_thread == NULL)return false;
	wnd->SetTitle(ablib::string::sprintf(_TR("%s 𓀒cc"),m_file.c_str()));
	return true;
}

void Tar::sRead(void *d){
	Tar *me = static_cast<Tar*>(d);
	me->Read();
}

void Tar::Read(){
	if(!m_process.Start()){
		g_setting.Log(ablib::string::sprintf(_TR("%s̎sɎs"),m_process.StartInfo().Arguments.c_str()));
		GetWindow()->Destroy(FALSE);
		return;
	}
	ablib::window::Edit ed(GetWindow(),IDC_FILE);
	ablib::string buf_rest;
	char bufc[4096];

	ablib::string dir = m_process.StartInfo().WorkingDirectory;
	dir.replace(_T("\\"),_T("/"));
	if(dir.length() != 0 && dir[dir.length() - 1] != '/')dir += _T("/");
	ablib::window::StaticText(GetWindow(),IDC_DIR).SetText(dir);
	ablib::string output;
	while(true){
		if(DWORD readsize = m_process.Read(bufc,4095)){
			bufc[readsize] = '\0';
			output += ablib::TransCode::FromChar(bufc);
			buf_rest += ablib::TransCode::FromChar(bufc);
			ablib::string::size_type crlf1 = buf_rest.rfind(_T("\n"));
			if(crlf1 == ablib::string::npos)crlf1 = buf_rest.rfind(_T("\r"));
			if(crlf1 != ablib::string::npos && crlf1 != 0){
				ablib::string::size_type last;
				// sR[h\r\n̏ꍇ
				if(crlf1 != 1 && buf_rest[crlf1] == '\n' && buf_rest[crlf1 - 1] == '\r')last = crlf1 - 2;
				else last = crlf1 - 1;
				ablib::string::size_type crlf2 =  buf_rest.rfind(_T("\n"),last);
				if(crlf2 == ablib::string::npos)crlf2 = buf_rest.rfind(_T("\r"),last);
				if(crlf2 != ablib::string::npos){
					ablib::string file = buf_rest.substr(crlf2 + 1,last - crlf2);
					buf_rest.erase(0,crlf1);
//					ed.SetText(dir + file);
					ed.SetText(file);
				}
			}
		}else{
			if(m_process.HasExited())break;
			else ::Sleep(100);
		}
	}
	DWORD errl = m_process.ExitCode();
	int rv = (errl == 0 || errl == 2) ? TRUE : FALSE;
	if(!rv)g_setting.Log(output);
	GetWindow()->Destroy(rv);
}


