#include "stdafx.h"
#include <process.h>
#include <algorithm>
#include <boost/lexical_cast.hpp>
#include <Oniguruma/RegEx.h>
#include <system/Time.h>
#include <system/File.h>
#include <system/FindFile.h>
#include <system/System.h>
#include "func.h"
#include "File.h"
#include "ZipTool.h"
#include "TeXInfo.h"
#include "FtpAccess.h"
#include "HttpAccess.h"
#include "setting.h"
#include "resource.h"
#include "InstallFiles.h"
#include "Plugin.h"

extern setting g_setting;
extern InstallFiles g_InstallFiles;
extern Plugin g_plugin;

namespace{
	const int SUCCESS = 0;
	const int CANCEL = 1;
	const int CONNECTERROR = 2;
	const int NOTHREAD = 3;
	const int FAILED = 4;

	const int WM_ISABORT = WM_APP + 88;

	const int NOPROTOCOL = 0;
	const int FTP = 1;
	const int HTTP = 2;
}

int TeXInfo::GetInfo(ablib::window::Wnd *parent,ablib::window::Wnd *itemhwnd){
	m_parent = parent;
	m_itemhwnd = itemhwnd;
	parent->ShowWindow(ablib::window::Wnd::sw_hide);

	HANDLE eve = ::CreateEvent(NULL,TRUE,FALSE,_T("Abenori_TeXInfoEvent"));
	if(!eve)return NOTHREAD;
	HANDLE thread = reinterpret_cast<HANDLE>(::_beginthread([](void *d){
		TeXInfo *me = reinterpret_cast<TeXInfo*>(d);
		me->BaseModalDlg::Create(NULL,IDD_TEXINFO);
	},0,this));
	if(!thread){
		::CloseHandle(eve);
		return NOTHREAD;
	}

	::WaitForSingleObject(eve,INFINITE);
	::CloseHandle(eve);

	int rv = StarGetInfo();
	parent->ShowWindow(ablib::window::Wnd::sw_show);
	GetWindow()->Destroy(rv);

	if(::WaitForSingleObject(thread,1000) == WAIT_TIMEOUT)::TerminateThread(thread,FALSE);

	return rv;

}

bool TeXInfo::CheckCancel(){
	return GetWindow()->SendMsg(WM_ISCANCEL,0,0) != FALSE;
}

void TeXInfo::WriteMsg(ablib::string &str){
	GetWindow()->SendMsg(WM_MESSAGE,0,reinterpret_cast<LPARAM>(str.c_str()));
}

bool TeXInfo::OnInitDialog(ablib::window::Dialog *wnd){
	if(g_setting.IsUseNetwork()){
		ablib::window::StaticText(wnd,IDC_MSG).SetText(ablib::string(_TR("t@C擾܂")) + _T("  ") + ablib::string(_TR("g̃lbg[N̏ԂɂĂ͎Ԃ邱Ƃ܂")));
	}else{
		ablib::window::StaticText(wnd,IDC_MSG).SetText(_TR("t@C擾܂"));
	}
	m_isabort = false;
	HANDLE eve = ::OpenEvent(EVENT_ALL_ACCESS,FALSE,_T("Abenori_TeXInfoEvent"));
	::SetEvent(eve);
	::CloseHandle(eve);
	return true;
}

bool TeXInfo::OnClose(ablib::window::Dialog *wnd){
	m_isabort = true;
	return true;
}


INT_PTR TeXInfo::OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam){
	switch(msg){
	case WM_MESSAGE:
	{
		ablib::window::Edit ed(wnd,IDC_TEXINFO_MSG);
		ed.SetText(reinterpret_cast<TCHAR*>(lParam));
		ed.ToBottom();
		return TRUE;
	}
	case WM_ADDMESSAGE:
	{
		ablib::window::Edit ed(wnd,IDC_TEXINFO_MSG);
		ablib::string s = ed.GetText();
		s += reinterpret_cast<TCHAR*>(lParam);
		ed.SetText(s.c_str());
		ed.ToBottom();
		return TRUE;
	}
	case WM_ISCANCEL:
		::SetWindowLong(wnd->GetHWND(),DWL_MSGRESULT,m_isabort ? TRUE : FALSE);
		return TRUE;
	default:
		return FALSE;
	}
}

bool TeXInfo::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDCANCEL:
		m_isabort = true;
		if(m_ftp)m_ftp->Close();
		if(m_http)m_http->Close();
		return true;
	default:
		return false;
	}
}


int TeXInfo::StarGetInfo(){
	CreateDirectoryReflex(g_setting.GetHozonDir());
	if(!g_setting.IsUseNetwork())return GetInfoFromLocal();

	ablib::string server,path;
	int protocol = WhatProtocol(g_setting.GetTeXUrl(),server,path);
	int rv;
	AddMsg(_TR("W32TeX̏擾"));
	AddMsg(_T("\r\n"));
	g_setting.Log(_TR("W32TeX̏擾Jn"));
	if(protocol == FTP)rv = GetTeXInfoFTP(server,path);
	else rv = GetTeXInfoHTTP(server,path);
	if(rv != SUCCESS){
		return rv;
	}
	g_setting.Log(_TR("W32TeX̏擾"));

	AddMsg(_T("\r\n\r\n"));
	AddMsg(_TR("dviout̏擾"));
	AddMsg(_T("\r\n"));
	g_setting.Log(_TR("dviout̏擾Jn"));
	rv = GetFileInfo(m_dviout,g_setting.GetDVIOUTUrl(),g_setting.GetDVIOUTReg());
	if(rv != SUCCESS)return rv;
	if(CheckCancel())return Cancel();
	g_setting.Log(_TR("dviout̏擾"));

	AddMsg(_T("\r\n\r\n"));
	AddMsg(_TR("Ghostscript̏擾"));
	AddMsg(_T("\r\n"));
	g_setting.Log(_TR("Ghostscript̏擾Jn"));
	rv = GetFileInfo(m_gs,g_setting.GetGSUrl(),g_setting.GetGSReg());
	if(rv != SUCCESS)return rv;
	if(CheckCancel())return Cancel();
	g_setting.Log(_TR("Ghostscript̏擾"));

	AddMsg(_T("\r\n\r\n"));
	/*
	AddMsg(_TR("GSview̏擾"));
	AddMsg(_T("\r\n"));
	g_setting.Log(_TR("GSview̏擾Jn"));
	rv = GetFileInfo(m_gv,g_setting.GetGVUrl(),g_setting.GetGVReg());
	if(rv != SUCCESS)return rv;
	if(CheckCancel())return Cancel();
	g_setting.Log(_TR("GSview̏擾"));

	AddMsg(_T("\r\n\r\n"));
	*/

	if(!g_plugin.GetInfo(GetWindow()->GetHWND()))return FAILED;
	if(CheckCancel())return Cancel();

	g_setting.SetIsDLInst(g_InstallFiles.Set(m_w32tex,m_dviout,m_gs/*,m_gv*/));

	return SUCCESS;
}

int TeXInfo::Cancel(){
	g_setting.Log(_TR("LZ܂"));
	AddMsg(_TR("LZ"));
	return CANCEL;
}

int TeXInfo::GetTeXInfoFTP(const ablib::string &server,const ablib::string &path){
	ASSERT(m_ftp == NULL);
	struct FtpAccessCover{
		FtpAccessCover(const TCHAR *serv,const TCHAR *user,const TCHAR *mail,FtpAccess **ft)
			: f(serv,user,mail),ptf(ft){*ptf = &f;}
		~FtpAccessCover(){*ptf = NULL;}
		FtpAccess f;
		FtpAccess **ptf;
	}ftpcov(server.c_str(),_T("anonymous"),_T("a@b"),&m_ftp);
	FtpAccess &ftp = ftpcov.f;
	AddMsg(ablib::string::sprintf(_TR("%sɐڑcc"),server.c_str()));

	if(CheckCancel())return Cancel();

	// ڑ
	if(!ftp.Connect()){
		g_setting.Log(ablib::string::sprintf(_TR("%sւ̐ڑɎs"),server.c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	AddMsg(_TR(""));
	AddMsg(_T("\r\n"));
	AddMsg(_TR("JgfBNg̈ړcc"));

	if(CheckCancel())return Cancel();

	std::vector<ablib::string> addpath;
	addpath.push_back(_T(""));
	if(ablib::system::System().Is64bit())addpath.push_back(_T("win64/"));
	std::vector<FtpAccess::FileInfo> fis;
	for(auto i : addpath){
		// JgfBNg̈ړ
		if(!ftp.cd((_T("/") + path + i).c_str())){
			g_setting.Log(ablib::string::sprintf(_TR("%sւ̈ړɎs"),(_T("/") + path + i).c_str()));
			AddMsg(_TR("s"));
			return CONNECTERROR;
		}
		AddMsg(_TR(""));
		AddMsg(_T("\r\n"));
		AddMsg(_TR("t@Cꗗ̎擾cc"));

		// t@Cꗗ擾D܂Ŏ擾DFTP֗D
		std::vector<FtpAccess::FileInfo> fistmp;
		if(!ftp.ls(_T("*.*"),fistmp)){
			g_setting.Log(_TR("t@C̎擾Ɏs"));
			AddMsg(_TR("s"));
			return CONNECTERROR;
		}
		for(auto & fi : fistmp)fi.name = i + fi.name;
		fis.insert(fis.end(),fistmp.begin(),fistmp.end());
	}
	AddMsg(_TR(""));
	AddMsg(_T("\r\n"));
	AddMsg(_TR("t@CTcc"));

	if(CheckCancel())return Cancel();

	// texinst***,zipW߂t@CꗗTD
	Oniguruma::RegEx reg;
	if(!reg.Compile(g_setting.GetTeXInstReg())){
		g_setting.Log(_TR("W32TeXTׂ̐K\Ƀ~X܂"));
		AddMsg(_TR("s"));
		return FAILED;
	}

	if(CheckCancel())return Cancel();

	// K\D
	std::vector<BYTE> texinst;
	for(FtpAccess::FileInfo &i : fis){
		if(reg.Match(i.name)){
			g_InstallFiles.Settexinst(i.name);
			texinst.reserve(i.size);
			break;
		}
	}
	if(g_InstallFiles.Gettexinst() == _T("")){
		g_setting.Log(_TR("t@C̔Ɏs"));
		AddMsg(_TR("s"));
		return FAILED;
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n"));
	AddMsg(ablib::string::sprintf(_TR("%s_E[hcc"),g_InstallFiles.Gettexinst().c_str()));

	if(CheckCancel())return Cancel();

	// ۂtexinst***.zip_E[hD܂̓ɁD
	if(!ftp.cd((_T("/") + path).c_str()) || !ftp.get(g_InstallFiles.Gettexinst().c_str(),texinst)){
		g_setting.Log(ablib::string::sprintf(_TR("%s̃_E[hɎs"),g_InstallFiles.Gettexinst().c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}

	// ăt@Cɏ݁D
	FILE *fp = ::_tfopen((g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str(),_T("wb"));
	if(!fp){
		g_setting.Log(ablib::string::sprintf(_TR("%sJ܂ł"),(g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str()));
		AddMsg(_TR("s"));
		return FAILED;
	}
	::fwrite(&texinst[0],sizeof(BYTE),texinst.size(),fp);
	::fclose(fp);
	ftp.Close();
	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("ؒf") + _T("\r\n") + ablib::string::sprintf(_TR("%s𓀁cc"),g_InstallFiles.Gettexinst().c_str()));

	if(CheckCancel())return Cancel();

	// texinst***𓀁D
	ablib::string kaitoutarget = ablib::string(g_setting.GetTmpDir()) + _T("texinst\\");
	File::DeleteFiles(kaitoutarget.c_str());
	if(!ziptool::DeCompress((g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str(),kaitoutarget.c_str())){
		g_setting.Log(ablib::string::sprintf(_TR("%s̉𓀂Ɏs"),g_InstallFiles.Gettexinst().c_str()));
		AddMsg(_T("s"));
		return FAILED;
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̍쐬cc"));

	// texinst***.ct@CD
	ablib::string texinst_c = kaitoutarget + g_InstallFiles.Gettexinst();
	texinst_c.erase(texinst_c.rfind(_T(".")));
	texinst_c += _T(".c");
	fp = ::_tfopen(texinst_c.c_str(),_T("r"));
	if(!fp){
		g_setting.Log(ablib::string::sprintf(_TR("%sJ܂ł"),texinst_c.c_str()));
		AddMsg(_TR("s"));
		return FAILED;
	}

	// char *fname[] = {TD*fnameɃt@Cꗗ邩CD
	TCHAR buf[4096];buf[0] = '\0';
	while(::lstrcmp(buf,_T("char *fname[] = {\n")) != 0){
		if(::_fgetts(buf,4096,fp) == NULL)break;
	}
	reg.Compile(_T("\"(.*?)\""));
	ASSERT(reg.IsCompiled());
	m_w32tex.clear();
	while(::_fgetts(buf,4096,fp)){
		// }t@CꗗID
		if(::lstrcmp(buf,_T("}\n")) == 0)break;
		if(reg.Match(buf)){//wǃ}b`͂ǂˁcc
			ablib::string f = reg.GetMatchStr(1);
			f.tolower();
			if(!g_setting.DoseListUp(f))continue;
			for(FtpAccess::FileInfo &i : fis){
				ablib::string file = i.name;
				auto r = file.find(_T("/"));
				if(r != ablib::string::npos)file.erase(0,r + 1);
				if(f == file){
					InstallFiles::FileData fd;
					fd.file = i.name;
					fd.size = i.size;
					fd.time = i.time;
					m_w32tex.push_back(fd);
				}
			}
		}
	}
	::fclose(fp);
	
	if(CheckCancel())return Cancel();

	AddMsg(ablib::string(_TR("")) + _T("\r\n"));
	return SUCCESS;
}

int TeXInfo::GetTeXInfoHTTP(const ablib::string &server,const ablib::string &path){
	ablib::string proxy;

	if(::lstrcmp(g_setting.GetProxy(),_T("")) != 0 && g_setting.GetPortNum() != 0){
		proxy = g_setting.GetProxy();
		proxy += _T(":") + boost::lexical_cast<ablib::string>(g_setting.GetPortNum());
	} 
	HttpAccess http(server.c_str(),proxy.c_str());


	AddMsg(ablib::string::sprintf(_TR("%sɐڑcc"),server.c_str()));
	// ڑ
	if(!http.Connect()){
		g_setting.Log(ablib::string::sprintf(_TR("%sւ̐ڑɎs"),server.c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̎擾cc"));

	if(CheckCancel())return Cancel();

	std::vector<ablib::string> addpath;
	addpath.push_back(_T(""));
	if(ablib::system::System().Is64bit())addpath.push_back(_T("win64/"));
	std::vector<InstallFiles::FileData> fis;
	std::vector<BYTE> data;
	for(auto i = addpath.begin() ; i != addpath.end() ; ++i){
		std::vector<InstallFiles::FileData> fistmp;
		GetFileListFromIndexHtml(fistmp, path + *i, http, static_cast<Oniguruma::RegEx*>(nullptr));
/*
		::OutputDebugString((_T("i = ") + boost::lexical_cast<ablib::string>(i) + _T("\n")).c_str());
		for(auto fi = fistmp.begin() ; fi != fistmp.end() ; ++fi){
			::OutputDebugString(fi->file.c_str());
			::OutputDebugString(_T("\n"));
		}
*/
		for(auto fi = fistmp.begin() ; fi != fistmp.end() ; ++fi){
			fi->file = *i + fi->file;
		}
		fis.insert(fis.end(),fistmp.begin(),fistmp.end());
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@CTcc"));

	if(CheckCancel())return Cancel();

	// texinst***,zipW߂t@CꗗTD
	// ̕ӂFTPHTTPwǏDł܂Ƃ߂邩D
	g_InstallFiles.Settexinst(_T(""));
	Oniguruma::RegEx reg;
	reg.SetOpt(_T("CaseSense"),false);
	if(!reg.Compile(g_setting.GetTeXInstReg())){
		g_setting.Log(_TR("W32TeXTׂ̐K\Ƀ~X܂"));
		AddMsg(_TR("s"));
		return FAILED;
	}

	if(CheckCancel())return Cancel();
	
	// K\D
 	bool found_texinst = false;
	for(InstallFiles::FileData &i : fis){
		if(reg.Match(i.file)){
			g_InstallFiles.Settexinst(i.file);
			found_texinst = true;
			break;
		}
	}
	if(!found_texinst){
		g_setting.Log(_TR("t@C̔Ɏs"));
		AddMsg(_TR("s"));
		return FAILED;
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n") + ablib::string::sprintf(_TR("%s_E[hcc"),g_InstallFiles.Gettexinst().c_str()));

	if(CheckCancel())return Cancel();

	data.clear();
	// ۂtexinst***.zip_E[hD܂̓ɁD
	if(!http.SendGET((path + g_InstallFiles.Gettexinst()).c_str())){
		g_setting.Log(ablib::string::sprintf(_TR("%sGETNXgMɎs"),(path + g_InstallFiles.Gettexinst()).c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	if(!http.data(data)){
		g_setting.Log(_TR("f[^̓ǂݍ݂Ɏs"));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}


	// ăt@Cɏ݁D
	FILE *fp = ::_tfopen((g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str(),_T("wb"));
	if(!fp){
		g_setting.Log(ablib::string::sprintf(_TR("%sJ܂ł"),(g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str()));
		AddMsg(_TR("s"));
		return FAILED;
	}
	::fwrite(&data[0],sizeof(BYTE),data.size(),fp);
	::fclose(fp);

	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("ؒf") + _T("\r\n") + ablib::string::sprintf(_TR("%s𓀁cc"),g_InstallFiles.Gettexinst().c_str()));

	if(CheckCancel())return Cancel();

	// texinst***𓀁D
	ablib::string kaitoutarget = ablib::string(g_setting.GetTmpDir()) + _T("texinst\\");
	File::DeleteFiles(kaitoutarget.c_str());
	if(!ziptool::DeCompress((g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str(),kaitoutarget.c_str())){
		g_setting.Log(ablib::string::sprintf(_TR("%s̉𓀂Ɏs"),g_InstallFiles.Gettexinst().c_str()));
		AddMsg(_TR("s"));
		return FAILED;
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̍쐬cc"));

	// texinst***.ct@CD
	ablib::string texinst_c = kaitoutarget + g_InstallFiles.Gettexinst();
	texinst_c.erase(texinst_c.rfind(_T(".")));
	texinst_c += _T(".c");
	fp = ::_tfopen(texinst_c.c_str(),_T("r"));
	if(!fp){
		g_setting.Log(ablib::string::sprintf(_TR("%sJ܂ł"),texinst_c.c_str()));
		AddMsg(_TR("s"));
		return FAILED;
	}

	// char *fname[] = {TD*fnameɃt@Cꗗ邩CD
	TCHAR buf[4096];buf[0] = '\0';
	while(::lstrcmp(buf,_T("char *fname[] = {\n")) != 0){
		if(::_fgetts(buf,4096,fp) == NULL)break;
	}
	reg.Compile(_T("\"(.*?)\""));
	ASSERT(reg.IsCompiled());
	m_w32tex.clear();
	while(::_fgetts(buf,4096,fp)){
		// }t@CꗗID
		if(::lstrcmp(buf,_T("}\n")) == 0)break;
		if(reg.Match(buf)){//wǃ}b`͂ǂˁcc
			ablib::string f = reg.GetMatchStr(1);
			f.tolower();
			if(!g_setting.DoseListUp(f))continue;
			// oftdevel͔΂D
//			if(f.find(_T("otfdevel")) != ablib::string::npos)continue;
			// luatex-dev΂D
//			if(f.find(_T("luatex-dev")) != ablib::string::npos)continue;
			for(InstallFiles::FileData &i : fis){
				ablib::string file = i.file;
				auto r = file.find(_T("/"));
				if(r != ablib::string::npos)file.erase(0,r + 1);
				if(file == reg.GetMatchStr(1)){
					m_w32tex.push_back(i);
				}
			}
		}
	}
	::fclose(fp);
	
	http.Close();

	AddMsg(ablib::string(_TR("")) + _T("\r\n"));
	return SUCCESS;
}

int TeXInfo::GetFileInfo(std::vector<InstallFiles::FileData> &output,const TCHAR *url,const TCHAR *reg){
	Oniguruma::RegEx r;
	if(!r.Compile(reg)){
		g_setting.Log(_TR("pK\܂"));
		AddMsg(_TR("s"));
		return FAILED;
	}
	ablib::string server,path;
	int protocol = WhatProtocol(url,server,path);
	if(protocol == FTP)return GetFileInfoFTP(output,server,path,r);
	else return GetFileInfoHTTP(output,server,path,r);
}

int TeXInfo::GetFileInfoFTP(std::vector<InstallFiles::FileData> &output,const ablib::string &server,const ablib::string &path,Oniguruma::RegEx &reg){
	ASSERT(m_ftp == NULL);
	struct FtpAccessCover{
		FtpAccessCover(const TCHAR *serv,const TCHAR *user,const TCHAR *mail,FtpAccess **ft)
			: f(serv,user,mail),ptf(ft){*ptf = &f;}
		~FtpAccessCover(){*ptf = NULL;}
		FtpAccess f;
		FtpAccess **ptf;
	}ftpcov(server.c_str(),_T("anonymous"),_T("a@b"),&m_ftp);
	FtpAccess &ftp = ftpcov.f;
	AddMsg(ablib::string::sprintf(_TR("%sɐڑcc"),server.c_str()));
	if(!ftp.Connect()){
		g_setting.Log(ablib::string::sprintf(_TR("%sւ̐ڑɎs"),server.c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	if(CheckCancel())return Cancel();

	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("JgfBNg̈ړcc"));
	if(!ftp.cd(path.c_str())){
		g_setting.Log(ablib::string::sprintf(_TR("%sɃJgfBNgڂ܂ł"),path.c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	if(CheckCancel())return Cancel();

	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̎擾cc"));
	std::vector<FtpAccess::FileInfo> fis;
	if(!ftp.ls(_T("*.*"),fis)){
		g_setting.Log(_TR("t@Cꗗ̓ǂݍ݂Ɏs"));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	if(CheckCancel())return Cancel();
	ftp.Close();

	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̍쐬cc"));
	std::vector<FtpAccess::FileInfo> netfiles;
	std::vector<ablib::string> netfiles_name;
	for(FtpAccess::FileInfo &i : fis){
		if(reg.Match(i.name) && reg.GetMatchPos() == 0 && reg.GetMatchLen() == i.name.length()){
			netfiles.push_back(i);
			netfiles_name.push_back(i.name);
		}
	}
	if(CheckCancel())return Cancel();

	output.clear();
	for(FtpAccess::FileInfo &i : netfiles){
		InstallFiles::FileData fd;
		fd.file = i.name;
		fd.size = i.size;
		fd.time = i.time;
		output.push_back(fd);
	}
	AddMsg(ablib::string(_TR("")) + _T("\r\n"));
	return SUCCESS;
}



int TeXInfo::GetFileInfoHTTP(std::vector<InstallFiles::FileData> &output,const ablib::string &server,const ablib::string &path,Oniguruma::RegEx &reg){
	ablib::string proxy;
	if(::lstrcmp(g_setting.GetProxy(),_T("")) != 0 && g_setting.GetPortNum() != 0){
		proxy = g_setting.GetProxy();
		proxy += _T(":") + boost::lexical_cast<ablib::string>(g_setting.GetPortNum());
	}
	HttpAccess http(server.c_str(),proxy.c_str());

	AddMsg(ablib::string::sprintf(_TR("%sɐڑcc"),server.c_str()));
	if(!http.Connect()){
		g_setting.Log(ablib::string::sprintf(_TR("%sւ̐ڑɎs"),server.c_str()));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	if(CheckCancel())return Cancel();

	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̎擾cc"));

	std::vector<InstallFiles::FileData> fis;
	GetFileListFromIndexHtml(fis, path, http, &reg);
	if(CheckCancel())return Cancel();
	http.Close();

	AddMsg(ablib::string(_TR("")) + _T("\r\n") + _TR("t@Cꗗ̍쐬cc"));
	output.clear();
	for(std::vector<ablib::string>::size_type i = 0 ; i < fis.size() ; ++i){
		if(reg.Match(fis[i].file))output.push_back(fis[i]);
	}

	AddMsg(ablib::string(_TR("")) + _T("\r\n"));
	return SUCCESS;
}

int TeXInfo::GetFileListFromIndexHtml(std::vector<InstallFiles::FileData> &fds,const ablib::string &path,HttpAccess &http,Oniguruma::RegEx *filter){
	if (!http.SendGET(path.c_str())) {
		g_setting.Log(_TR("GETNGXg̑MɎs"));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}

	if (CheckCancel())return SUCCESS;

	std::vector<BYTE> data;
	data.reserve(http.content_length());
	if (!http.data(data)) {
		g_setting.Log(_TR("f[^̓ǂݍ݂Ɏs"));
		AddMsg(_TR("s"));
		return CONNECTERROR;
	}
	data.push_back('\0');

	ablib::string str = ablib::TransCode::FromChar(reinterpret_cast<char*>(&data[0]));
	std::vector<InstallFiles::FileData> fistmp;

	Oniguruma::RegEx reg1,reg2,reg3;
	// 1: t@CC2: C3: C4: NC5: C6: C7: TCY
	reg1.Compile(_T("href[ \\t]*=[ \\t]*\"([^\\r\\n\"/]+)\"[^\\n\\r]*?([0-9]*)-([A-Za-z]*)-([0-9]*)[ \\t]*([0-9]*):([0-9]*)[^\\n\\r]*?([0-9\\.]*[KMB])"));
	// 1: t@CC2: NC3: C4: C5: C6: C7: TCY
	reg2.Compile(_T("href[ \\t]*=[ \\t]*\"([^\\r\\n\"/]+)\"[^\\n\\r]*?([0-9]*)-([0-9]*)-([0-9]*)[ \\t]*([0-9]*):([0-9]*)[^\\n\\r]*?([0-9\\.]*[KMB])"));
	// 1: t@C
	reg3.Compile(_T("href[ \\t]*=[ \\t]*\"([^\\r\\n\"/]+)\""));
	ASSERT(reg1.IsCompiled()); ASSERT(reg2.IsCompiled()); ASSERT(reg3.IsCompiled());
	//	DEBUGSTRING(_T("%s"), reg1.Match("href=\"context.tar.bz2\">context.tar.bz2</a>            15-Aug-2009 10:07   17M  ") ? "true" : "false");
//	DEBUGSTRING(_T("%s"), reg2.Match("href="context.tar.xz">context.tar.xz</a>            2013-02-26 15:20   10M") ? "true" : "false");
	ablib::string::size_type p = 0;
	int year, day, month, hour, min;
	while(true){
		if (CheckCancel())return SUCCESS;
		bool reg1matched = reg1.Match(str.c_str() + p);
		bool reg2matched = reg2.Match(str.c_str() + p);
		DEBUGSTRING(_T("from %d, reg1 match = %s, reg2_match = %s"), p, reg1matched ? _T("true") : _T("false"), reg2matched ? _T("true") : _T("false"));
		InstallFiles::FileData fd;
		//ablib::string day,year,hour,min;
		if(reg1matched && reg1.GetTokenNum() >= 7){
			p += reg1.GetMatchPos() + reg1.GetMatchLen();
			fd.file = reg1.GetMatchStr(1);
			if (filter != nullptr && !filter->Match(fd.file))continue;
			fd.size = FromStrSize2IntSize(reg1.GetMatchStr(7));
			year = boost::lexical_cast<int>(reg1.GetMatchStr(4));
			month = FromStrMonth2IntMonth(reg1.GetMatchStr(3));
			day = boost::lexical_cast<int>(reg1.GetMatchStr(2));
			hour = boost::lexical_cast<int>(reg1.GetMatchStr(5));
			min = boost::lexical_cast<int>(reg1.GetMatchStr(6));
			ablib::system::Time time(year, month, day, hour, min);
			fd.time = time;
		}else if(reg2matched && reg2.GetTokenNum() >= 7){
			p += reg2.GetMatchPos() + reg2.GetMatchLen();
			fd.file = reg2.GetMatchStr(1);
			if (filter != nullptr && !filter->Match(fd.file))continue;
			fd.size = FromStrSize2IntSize(reg2.GetMatchStr(7));
			year = boost::lexical_cast<int>(reg2.GetMatchStr(2));
			month = boost::lexical_cast<int>(reg2.GetMatchStr(3));
			day = boost::lexical_cast<int>(reg2.GetMatchStr(4));
			hour = boost::lexical_cast<int>(reg2.GetMatchStr(5));
			min = boost::lexical_cast<int>(reg2.GetMatchStr(6));
			ablib::system::Time time(year, month, day, hour, min);
			fd.time = time;
		} else if (reg3.Match(str.c_str() + p)) {
			p += reg3.GetMatchPos() + reg3.GetMatchLen();
			fd.file = reg3.GetMatchStr(1);
			if (filter != nullptr && !filter->Match(fd.file))continue;
			if (!http.SendHEAD((path + fd.file).c_str())) {
				g_setting.Log(path + fd.file + _T(" ւHEADNGXgMɎsD"));
				return CONNECTERROR;
			}
			fd.time = http.last_modified();
			fd.size = http.content_length();
			if (!fd.time.IsValid())g_setting.Log(_T("Cannot get Last-Modified of ") + fd.file);
		} else break;
		

		DEBUGSTRING(_T("t@CXg쐬Ffile = %s, TCY = %d, %dN%d%d%d%d"),fd.file.c_str(),fd.size,fd.time.year(),fd.time.month(),fd.time.day(),fd.time.hour(),fd.time.minute());
		fds.push_back(fd);
	}
	if (fds.empty()) {
		g_setting.Log(_TR("File not found\nServer: ") + http.servername() + _TR("\nPath: ") + path + _TR("\nData:\n") + str + _TR("\n<<DATA"));
	}
	return SUCCESS;
}


int TeXInfo::GetInfoFromLocal(){
	g_setting.Log(_TR("茳̃t@C擾"));


	WIN32_FIND_DATA wfd;
	ablib::system::FindFile ff;
	ablib::string msg = _T("");
	msg += _TR("ۑĂTeXt@Ccc");
	WriteMsg(msg);

	bool searched = false;
	std::vector<ablib::string> addpath;
	addpath.push_back(_T(""));addpath.push_back(_T("win64/"));
	std::vector<ablib::string> files;
	for(auto &i : addpath){
		if(!ff.Begin(ablib::string(g_setting.GetHozonDir()) + i + _T("*.*")))continue;
		searched = true;
	
		while(ff.Next(&wfd)){
			files.push_back(i + wfd.cFileName);
			files[files.size() - 1].tolower();
		}
		ff.Close();
	}

	Oniguruma::RegEx texinst;
	if(!texinst.Compile(g_setting.GetTeXInstReg())){
		g_setting.Log(_TR("W32TeXTׂ̐K\Ƀ~X܂"));
		msg += _TR("s");WriteMsg(msg);return FAILED;
	}
	std::vector<ablib::string> tinsts;
	for(ablib::string &i : files){
		if(texinst.Match(i))tinsts.push_back(i);
	}
	if(tinsts.empty()){
		g_setting.Log(_TR("TeXt@C܂ł"));
		msg += _TR("s");WriteMsg(msg);return FAILED;
	}
	
	g_InstallFiles.Settexinst(tinsts[GetLatest(tinsts)]);
	msg += ablib::string(_TR("")) + _T("\r\n") + ablib::string::sprintf(_TR("%s𓀁cc"),g_InstallFiles.Gettexinst().c_str());WriteMsg(msg);
	ablib::string texinstdir = g_setting.GetTmpDir();
	texinstdir += _T("texinst\\");
	File::DeleteFiles(texinstdir.c_str());
	if(!ziptool::DeCompress((g_setting.GetHozonDir() + g_InstallFiles.Gettexinst()).c_str(),texinstdir.c_str())){
		g_setting.Log(ablib::string::sprintf(_TR("%s̉𓀂Ɏs"),g_InstallFiles.Gettexinst().c_str()));
		msg += _TR("s");WriteMsg(msg);
		return FAILED;
	}
	
	msg += ablib::string(_TR("")) + _T("\r\n") + _TR("TeXt@Čcc");WriteMsg(msg);
	ablib::string texinst_source = texinstdir + g_InstallFiles.Gettexinst();
	texinst_source.erase(texinst_source.rfind(_T(".")));
	texinst_source += _T(".c");
	FILE *fp = ::_tfopen(texinst_source.c_str(),_T("r"));
	if(!fp){
		g_setting.Log(ablib::string::sprintf(_TR("%sJ܂ł"),g_InstallFiles.Gettexinst().c_str()));
		msg += _TR("s");WriteMsg(msg);
		return FAILED;
	}
	Oniguruma::RegEx reg(_T("\"(.*?)\""));
	ASSERT(reg.IsCompiled());
	TCHAR str[4096];
	std::vector<InstallFiles::FileData> w32tex;
	while(::_fgetts(str,4095,fp)){
		if(::lstrcmp(str,_T("}\n")) == 0)break;
		if(reg.Match(str)){
			ablib::string s = reg.GetMatchStr(1);
			s.tolower();
			if(!g_setting.DoseListUp(s))continue;
//			if(s.find(_T("otfdevel")) != ablib::string::npos)continue;
//			if(s.find(_T("luatex-dev")) != ablib::string::npos)continue;
			for(ablib::string &i : files){
//				OutputDebugString((_T("s = ") + s + _T(", i = ") + i + _T("\n")).c_str());
				ablib::string file = i;
				auto r = file.find(_T("/"));
				if(r != ablib::string::npos)file.erase(0,r + 1);
				if(s == file){
					InstallFiles::FileData fd;
					fd.file = i;
					fd.time = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + fd.file);
					fd.size = ablib::system::File::GetSize(g_setting.GetHozonDir() + fd.file);
					w32tex.push_back(fd);
					break;
				}
			}
		}
	}
	::fclose(fp);
	msg += ablib::string(_TR("")) + _T("\r\n") + _TR("dviouťcc");WriteMsg(msg);

	if(!reg.Compile(g_setting.GetDVIOUTReg())){
		g_setting.Log(_TR("dvioutpK\Ƀ~X܂"));
		msg += _TR("s");WriteMsg(msg);
		return FAILED;
	}
	std::vector<InstallFiles::FileData> dviout;
	for(ablib::string &i : files){
		if(reg.Match(i)){
			InstallFiles::FileData fd;
			fd.file = i;
			fd.time = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + fd.file);
			fd.size = ablib::system::File::GetSize(g_setting.GetHozonDir() + fd.file);
			dviout.push_back(fd);
		}
	}

	msg += ablib::string(_TR("")) + _T("\r\n") + _TR("Ghostscripťcc");WriteMsg(msg);

	if(!reg.Compile(g_setting.GetGSReg())){
		g_setting.Log(_TR("GhostscriptpK\Ƀ~X܂"));
		msg += _TR("s");WriteMsg(msg);
		return FAILED;
	}

	std::vector<InstallFiles::FileData> gs;
	for(ablib::string &i : files){
		if(reg.Match(i)){
			InstallFiles::FileData fd;
			fd.file = i;
			fd.time = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + fd.file);
			fd.size = ablib::system::File::GetSize(g_setting.GetHozonDir() + fd.file);
			gs.push_back(fd);
		}
	}
	msg += ablib::string(_TR("")) + _T("\r\n")/* + _TR("GSview̌cc")*/;WriteMsg(msg);

	/*
	if(!reg.Compile(g_setting.GetGVReg())){
		g_setting.Log(_TR("GSviewpK\Ƀ~X܂"));
		msg += _TR("s");WriteMsg(msg);
		return FAILED;
	}
	std::vector<InstallFiles::FileData> gv;
	for(ablib::string &i : files){
		if(reg.Match(i)){
			InstallFiles::FileData fd;
			fd.file = i;
			fd.time = ablib::system::File::GetLastWriteTime(g_setting.GetHozonDir() + fd.file);
			fd.size = ablib::system::File::GetSize(g_setting.GetHozonDir() + fd.file);
			gv.push_back(fd);
		}
	}
	msg += _TR("");msg += _T("\r\n");WriteMsg(msg);
	*/
	if(!g_plugin.GetInfo(GetWindow()->GetHWND()))return FAILED;
	if(CheckCancel())return Cancel();

	g_InstallFiles.Set(w32tex,dviout,gs/*,gv*/);

	return SUCCESS;
}

int TeXInfo::WhatProtocol(const TCHAR *url,ablib::string &server,ablib::string &path){
	int rv;

	ablib::string u = url;

	if(u.find(_T("ftp://")) == 0){
		u.erase(0,6);
		rv = FTP;
	}else if(u.find(_T("http://")) == 0){
		u.erase(0,7);
		rv = HTTP;
	}else{
		rv = FTP;
	}
	ablib::string::size_type p = u.find(_T("/"));
	if(p != ablib::string::npos){
		server = u.substr(0,p);
		path = u.substr(p + 1);
	}else{
		server = u;
		path = _T("");
	}
	return rv;
}

void TeXInfo::AddMsg(const ablib::string &str){
	GetWindow()->SendMsg(WM_ADDMESSAGE,0,reinterpret_cast<LPARAM>(str.c_str()));
}

int TeXInfo::GetLatest(const std::vector<ablib::string> &files) const{
	if(files.size() == 0)return 0;
	Oniguruma::RegEx reg;
	reg.Compile(_T("[0-9]+"));
	std::vector<size_type> version;
	for(const ablib::string &i : files){
		if(!reg.Match(i.c_str()))version.push_back(0);
		else version.push_back(boost::lexical_cast<int>(reg.GetMatchStr()));
	}
	std::vector<size_type>::iterator max = std::max_element(version.begin(),version.end());
	if(max == version.end())return 0;
	else return max - version.begin();
}

DWORD TeXInfo::FromStrMonth2IntMonth(const ablib::string &month){
	ablib::string m = month;m.tolower();
	if(m == _T("jan"))return 1;
	else if(m == _T("feb"))return 2;
	else if(m == _T("mar"))return 3;
	else if(m == _T("apr"))return 4;
	else if(m == _T("may"))return 5;
	else if(m == _T("jun"))return 6;
	else if(m == _T("jul"))return 7;
	else if(m == _T("aug"))return 8;
	else if(m == _T("sep"))return 9;
	else if(m == _T("oct"))return 10;
	else if(m == _T("nov"))return 11;
	else if(m == _T("dec"))return 12;
	else g_setting.Log(ablib::string::sprintf(_TR("ϊŃ~XDoOۂ炠ׂ̂ɕ傢ƂāDmonth = %s"),month.c_str()));
	return -1;
}

int TeXInfo::FromStrSize2IntSize(const ablib::string &s){
	if(s == _T(""))return 0;
	TCHAR c = s[s.length() - 1];
	double size;
	if(!(L'0' <= c && c <= L'9'))size = ::_tstof(s.c_str());
	else size = ::_tstof(s.substr(0,s.length() - 1).c_str());
	switch(c){
	case L'M':
		size = size*1024*1024;
		break;
	case L'K':
		size = size*1024;
		break;
	default:
		break;
	}
	return static_cast<int>(size);
}
