#ifndef __TEXINFO_H__
#define __TEXINFO_H__

#include <vector>
#include <Oniguruma/RegEx.h>
#include <window/basemodaldlg.h>
#include "Plugin.h"
#include "ftpaccess.h"
#include "httpaccess.h"
#include "InstallFiles.h"

/*
TeX̃t@C̏擾D
*/

class TeXInfo : public ablib::window::BaseModalDlg{
public:
	TeXInfo(HINSTANCE appint) : BaseModalDlg(appint),m_ftp(NULL),m_http(NULL){};
	~TeXInfo(){};
	int GetInfo(ablib::window::Wnd *parent,ablib::window::Wnd *itemhwnd);

private:
	ablib::window::Wnd *m_itemhwnd,*m_parent;
	Plugin *m_plugin;
	FtpAccess *m_ftp;
	HttpAccess *m_http;

	std::vector<InstallFiles::FileData> m_w32tex,m_dviout,m_gs,m_gv;

	int WhatProtocol(const TCHAR *url,ablib::string &server,ablib::string &path);
	int GetTeXInfoFTP(const ablib::string &server,const ablib::string &path);
	int GetTeXInfoHTTP(const ablib::string &server,const ablib::string &path);

	int GetFileInfo(std::vector<InstallFiles::FileData> &output,const TCHAR *url,const TCHAR *reg);

	int GetFileInfoFTP(std::vector<InstallFiles::FileData> &output,const ablib::string &server,const ablib::string &path,Oniguruma::RegEx &reg);
	int GetFileInfoHTTP(std::vector<InstallFiles::FileData> &output,const ablib::string &server,const ablib::string &path,Oniguruma::RegEx &reg);

	int GetFileListFromIndexHtml(std::vector<InstallFiles::FileData> &fd, const ablib::string &path, HttpAccess &http, Oniguruma::RegEx *filters);

	static void sCreateDlg(void *d);
	int StarGetInfo();
	int Cancel();

	void WriteMsg(ablib::string &str);
	void AddMsg(const ablib::string &str);
	bool CheckCancel();
	int GetLatest(const std::vector<ablib::string> &files) const;
	bool m_isabort;

	bool OnClose(ablib::window::Dialog *wnd);
	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id,int param);
	INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);

	DWORD FromStrMonth2IntMonth(const ablib::string &s);
	int FromStrSize2IntSize(const ablib::string &s);

	int GetInfoFromLocal();
};

#endif //__TEXINFO_H__


