#include "stdafx.h"
#include <ablib/Error.h>
#include "maindlg.h"
#include "setting.h"
#include "Plugin.h"
#include "InstallFiles.h"
#include "Path.h"
#include "resource.h"
#include "RubySys.h"

setting g_setting;
InstallFiles g_InstallFiles;
Path g_path;
Plugin g_plugin;

struct Mutex{
public:
	Mutex(const TCHAR *s) : m_str(s),m_mutex(NULL){}
	~Mutex(){if(m_mutex)::ReleaseMutex(m_mutex);}
	bool Create(){
		m_mutex = ::CreateMutex(FALSE,0,m_str.c_str());
		if(::GetLastError() == ERROR_ALREADY_EXISTS){
			m_mutex = NULL;
			return false;
		}else if(m_mutex == NULL){
			::MessageBox(NULL,_TR("Ɏs"),_T("AbTeXinst"),0);
			return false;
		}
		return true;
	}

private:
	HANDLE m_mutex;
	ablib::string m_str;
};

void GenerateSysIniFile(){
	HANDLE fh = ::CreateFile(g_setting.GetSysIniFile(),GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(fh != INVALID_HANDLE_VALUE){
		#define _RT(x) _T(x) _T("\r\n")
		const TCHAR sysini_def[] = 
			_RT("[System]")
			_RT("NoWriteINI=0")
			_RT("NoWriteHozonDir=0")
			_RT("NoWriteLog=0")
			_RT("LogFile=0")
			_RT("ruby_option=-Ks")
			_RT("[TeX]")
			_RT("URLlist0=http://www.ring.gr.jp/pub/text/TeX/ptex-win32/current/")
			_RT("URLlist1=http://www.dnsbalance.ring.gr.jp/pub/text/TeX/ptex-win32/current/")
			_RT("URLlist2=http://ftp.kddilabs.jp/TeX/ptex-win32/current/")
			_RT("URLlist3=http://ctan.ijs.si/mirror/w32tex/current/")
			_RT("URLlist4=http://core.ring.gr.jp/pub/text/TeX/ptex-win32/current/")
			_RT("URLlist5=ftp://ftp.ring.gr.jp/pub/text/TeX/ptex-win32/current/")
			_RT("URLlist6=ftp://ftp.dnsbalance.ring.gr.jp/pub/text/TeX/ptex-win32/current/")
			_RT("URLlist7=ftp://core.ring.gr.jp/pub/text/TeX/ptex-win32/current/")
			_RT("URLlist8=ftp://akagi.ms.u-tokyo.ac.jp/pub/TeX/win32/")
			_RT("URLlist9=ftp://ftp.kddilabs.jp/TeX/ptex-win32/current/")
			_RT("[DVIOUT]")
			_RT("URLlist0=ftp://akagi.ms.u-tokyo.ac.jp/pub/TeX/dviout/current/")
			_RT("URLlist1=http://www.ring.gr.jp/pub/text/TeX/dviout/")
			_RT("URLlist2=http://www.dnsbalance.ring.gr.jp/pub/text/TeX/dviout/")
			_RT("URLlist3=http://core.ring.gr.jp/pub/text/TeX/dviout/")
			_RT("URLlist4=ftp://ftp.ring.gr.jp/pub/text/TeX/dviout/")
			_RT("URLlist5=ftp://ftp.dnsbalance.ring.gr.jp/pub/text/TeX/dviout/")
			_RT("URLlist6=ftp://core.ring.gr.jp/pub/text/TeX/dviout/")
			_RT("[GS]")
			_RT("URLlist0=http://www.ring.gr.jp/pub/text/TeX/ptex-win32/gs/")
			_RT("URLlist1=http://www.dnsbalance.ring.gr.jp/pub/text/TeX/ptex-win32/gs/")
			_RT("URLlist2=http://core.ring.gr.jp/pub/text/TeX/ptex-win32/gs/")
			_RT("URLlist3=ftp://ftp.ring.gr.jp/pub/text/TeX/ptex-win32/gs/")
			_RT("URLlist4=ftp://ftp.dnsbalance.ring.gr.jp/pub/text/TeX/ptex-win32/gs/")
			_RT("URLlist5=ftp://core.ring.gr.jp/pub/text/TeX/ptex-win32/gs/")
			_RT("URLlist6=ftp://akagi.ms.u-tokyo.ac.jp/pub/TeX/win32-gs/")
			_RT("[GV]")
			_RT("URLlist0=http://pages.cs.wisc.edu/~ghost/gsview/download/")
			_RT("[Reg]")
			_RT("texinst=texinstwin*\\.zip")
			_RT("DVIOUT=tex[0-9]*w\\.zip")
			_RT("GS=gs[0-9]*w(32|64)full(-gpl)?\\.(zip|exe)")
			_RT("GV=gsv[0-9]*w(32|64)\\.exe")
			_RT("[FileReg]")
			_RT("luatex=luatex-w32\\.tar\\.(bz2|gz|xz)")
			_RT("luatex-dev=luatex-dev-w32\\.tar\\.(bz2|gz|xz)")
			_RT("otf=otf\\.tar\\.(bz2|gz|xz)")
			_RT("otfbeta=otfbeta\\.tar\\.(bz2|gz|xz)")
			_RT("otfdevel=otfdevel\\.tar\\.(bz2|gz|xz)")
			_RT("luatex-w64=luatex-w64\\.tar\\.(bz2|gz|xz)")
			_RT("luatex-w64-dev=luatex-dev-w64\\.tar\\.(bz2|gz|xz)")
			_RT("luajittex-dev=luajittex-dev-w32\\.tar\\.(bz2|gz|xz)")
			_RT("luajittex=luajittex-w32\\.tar\\.(bz2|gz|xz)")
			_RT("luajittex-w64-dev=luajittex-dev-w64\\.tar\\.(bz2|gz|xz)")
			_RT("luajittex-w64=luajittex-w64\\.tar\\.(bz2|gz|xz)")
			_RT("[TeXSimilarFiles]")
			_RT("otf=otf:otfdevel:otfbeta")
			_RT("luatex=luatex:luatex-dev")
			_RT("luatex-w64=luatex-w64:luatex-w64-dev")
			_RT("luajittex=luajittex:luajittex-dev")
			_RT("luajittex0w64=luajittex-w64:luajittex-w64-dev")
			;
		#undef _RT
		DWORD size;
		::WriteFile(fh,sysini_def,sizeof(TCHAR)*::lstrlen(sysini_def),&size,NULL);
		::CloseHandle(fh);
	}
}

void SetDefaultSetting(){
	TCHAR buf[128];::GetSystemDirectory(buf,127);
	g_setting.SetHozonDir((ablib::string(buf[0]) + _T(":\\w32tex\\download\\")).c_str());
	g_setting.SetInstallDir((ablib::string(buf[0]) + _T(":\\w32tex\\")).c_str());
	g_setting.SetTeXUrl(_T("http://mirror.ctan.org/tex-archive/systems/win32/w32tex/"));
	g_setting.SetIsTeXUrlList(true);
	g_setting.SetIsTeXUpdatePath(true);

	g_setting.SetDVIOUTUrl(_T("http://mirror.ctan.org/tex-archive/dviware/dviout/"));
	g_setting.SetIsDVIOUTUrlList(true);

	g_setting.SetGSUrl(_T("http://core.ring.gr.jp/pub/text/TeX/ptex-win32/gs/"));
	g_setting.SetIsGSUrlList(true);

//	g_setting.SetGVUrl(_T("http://pages.cs.wisc.edu/~ghost/gsview/download/"));
//	g_setting.SetIsGVUrlList(true);

	g_setting.SetIsDeleteCache(true);
	g_setting.SetIsUseNetwork(true);

	g_setting.SetListUpFile(_T("otf"),false);
	g_setting.SetListUpFile(_T("otfdevel"),false);
	g_setting.SetListUpFile(_T("otfbeta"),true);
	g_setting.SetListUpFile(_T("luatex"),true);
	g_setting.SetListUpFile(_T("luatex-dev"),false);
	g_setting.SetListUpFile(_T("luatex-w64"),true);
	g_setting.SetListUpFile(_T("luatex-w64-dev"),false);
	g_setting.SetListUpFile(_T("luajittex"),true);
	g_setting.SetListUpFile(_T("luajittex-dev"),false);
	g_setting.SetListUpFile(_T("luajittex-w64"),true);
	g_setting.SetListUpFile(_T("luajittex-w64-dev"),false);
//	g_setting.SetListUpFile(_T("xetex"),true);
//	g_setting.SetListUpFile(_T("xetex-dev"),false);

	g_setting.Write();
}

#include "Tar.h"
extern Tar *g_Tar;

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
#ifndef NDEBUG
//	::_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
//	::_CrtSetBreakAlloc();
#endif
	ablib::system::Translation::InitTranslation();
	::_tsetlocale(LC_ALL, _T(""));

	Mutex m(_T("AbTeXinst"));
	if(!m.Create())return -1;

	::InitCommonControls();
	Oniguruma::SYNTAX = ONIG_SYNTAX_RUBY;
	if(!g_setting.IsSysIniFileExist())GenerateSysIniFile();
	g_setting.Read();
	if(!g_setting.IsIniFileExist())SetDefaultSetting();

	g_setting.SetIsDLInst(true);
	// CXg[fBNg͕K悤ɂD
	if(::lstrcmp(g_setting.GetInstallDir(),_T("")) == 0){
		TCHAR buf[128];::GetSystemDirectory(buf,127);
		g_setting.SetInstallDir((ablib::string(buf[0]) + _T(":\\w32tex\\")).c_str());
	}
	g_setting.Log(_T(""));// Ot@C̏
/*
	TCHAR str[4096];
	::LoadString(hInstance,IDS_STRING1,str,4095);
	::MessageBox(NULL,str,NULL,0);
*/
	Ruby ruby;
	g_plugin.Load();
	int rv;

	do{
		MainDlg md;
		rv = md.Create();
	}while(rv == MainDlg::CHANGE_LANGUAGE);
	g_plugin.UnInit();
	g_plugin.UnLoad();
	delete g_Tar;
	g_InstallFiles.Save();
	if (g_setting.IsWriteINI())g_setting.Write();
	return rv;
}
