#include "stdafx.h"
#include "ftpaccess.h"
#include <system/Time.h>
#include "Setting.h"
#include <boost/lexical_cast.hpp>

extern setting g_setting;

FtpAccess::FtpAccess(const TCHAR *server,const TCHAR *user,const TCHAR *pass)
: m_server(server),m_user(user),m_pass(pass)
{
	m_open = ::InternetOpen(_T("abtexinst"),INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0);
	if(m_open == NULL){
		DWORD d = ::GetLastError();
		g_setting.Log(_T("InternetOpen:GetLastError̃G[R[h") + boost::lexical_cast<ablib::string>(d));
	}
}

bool FtpAccess::Connect(int timeout){
	if(m_open == NULL)return false;
	m_timeout = timeout * 1000;
	m_connect = ::InternetConnect(m_open,m_server.c_str(),
		INTERNET_DEFAULT_FTP_PORT,m_user.c_str(),m_pass.c_str(),
		INTERNET_SERVICE_FTP,INTERNET_FLAG_PASSIVE,0);
	if(m_connect == NULL){
		DWORD d = ::GetLastError();
		g_setting.Log(_T("InternetConnect:GetLastError̃G[R[h") + boost::lexical_cast<ablib::string>(d));
		DWORD len = 4096;
		TCHAR buf[4096];
		if(::InternetGetLastResponseInfo(&d,buf,&len)){
			if(d != 0){
				g_setting.Log(_T("InternetGetLastResponsInfóCR[h") + boost::lexical_cast<ablib::string>(d) + 
					_T("ƁCbZ[W") + buf + _T("Ԃ܂D"));
			}
		}
		return false;
	}else return true;

}

void FtpAccess::Close(){
	::InternetCloseHandle(m_connect);
	::InternetCloseHandle(m_open);
}

bool FtpAccess::ls(const TCHAR *pattern,std::vector<ablib::string> &rv){
	HINTERNET find;
	WIN32_FIND_DATA wfd;
	::ZeroMemory(&wfd,sizeof(WIN32_FIND_DATA));
	find = ::FtpFindFirstFile(m_connect,pattern,&wfd,INTERNET_FLAG_RELOAD,0);
	if(find == NULL){
		DWORD d = ::GetLastError();
		g_setting.Log(_T("FtpFindFirstFile:GetLastError̃G[R[h") + boost::lexical_cast<ablib::string>(d));
		DWORD len = 4096;
		TCHAR buf[4096];
		if(::InternetGetLastResponseInfo(&d,buf,&len)){
			if(d != 0){
				g_setting.Log(_T("InternetGetLastResponsInfóCR[h") + boost::lexical_cast<ablib::string>(d) + 
					_T("ƁCbZ[W") + buf + _T("Ԃ܂D"));
			}
		}
		return false;
	}
	rv.clear();
	do{
		rv.push_back(wfd.cFileName);
	}while(::InternetFindNextFile(find,&wfd));
	::InternetCloseHandle(find);
	return true;
}

bool FtpAccess::ls(const TCHAR *pattern,std::vector<FileInfo> &rv){
	HINTERNET find;
	WIN32_FIND_DATA wfd;
	::ZeroMemory(&wfd,sizeof(WIN32_FIND_DATA));
	find = ::FtpFindFirstFile(m_connect,pattern,&wfd,INTERNET_FLAG_RELOAD,0);
	if(find == NULL){
		DWORD d = ::GetLastError();
		g_setting.Log(_T("FtpFindFirstFile:GetLastError̃G[R[h") + boost::lexical_cast<ablib::string>(d));
		DWORD len = 4096;
		TCHAR buf[4096];
		if(::InternetGetLastResponseInfo(&d,buf,&len)){
			if(d != 0){
				g_setting.Log(_T("InternetGetLastResponsInfóCR[h") + boost::lexical_cast<ablib::string>(d) + 
					_T("ƁCbZ[W") + buf + _T("Ԃ܂D"));
			}
		}
		return false;
	}
	rv.clear();
	do{
		FileInfo fi;
		fi.name = wfd.cFileName;
		fi.size = wfd.nFileSizeLow;
		SYSTEMTIME si;
		::FileTimeToSystemTime(&(wfd.ftLastWriteTime),&si);
		fi.time = si;
		rv.push_back(fi);
	}while(::InternetFindNextFile(find,&wfd));
	::InternetCloseHandle(find);
	return true;
}

bool FtpAccess::cd(const TCHAR *dir){
	if(::FtpSetCurrentDirectory(m_connect,dir) == FALSE){
		DWORD d = ::GetLastError();
		g_setting.Log(_T("FtpSetCurrentDirectory:GetLastError̃G[R[h") + boost::lexical_cast<ablib::string>(d));
		DWORD len = 4096;
		TCHAR buf[4096];
		if(::InternetGetLastResponseInfo(&d,buf,&len)){
			if(d != 0){
				g_setting.Log(_T("InternetGetLastResponsInfóCR[h") + boost::lexical_cast<ablib::string>(d) + 
					_T("ƁCbZ[W") + buf + _T("Ԃ܂D"));
			}
		}
		return false;
	}else return true;

}

FtpAccess::size_type FtpAccess::size(const TCHAR *file){
	WIN32_FIND_DATA wfd;
	::ZeroMemory(&wfd,sizeof(WIN32_FIND_DATA));
	HINTERNET find = ::FtpFindFirstFile(m_connect,file,&wfd,INTERNET_FLAG_RELOAD,0);
	if(find == NULL)return 0;
	::InternetCloseHandle(find);
	return wfd.nFileSizeLow;
}

ablib::system::Time FtpAccess::time(const TCHAR *file){
	WIN32_FIND_DATA wfd;
	::ZeroMemory(&wfd,sizeof(WIN32_FIND_DATA));
	HINTERNET find = ::FtpFindFirstFile(m_connect,file,&wfd,INTERNET_FLAG_RELOAD,0);
	if(find == NULL)return ablib::system::Time();
	::InternetCloseHandle(find);
	SYSTEMTIME st;
	if(::FileTimeToSystemTime(&(wfd.ftLastWriteTime),&st))return ablib::system::Time(st);
	else return ablib::system::Time();
}
	
bool FtpAccess::get(const TCHAR *file,std::vector<BYTE> &rv){
	HINTERNET stream = ::FtpOpenFile(m_connect,file,GENERIC_READ,FTP_TRANSFER_TYPE_BINARY,0);
	if(stream == NULL)return false;
	BYTE buf[4096];
	DWORD size;
	rv.clear();
	do{
		if(!::InternetReadFile(stream,buf,4095,&size)){
			::InternetCloseHandle(stream);
			return false;
		}
		rv.insert(rv.end(),buf,buf + size);
	}while(size);
	::InternetCloseHandle(stream);
	return true;
}
