#include "stdafx.h"
#include "setting.h"
#include <shlobj.h>
#include <boost/lexical_cast.hpp>

/* ݒt@C
[ispell]
URL=iispell_E[hj
IsURLList=iURLXgIԂj
ISPELLDICTDIR=isystem̃CXg[j
Home=iprivatẽCXg[j
*/

TCHAR *g_url[] = {
	_T("http://www.ring.gr.jp/pub/text/TeX/ptex-win32/w32/"),
	_T("http://www.dnsbalance.ring.gr.jp/archives/text/TeX/ptex-win32/w32/"),
	_T("http://core.ring.gr.jp/pub/text/TeX/ptex-win32/w32/"),
	_T("ftp://ftp.ring.gr.jp/pub/text/TeX/ptex-win32/w32/"),
	_T("ftp://ftp.dnsbalance.ring.gr.jp/archives/text/TeX/ptex-win32/w32/"),
	_T("ftp://core.ring.gr.jp/pub/text/TeX/ptex-win32/w32/"),
	NULL
};

void setting::SetINIFile(const TCHAR *ini,const TCHAR *log){
	m_ini = ini;
	m_log = log;
	DLL dll;
	dll.loaddll();
	SetURL(GetINIStr(_T("ispell"),_T("URL")));
	if(GetURL() == _T(""))SetURL(_T("http://www.ring.gr.jp/pub/text/TeX/ptex-win32/w32/"));
	SetISPELLDICTDIR(GetINIStr(_T("ispell"),_T("ISPELLDICTDIR")));
	if(GetISPELLDICTDIR() == _T("")){
		if(GetEnv(_T("ISPELL_DICTDIR")) != _T("")){
			ablib::string d = GetEnv(_T("ISPELL_DICTDIR"));
			d.replace(_T("/"),_T("\\"));
			SetISPELLDICTDIR(d);
		}else SetISPELLDICTDIR(ablib::string(dll.dllfunc<const TCHAR*>(_T("GETINSTALLDIR"))) + _T("ispell\\dic\\"));
	}
	SetHome(GetINIStr(_T("ispell"),_T("HOME")));

	if(GetHome() == _T("")){
		bool set = false;
		{
			ablib::string d = GetEnv(_T("HOME"));
			if(d != _T("")){
				d.replace(_T("/"),_T("\\"));
				SetHome(d);
				set = true;
			}
		}
		if(!set){
			ablib::string path = GetEnv(_T("HOMEPATH"));
			ablib::string drive = GetEnv(_T("HOMEDRIVE"));
			if(path != _T("") && drive != _T("")){
				path.replace(_T("/"),_T("\\"));
				SetHome(drive + path);
				set = true;
			}
		}
		if(!set){
			TCHAR buf[MAX_PATH + 2];
			LPITEMIDLIST id;
			LPMALLOC mal;
			if(
				!FAILED(::SHGetMalloc(&mal)) && 
				!FAILED(::SHGetSpecialFolderLocation(NULL,CSIDL_PERSONAL,&id)) &&
				::SHGetPathFromIDList(id,buf))
			{
				mal->Free(id);
				if(buf[::lstrlen(buf) - 1] == '\\')buf[::lstrlen(buf) - 1] = '\0';
				SetHome(buf);
				set = true;
			}
		}
		if(!set){
			SetHome(ablib::string(dll.dllfunc<const TCHAR*>(_T("GETINSTALLDIR"))) + _T("ispell\\home\\"));
		}
	}
	if(GetINIStr(_T("ispell"),_T("IsURLList")) == _T(""))SetIsURLList(true);
	else SetIsURLList(GetINIInt(_T("ispell"),_T("IsURLList")) != FALSE);

	// ꎞfBNg̏ꏊ擾
	DWORD size = ::GetTempPath(0,NULL);
	TCHAR *buf = new TCHAR[size + 1];
	::GetTempPath(size,buf);
	m_tmpdir = AddYenToDir(buf);
	delete[] buf;
	// pXɂiC̖j
	size = ::GetLongPathName(m_tmpdir.c_str(),NULL,0);
	buf = new TCHAR[size + 1];
	::GetLongPathName(m_tmpdir.c_str(),buf,size);
	m_tmpdir = buf;
	delete[] buf;
}

void setting::Write(){
	WriteINIStr(_T("ispell"),_T("URL"),m_url);
	WriteINIStr(_T("ispell"),_T("ISPELLDICTDIR"),m_ispelldir);
	WriteINIStr(_T("ispell"),_T("Home"),m_home);
	WriteINIInt(_T("ispell"),_T("IsURLList"),m_isurllist ? TRUE : FALSE);
}

void setting::Log(const ablib::string &log){
	LOCK l(this);
	FILE *fp = ::_tfopen(m_log.c_str(),_T("a+"));
	if(fp){
		::_ftprintf(fp,_T("%s\n"),log.c_str());
		::fclose(fp);
	}
}

void setting::WriteINIStr(const TCHAR *sec,const TCHAR *key,const ablib::string &str){
	::WritePrivateProfileString(sec,key,str.c_str(),m_ini.c_str());
}

void setting::WriteINIInt(const TCHAR *sec,const TCHAR *key,int num){
	::WritePrivateProfileString(sec,key,boost::lexical_cast<ablib::string>(num).c_str(),m_ini.c_str());
}

ablib::string setting::GetINIStr(const TCHAR *sec,const TCHAR *key){
	TCHAR buf[4096];
	::GetPrivateProfileString(sec,key,_T(""),buf,4095,m_ini.c_str());
	return ablib::string(buf);
}

int setting::GetINIInt(const TCHAR *sec,const TCHAR *key){
	return ::GetPrivateProfileInt(sec,key,0,m_ini.c_str());
}

ablib::string setting::GetEnv(const TCHAR *name){
	DWORD size = ::GetEnvironmentVariable(name,NULL,0);
	if(size == 0)return _T("");
	TCHAR *buf = new TCHAR[size + 1];
	::GetEnvironmentVariable(name,buf,size + 1);
	ablib::string rv = buf;
	delete[] buf;
	return rv;
}
