#ifndef __SETTING_H__
#define __SETTING_H__

#include <ablib/lock.h>
#include "dll.h"

class setting : public ablib::Lock
{
public:
	setting(){}
	~setting(){}
	void SetINIFile(const TCHAR *ini,const TCHAR *log);

	ablib::string GetURL(){return m_url;}
	ablib::string GetISPELLDICTDIR(){return m_ispelldir;}
	ablib::string GetHome(){return m_home;}
	ablib::string GetTmpDir(){return m_tmpdir;}
	bool IsURLList(){return m_isurllist;}

	void SetURL(const ablib::string &url){m_url = url;}
	void SetISPELLDICTDIR(const ablib::string &dir){m_ispelldir = AddYenToDir(dir);}
	void SetHome(const ablib::string &home){m_home = AddYenToDir(home);}
	void SetIsURLList(bool b){m_isurllist = b;}

	void Log(const ablib::string &log);
	bool IsWriteINI(){return (GetINIInt(_T("system"),_T("NoWriteINI")) == FALSE);}
	void Write();

	static ablib::string GetEnv(const TCHAR *name);

private:
	ablib::string m_ini,m_log;
	ablib::string m_url,m_ispelldir,m_home;
	bool m_isurllist;

	ablib::string m_tmpdir;

	ablib::string GetINIStr(const TCHAR *sec,const TCHAR *key);
	int GetINIInt(const TCHAR *sec,const TCHAR *key);
	void WriteINIInt(const TCHAR *sec,const TCHAR *key,int num);
	void WriteINIStr(const TCHAR *sec,const TCHAR *key,const ablib::string &str);

	void WriteDir(const TCHAR *sec,const TCHAR *key,const ablib::string &dir);
	ablib::string AddYenToDir(const ablib::string &d){
		if(d != _T("") && d[d.length() - 1] != '\\')return d + _T("\\");
		else return d;
	}

};

#endif //__SETTING_H__

