#ifndef __DLL_H__
#define __DLL_H__

#include <ablib/macro/repeat.h>

struct load_function{
public:
	load_function(){}
	load_function(const TCHAR *func) : m_func(func){}
	
	const TCHAR *funcname() const{return m_func.c_str();}
private:
	ablib::string m_func;
};

class DLL{
public:
	DLL() : m_dll(NULL){}
	~DLL(){freedll();}
	
	bool loaddll(const TCHAR *dll);
	bool loaddll();
	bool freedll();
	
#define DLLFUNC_CREATE(n)												\
	template<typename R TEMPLATE_PARAMS(n)>								\
	R dllfunc(const TCHAR *func FUNC_PARAMS(n)){						\
		if(m_dll == NULL)throw load_function(func);						\
		typedef R (*FUNC)(TEMPLATE_ARGS(n));							\
		FUNC f = reinterpret_cast<FUNC>(::GetProcAddress(m_dll,func));	\
		if(f == NULL)throw load_function(func);							\
		return (*f)(FUNC_ARGS(n));										\
	}

#define TEMPLATE_PARAMS(n)
#define TEMPLATE_ARGS(n)
#define FUNC_PARAMS(n)
#define FUNC_ARGS(n)
DLLFUNC_CREATE(0)

//, typename T1,typename T2,...,typename Tn
#undef TEMPLATE_PARAMS
#define TEMPLATE_PARAM(n) typename T ## n ,
#define TEMPLATE_PARAMS(n) , ABLIB_REPEAT_4(n,TEMPLATE_PARAM) typename T ## n
// T1,T2,...,Tn
#undef TEMPLATE_ARGS
#define TEMPLATE_ARG(n) T ## n,
#define TEMPLATE_ARGS(n) ABLIB_REPEAT_4(n,TEMPLATE_ARG) T ## n
//,T1 t1,T2 t2,...,Tn tn
#undef FUNC_PARAMS
#define FUNC_PARAM(n) T ## n t ## n,
#define FUNC_PARAMS(n) , ABLIB_REPEAT_4(n,FUNC_PARAM) T ## n t ## n
//t1,t2,...,tn
#undef FUNC_ARGS
#define FUNC_ARG(n) t ## n,
#define FUNC_ARGS(n) ABLIB_REPEAT_4(n,FUNC_ARG) t ## n

ABLIB_REPEAT(20,DLLFUNC_CREATE)

#undef TEMPLATE_PARAM
#undef TEMPLATE_PARAMS
#undef TEMPLATE_ARG
#undef TEMPLATE_ARGS
#undef FUNC_PARAM
#undef FUNC_PARAMS
#undef FUNC_ARG
#undef FUNC_ARGS

private:
	HMODULE m_dll;
	
private:
	NOCOPY(DLL);
};



#endif //__DLL_H__
