#ifndef __SETTING_H__
#define __SETTING_H__

#include <ablib/lock.h>

class setting : public ablib::Lock
{
public:
	setting(){}
	~setting(){}
	void SetINIFile(const TCHAR *ini,const TCHAR *log);

	ablib::string GetURL() const{return m_url;}
	ablib::string GetTargetDir() const{return m_targetdir;}
	
	void SetURL(const ablib::string &url){m_url = url;}
	void SetTargetDir(const ablib::string &dir);

	bool IsWriteINI(){return (GetINIInt(_T("system"),_T("NoWriteINI")) == FALSE);}
	void Write();

	void Log(const ablib::string &log);

private:
	ablib::string m_ini,m_log;
	ablib::string m_url,m_targetdir;
	ablib::string GetINIStr(const TCHAR *sec,const TCHAR *key);
	int GetINIInt(const TCHAR *sec,const TCHAR *key);
	void WriteINIStr(const TCHAR *sec,const TCHAR *key,const ablib::string &str);
};

#endif //__SETTING_H__

