#include "stdafx.h"
#include <stdio.h>
#include <shlobj.h>
#include <vector>
#include "httpaccess.h"

HttpAccess::HttpAccess(const TCHAR *server) : m_servername(server),m_hreq(NULL),m_connect(NULL){
	m_open = ::InternetOpen(_T("AbTeXinst"),INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0);
}

HttpAccess::~HttpAccess(){
	Close();
}

bool HttpAccess::Connect(int timeout){
	DWORD m_timeout = timeout * 1000;
	m_connect = ::InternetConnect(m_open,m_servername.c_str(),INTERNET_DEFAULT_HTTP_PORT,NULL,NULL,INTERNET_SERVICE_HTTP,0,NULL);
	if(m_connect == NULL)return false;
	::InternetSetOption(m_open,INTERNET_OPTION_RECEIVE_TIMEOUT, &m_timeout,sizeof(DWORD));
	return true;
}

void HttpAccess::Close(){
	::InternetCloseHandle(m_hreq);
	::InternetCloseHandle(m_connect);
	::InternetCloseHandle(m_open);
}


bool HttpAccess::SendHEAD(const TCHAR *file,const TCHAR *addheader){
	if(m_hreq != NULL)::InternetCloseHandle(m_hreq);
	m_hreq = ::HttpOpenRequest(m_connect,_T("HEAD"),file,_T("HTTP/1.1"),(_T("http://") + m_servername + file).c_str(),NULL,0,NULL);
	if(m_hreq == NULL)return false;
	return ::HttpSendRequest(m_hreq,addheader,-1,NULL,0) != FALSE;
}

bool HttpAccess::SendGET(const TCHAR *file,const TCHAR *addheader){
	if(m_hreq != NULL)::InternetCloseHandle(m_hreq);
	m_hreq = ::HttpOpenRequest(m_connect,_T("GET"),file,_T("HTTP/1.1"),(_T("http://") + m_servername + file).c_str(),NULL,0,NULL);
	if(m_hreq == NULL)return false;
	return ::HttpSendRequest(m_hreq,addheader,-1,NULL,0) != FALSE;
}

int HttpAccess::status_code(){
	ASSERT(m_hreq != NULL);
	char sc[32];
	DWORD size = sizeof(char)*32;
	BOOL ret = ::HttpQueryInfo(m_hreq,HTTP_QUERY_STATUS_CODE,sc,&size,0);
	return (ret != FALSE ? ::atoi(sc) : 400);
}

HttpAccess::size_type HttpAccess::content_length(){
	DWORD size = sizeof(size_type);
	size_type rv = 0;
	BOOL ret = ::HttpQueryInfo(m_hreq,HTTP_QUERY_CONTENT_LENGTH | HTTP_QUERY_FLAG_NUMBER,&rv,&size,0);
	return ret != FALSE ? rv : 0;
}

ablib::system::Time HttpAccess::last_modifiled(){
	SYSTEMTIME st;
	DWORD size = sizeof(SYSTEMTIME);
	BOOL ret = ::HttpQueryInfo(m_hreq,HTTP_QUERY_LAST_MODIFIED  | HTTP_QUERY_FLAG_SYSTEMTIME,&st,&size,0);
	ablib::system::Time rv(st);
	if(!ret)rv.SetValid(false);
	return rv;
}

bool HttpAccess::data(std::vector<BYTE> &rv){
	BYTE buf[4096];
	DWORD size;
	do{
		if(!::InternetReadFile(m_hreq,buf,4095,&size))return false;
		rv.insert(rv.end(),buf,buf + size);
	}while(size);
	return true;
}

bool HttpAccess::SetProxy(const TCHAR *server){
	INTERNET_PROXY_INFO ipi;
	ipi.dwAccessType = INTERNET_OPEN_TYPE_PROXY;
	ipi.lpszProxy = server;
	ipi.lpszProxyBypass = _T("<local>");
	if(::InternetSetOption(m_open,INTERNET_OPTION_PROXY,&ipi,sizeof(INTERNET_PROXY_INFO)))return true;
	else return false;
}
