#ifndef __SETTING_H__
#define __SETTING_H__

#include <ablib/lock.h>

class setting : public ablib::Lock
{
public:
	setting(){}
	~setting(){}
	void SetINIFile(const TCHAR *ini,const TCHAR *log);
	ablib::string GetURL(){return GetINIStr(_T("Xy-pic"),_T("URL"));}
	ablib::string GetHozonDir(){return GetINIStr(_T("Dir"),_T("Hozon"));}
	ablib::string GetTeXDir(){return GetINIStr(_T("Dir"),_T("Install"));}
	ablib::string GetTargetDir(){return GetINIStr(_T("Xy-pic"),_T("target"));}
	ablib::string GetProxy(){return GetINIStr(_T("Connect"),_T("Proxy"));}
	int GetProxyPort(){return GetINIInt(_T("Connect"),_T("Port"));}
	bool IsUseNetwork(){return GetINIInt(_T("Connect"),_T("UseNetwork")) != FALSE;}

	void WriteURL(const TCHAR *url);
	void WriteTargetDir(const TCHAR *dir);

	void Log(const ablib::string &log);

private:
	ablib::string m_ini,m_log;
	ablib::string GetINIStr(const TCHAR *sec,const TCHAR *key);
	int GetINIInt(const TCHAR *sec,const TCHAR *key);
	void WriteINIStr(const TCHAR *sec,const TCHAR *key,const TCHAR *str);
};

#endif //__SETTING_H__

