#include "stdafx.h"
#include <algorithm>
#include <boost/lexical_cast.hpp>
#include <ablib/KRSearch.h>
#include <ablib/Pathname.h>
#include <functional>
#include <boost/mem_fn.hpp>
#include "setting.h"
#include "func.h"

/*
ݒt@Cdl
<abtexinst_sys.ini>
[system]
NoWriteIni=iݒt@Cւ݂̏sj
NoWriteHozonDir=i[Dir]Hozonȉւ݂̏}邩ǂj
NoWriteLog=iOoǂj
Log=iOǂɏoj
ruby_option=iRubyɓnIvVj
[Reg]
texinst=itexinst**.zip̃t@C\K\j
DVIOUT=idviout̃t@C\K\j
GS=iGhostscript̃t@C\K\j
GV=iGSview̃t@C\K\j
[TeX]
URLlist0=iXgɏoĂURLj
...
[DVIOUT]
URLlist0=iXgɏoĂURLj
...
[GS]
URLlist0=iXgɏoĂURLj
...
[GV]
URLlist0=iXgɏoĂURLj
...
[FileReg]
luatex=luatex-w32\.tar\.(bz2|gz|xz)
luatex-dev=luatex-dev-w32\.tar\.(bz2|gz|xz)
otf=otf\.tar\.(bz2|gz|xz)
otfbeta=otfbeta\.tar\.(bz2|gz|xz)
otfdevel=otfdevel\.tar\.(bz2|gz|xz)
[TeXSimilarFiles]
; uɂĂvt@Cݒ肷D
; iʎqj=iFileRegŎw肵ʎqRŕׂj
otf=otf:otfdevel:otfbeta
...


<abtexinst.ini>
[TeXURL]
URL=iTeX_E[hj
IsUrlList=iTeXURLXgIԂj
[DVIOUTURL]
URL=iDVIOUT_E[hj
IsUrlList=iDVIOUTURLXgIԂj
[GSURL]
URL=iGhostscript_E[hj
IsUrlList=iGhostscriptURLXgIԂj
[GVURL]
URL=iGSview_E[hj
IsUrlList=iGSviewURLXgIԂj
[Dir]
Hozon=iTeXt@Cꎞۑj
Install=iTeXCXg[j
DVIOUT=iDVIOUTCXg[j
[Connect]
Proxy=ivNVj
Port=i|[gj
DeleteCache=i_E[hOcacheǂj
UseNetwork=ilbg[Ngǂj
[TeX]
dlinst=i_E[ht@CCXg[邩ǂj
UpdatePath=ipXǉ邩ǂj
*/
#include <shlobj.h>
setting::setting() : 
	m_port(0),m_isTeXurllist(true),m_isdviouturllist(true),m_isgsurllist(true)/*,m_isgvurllist(true)*/,m_isdelcache(true),
	m_isusenetwork(true),
	m_iswriteini(true),m_iswritehozondir(true),m_isdlinst(true)

{
	TCHAR file[4096];
	::GetModuleFileName(NULL,file,4096);
	m_inifile = file;
	m_inifile.erase(m_inifile.rfind(_T(".")));
	m_sysinifile = m_inifile + _T("_sys.ini");

	m_inifile += _T(".ini");

	// ꎞfBNg̏ꏊ擾
	DWORD size = ::GetTempPath(0,NULL);
	TCHAR *buf = new TCHAR[size + 1];
	::GetTempPath(size,buf);
	m_tmpdir = AddYenToDir(buf);
	delete[] buf;
	// pXɂiC̖j
	size = ::GetLongPathName(m_tmpdir.c_str(),NULL,0);
	buf = new TCHAR[size + 1];
	::GetLongPathName(m_tmpdir.c_str(),buf,size);
	m_tmpdir = buf;
	delete[] buf;
}

setting::~setting(){
	Log(_T(""));
}

void setting::Read(){
	TCHAR str[4096];
	::GetPrivateProfileString(_T("Reg"),_T("texinst"),_T(""),str,4096,m_sysinifile.c_str());
	m_texinstreg = str;
	::GetPrivateProfileString(_T("Reg"),_T("DVIOUT"),_T(""),str,4096,m_sysinifile.c_str());
	m_dvioutreg = str;
	::GetPrivateProfileString(_T("Reg"),_T("GS"),_T(""),str,4096,m_sysinifile.c_str());
	m_gsreg = str;
	/*
	::GetPrivateProfileString(_T("Reg"),_T("GV"),_T(""),str,4096,m_sysinifile.c_str());
	m_gvreg = str;
	*/
	m_iswriteini = (::GetPrivateProfileInt(_T("System"),_T("NoWriteINI"),FALSE,m_sysinifile.c_str()) == FALSE);
	m_iswritehozondir = (::GetPrivateProfileInt(_T("System"),_T("NoWriteHozonDir"),FALSE,m_sysinifile.c_str()) == FALSE);
	::GetPrivateProfileString(_T("System"),_T("ruby_option"),_T(""),str,4096,m_sysinifile.c_str());
	m_rubyoption = str;
	std::vector<ablib::string> keys;
	keys = GetKeys(m_sysinifile.c_str(),_T("FileReg"));
	m_fileregs.clear();
	for(ablib::string &key : keys){
		::GetPrivateProfileString(_T("FileReg"),key.c_str(),_T(""),str,4095,m_sysinifile.c_str());
		SetFileRegExp(key.c_str(),str);
	}

	struct{std::vector<ablib::string> &variable;TCHAR *sec;} items[] = 
	{{m_texurllist,_T("TeX")},{m_dviouturllist,_T("DVIOUT")},{m_gsurllist,_T("GS")}/*,{m_gvurllist,_T("GV")}*/,{m_texurllist/*dummy*/,NULL}} ,*p;

	for(p = items;p->sec != NULL ; ++p){
		p->variable.clear();
		for(int i = 0; true ; ++i){
			::GetPrivateProfileString(p->sec,(_T("URLlist") + boost::lexical_cast<ablib::string>(i)).c_str(),_T(""),str,4096,m_sysinifile.c_str());
			if(::lstrcmp(str,_T("")) == 0)break;
			p->variable.push_back(str);
		}
	}
	
	keys = GetKeys(m_sysinifile.c_str(),_T("TeXSimilarFiles"));
	for(ablib::string &key : keys){
		::GetPrivateProfileString(_T("TeXSimilarFiles"),key.c_str(),_T(""),str,4096,m_sysinifile.c_str());
		ablib::string val = str;
		ablib::string::size_type p = -1;
		do{
			++p;
			ablib::string::size_type q = p;
			p = val.find(_T(":"),q);
			AddSimilarFile(key.c_str(),val.substr(q,p == ablib::string::npos ? ablib::string::npos : p - q).c_str());
		}while(p != ablib::string::npos);
	}



	::GetPrivateProfileString(_T("TeXURL"),_T("URL"),_T(""),str,4096,m_inifile.c_str());
	SetTeXUrl(str);
	if(std::find(m_texurllist.begin(),m_texurllist.end(),str) == m_texurllist.end())SetIsTeXUrlList(false);
	else SetIsTeXUrlList(::GetPrivateProfileInt(_T("TeXURL"),_T("IsUrlList"),0,m_inifile.c_str()) != FALSE);
	::GetPrivateProfileString(_T("Dir"),_T("Hozon"),_T(""),str,4096,m_inifile.c_str());
	SetHozonDir(str);
	::GetPrivateProfileString(_T("Dir"),_T("Install"),_T(""),str,4096,m_inifile.c_str());
	SetInstallDir(str);
	::GetPrivateProfileString(_T("Connect"),_T("Proxy"),_T(""),str,4096,m_inifile.c_str());
	SetProxy(str);
	SetPortNum(::GetPrivateProfileInt(_T("Connect"),_T("Port"),0,m_inifile.c_str()));
	::GetPrivateProfileString(_T("DVIOUTURL"),_T("URL"),_T(""),str,4096,m_inifile.c_str());
	SetDVIOUTUrl(str);
	if(std::find(m_dviouturllist.begin(),m_dviouturllist.end(),str) == m_dviouturllist.end())SetIsDVIOUTUrlList(false);
	else SetIsDVIOUTUrlList(::GetPrivateProfileInt(_T("DVIOUTURL"),_T("IsUrlList"),FALSE,m_inifile.c_str()) != FALSE);
	::GetPrivateProfileString(_T("GSURL"),_T("URL"),_T(""),str,4096,m_inifile.c_str());
	SetGSUrl(str);
	if(std::find(m_gsurllist.begin(),m_gsurllist.end(),str) == m_gsurllist.end())SetIsGSUrlList(false);
	else SetIsGSUrlList(::GetPrivateProfileInt(_T("GSURL"),_T("IsUrlList"),FALSE,m_inifile.c_str()) != FALSE);
//	::GetPrivateProfileString(_T("GVURL"),_T("URL"),_T(""),str,4096,m_inifile.c_str());
//	SetGVUrl(str);
//	if(std::find(m_gvurllist.begin(),m_gvurllist.end(),str) == m_gvurllist.end())SetIsGVUrlList(false);
//	else SetIsGVUrlList(::GetPrivateProfileInt(_T("GVURL"),_T("IsUrlList"),FALSE,m_inifile.c_str()) != FALSE);
	::GetPrivateProfileString(_T("Dir"),_T("DVIOUT"),_T(""),str,4096,m_inifile.c_str());
	SetDVIOUTInstallDir(str);
	m_isdlinst = (::GetPrivateProfileInt(_T("TeX"),_T("DLInst"),FALSE,m_inifile.c_str()) != FALSE);
	m_istexupdatepath = (::GetPrivateProfileInt(_T("TeX"),_T("UpdatePath"),FALSE,m_inifile.c_str()) != FALSE);
	SetIsDeleteCache(::GetPrivateProfileInt(_T("Connect"),_T("DeleteCache"),FALSE,m_inifile.c_str()) != FALSE);
	SetIsUseNetwork(::GetPrivateProfileInt(_T("Connect"),_T("UseNetwork"),FALSE,m_inifile.c_str()) != FALSE);

	keys = GetKeys(m_inifile.c_str(),_T("Listup"));
	m_listupfiles.clear();
	for(ablib::string &key : keys){
		SetListUpFile(key.c_str(),(::GetPrivateProfileInt(_T("Listup"),key.c_str(),0,m_inifile.c_str()) != FALSE));
	}

}

bool setting::IsIniFileExist(){
	return (::GetFileAttributes(m_inifile.c_str()) != 0xFFFFFFFF);
}

bool setting::IsSysIniFileExist(){
	return (::GetFileAttributes(m_sysinifile.c_str()) != 0xFFFFFFFF);
}

void setting::Write(){
	Write(_T("Dir"),_T("Hozon"),m_hozonraw);
	Write(_T("Dir"),_T("Install"),m_install);
	Write(_T("Connect"),_T("Port"),m_port);
	Write(_T("Connect"),_T("Proxy"),m_proxy);
	Write(_T("TeXURL"),_T("URL"),m_TeXurl);
	Write(_T("TeXURL"),_T("IsUrlList"),m_isTeXurllist);
	Write(_T("DVIOUTURL"),_T("URL"),m_dviouturl);
	Write(_T("DVIOUTURL"),_T("IsUrlList"),m_isdviouturllist);
	Write(_T("Dir"),_T("DVIOUT"),m_dvioutdir);
	Write(_T("GSURL"),_T("URL"),m_gsurl);
	Write(_T("GSURL"),_T("IsUrlList"),m_isgsurllist);
	/*
	Write(_T("GVURL"),_T("URL"),m_gvurl);
	Write(_T("GVURL"),_T("IsUrlList"),m_isgvurllist);
	*/
	Write(_T("TeX"),_T("DLInst"),m_isdlinst);
	Write(_T("TeX"),_T("UpdatePath"),m_istexupdatepath);
	Write(_T("Connect"),_T("DeleteCache"),m_isdelcache);
	Write(_T("Connect"),_T("UseNetWork"),m_isusenetwork);

	for(std::map<ablib::string,bool>::iterator ite = m_listupfiles.begin() ; ite != m_listupfiles.end() ; ++ite){
		Write(_T("Listup"),ite->first.c_str(),ite->second);
	}

}

bool setting::Write(const TCHAR *sec, const TCHAR *key, const TCHAR *val){
	return (::WritePrivateProfileString(sec,key,val,m_inifile.c_str()) != FALSE);
}
bool logfirst = true;
void setting::Log(const ablib::string &log){
	LOCK l(this);
	if(logfirst){
		TCHAR file[4096];
		::GetModuleFileName(NULL,file,4096);
		ablib::string logfile = file;
		logfile.erase(logfile.rfind(_T(".")));

		logfile += _T("_log.txt");
		logfile = logfile.substr(logfile.rfind(_T("\\")) + 1);
		if(logfile == _T(""))logfile = _T("abtexinst_log.txt");

		int logset = ::GetPrivateProfileInt(_T("System"),_T("LogFile"),0,m_sysinifile.c_str());
		TCHAR str[4096];
		if(logset == 1){// installfBNg
			m_logfile = GetInstallDir() + logfile;
		}else if(logset == 2){// hozonfBNg
			m_logfile = GetHozonDir() + logfile;
		}else if(logset == 3){// desktop
			LPITEMIDLIST id;
			LPMALLOC mal;
			if(!FAILED(::SHGetMalloc(&mal)) && !FAILED(::SHGetSpecialFolderLocation(NULL,CSIDL_DESKTOP,&id))){
				::SHGetPathFromIDList(id,str);
				mal->Free(id);
				m_logfile = ablib::string(str) + _T("\\") + logfile;
			}
		}else if(logset == 4){// VXehCu
			::GetSystemDirectory(str,4095);str[1] = '\0';::lstrcat(str,_T(":\\"));
			m_logfile = str + logfile;
		}else{
			// ȊOexêtH_D
			::GetModuleFileName(NULL,str,4096);
			m_logfile = str;
			m_logfile.erase(m_logfile.rfind(_T(".")));
			m_logfile += _T("_log.txt");
		}
//		::MessageBox(NULL,m_logfile.c_str(),NULL,0);

		bool iswritelog = (::GetPrivateProfileInt(_T("System"),_T("NoWriteLog"),FALSE,m_sysinifile.c_str()) == FALSE);
		if(iswritelog){
			ablib::string dir = m_logfile;
			dir.erase(dir.rfind(_T("\\")) + 1);
			// Ot@CtH_
			::CreateDirectoryReflex(dir.c_str());
		}else m_logfile = _T("");

		if(m_logfile != _T("")){
			FILE *fp = ::_tfopen(m_logfile.c_str(),_T("a+"));
			if(fp){
				SYSTEMTIME si;
				::GetLocalTime(&si);
				::_ftprintf(fp,_TR("--------%dN%d%d%d%dɋÑO ----------\n"),
					si.wYear,si.wMonth,si.wDay,si.wHour,si.wMinute);
				::fclose(fp);
			}
		}
		logfirst = false;
	}
	

	if(m_logfile != _T("")){
		FILE *fp = ::_tfopen(m_logfile.c_str(),_T("a+"));
		if(fp){
			::_ftprintf(fp,_T("%s\n"),log.c_str());
			::fclose(fp);
		}
	}
}

ablib::string setting::ToAbsolutePath(const ablib::string &d){
	if(d.length() >= 2 && d[1] == ':')return d;
	ablib::string s = d;
	s.replace(_T("/"),_T("\\"));
	TCHAR buf[MAX_PATH + 1];
	::GetModuleFileName(NULL,buf,MAX_PATH);
	ablib::Pathname abtexinst(buf);
	s = abtexinst.dirname() + _T("\\") + s;
	
	// s"\\"ŕ
	ablib::KRSearch search(_T("\\"));
	ablib::string::size_type p = 0;
	std::vector<ablib::string> sv;
	while(search.Match(s.c_str() + p,s.length() - p)){
		sv.push_back(s.substr(p,search.GetMatchPos()));
		p += search.GetMatchPos() + 1;
	}
	
	std::vector<ablib::string> sv2;
	for(ablib::string &i : sv){
		if(i == _T(".") || i == _T(""))continue;
		else if(i == _T("..")){if(!sv2.empty())sv2.pop_back();}
		else sv2.push_back(i);
	}
	
	s = _T("");
	for(ablib::string &i : sv2){
		s = s + i + _T("\\");
	}
	return s;
}

ablib::string setting::ExpandEnvVar(const ablib::string &s){
	DWORD size = ::ExpandEnvironmentStrings(s.c_str(),NULL,0);
	TCHAR *rv = new TCHAR[size + 1];
	::ExpandEnvironmentStrings(s.c_str(),rv,size);
	ablib::string r = rv;
	delete[] rv;
	return r;
}

bool setting::SetFileRegExp(const TCHAR *key, const TCHAR *reg){
	if(::lstrcmp(reg,_T("")) == 0)return false;
	Oniguruma::RegEx rex(reg);
	rex.SetOpt(_T("CaseSense"),false);
	if(!rex.IsCompiled())return false;
	m_fileregs[key] = rex;
	return true;
}

bool setting::DoseListUp(const ablib::string &file){
	bool r;
	r = true;
#ifndef NDEBUG
	bool chk = true;// Ƀ}b`Ȃ悤ɂ悤
#endif
	for(auto & i : m_listupfiles){
		ASSERT(m_fileregs.find(i.first) != m_fileregs.end());
		if(m_fileregs[i.first].Match(file)){
#ifndef NDEBUG
			ASSERT(chk);
			chk = false;
#endif
			r = i.second;
		}
	}
	return r;
}


std::vector<ablib::string> setting::GetKeys(const TCHAR *ini, const TCHAR *sec){
	TCHAR keys[65537];
	::GetPrivateProfileString(sec,NULL,_T(""),keys,65535,ini);
	std::vector<ablib::string> rv;
	const TCHAR *p = keys;
	while(*p){
		rv.push_back(p);
		p += ::lstrlen(p) + 1;
	}
	return rv;
}

void setting::AddSimilarFile(const TCHAR *key, const TCHAR *filekey){
//	ASSERT(m_fileregs.find(filekey) != m_fileregs.end());
	m_similarfile[key].push_back(filekey);
}

// ɂĂƎw肳ꂽ̂͂ɂĂƔD
// łȂꍇ́C𔲂ŔrD
// C.bz2C.gzy.xz̈Ⴂ͖D
int setting::IsSimilarFile(const ablib::string &a, const ablib::string &b){
	for(std::map<ablib::string,std::vector<ablib::string> >::const_iterator ite = m_similarfile.begin() ; ite != m_similarfile.end() ; ++ite){
		//[&](const ablib::string &str){return m_fileregs[a].Match(str);})){
//		if(std::find_if(ite->second.begin(),ite->second.end(),std::bind(std::mem_fn(&setting::RegMatch),this,std::placeholders::_1,a)) != ite->second.end()){
		if(std::find_if(ite->second.begin(),ite->second.end(),[&a,this](const ablib::string &str){return m_fileregs[a].Match(str);}) != ite->second.end()){
			if(std::find_if(ite->second.begin(),ite->second.end(),[&b,this](const ablib::string &str){return m_fileregs[b].Match(str);}) != ite->second.end())return 1;
		}
	}

	ablib::string::size_type alen = a.length();
	if(a.find(_T(".gz")) == alen - 3)alen -= 3;
	else if(a.find(_T(".bz2")) == alen - 4)alen -= 4;
	else if(a.find(_T(".xz")) == alen - 3)alen -= 3;

	ablib::string::size_type blen = b.length();
	if(b.find(_T(".gz")) == blen - 3)blen -= 3;
	else if(b.find(_T(".bz2")) == blen - 4)blen -= 4;
	else if(b.find(_T(".xz")) == blen - 3)blen -= 3;

	ablib::string::size_type ai = 0,bi = 0;
	for(ai = 0 ; ai < alen ; ++ai){
		if('0' <= a[ai] && a[ai] <= '9')continue;
		for(;bi < blen ; ++bi){
			if('0' <= b[bi] && b[bi] <= '9')continue;
			if(b[bi] != a[ai])return 0;
			else{++bi;break;}
		}
	}
	if(bi != blen)return 0;
	else return 2;
}

