#ifndef __SETTING_H__
#define __SETTING_H__

#include <map>
#include <vector>
#include <ablib/lock.h>
#include <boost/lexical_cast.hpp>
#include <Oniguruma/RegEx.h>

/*
ݒ̓ǂݏoAoAێB
*/

class setting : public ablib::Lock{
public:
	setting();
	~setting();
	void Read();
	void Write();
	bool Write(const TCHAR *sec,const TCHAR *key,const TCHAR *val);
	bool Write(const TCHAR *sec,const TCHAR *key,const ablib::string &val){return Write(sec,key,val.c_str());}
	bool Write(const TCHAR *sec,const TCHAR *key,int val){return Write(sec,key,boost::lexical_cast<ablib::string>(val));}
	bool Write(const TCHAR *sec,const TCHAR *key,bool b){return Write(sec,key,b?TRUE:FALSE);}
	const TCHAR *GetIniFile() const{return m_inifile.c_str();}
	const TCHAR *GetSysIniFile() const{return m_sysinifile.c_str();}
	const TCHAR *GetLogFile() const{return m_logfile.c_str();}
	const TCHAR *GetHozonDirRaw() const{return m_hozonraw.c_str();}
	const TCHAR *GetHozonDir() const{return m_hozonabs.c_str();}
	const TCHAR *GetInstallDir() const{return m_install.c_str();}
	const TCHAR *GetTeXUrl() const{return m_TeXurl.c_str();}
	const TCHAR *GetProxy() const{return m_proxy.c_str();}
	const TCHAR *GetTeXInstReg() const{return m_texinstreg.c_str();}
	const TCHAR *GetDVIOUTUrl() const{return m_dviouturl.c_str();}
	const TCHAR *GetGSUrl() const{return m_gsurl.c_str();}
//	const TCHAR *GetGVUrl() const{return m_gvurl.c_str();}
	const TCHAR *GetDVIOUTReg() const{return m_dvioutreg.c_str();}
	const TCHAR *GetGSReg() const{return m_gsreg.c_str();}
//	const TCHAR *GetGVReg() const{return m_gvreg.c_str();}
	const TCHAR *GetDVIOUTInstallDir() const{return m_dvioutdir.c_str();}

	const std::vector<ablib::string> &GetTeXURLlist() const{return m_texurllist;}
	const std::vector<ablib::string> &GetDVIOUTURLlist() const{return m_dviouturllist;}
	const std::vector<ablib::string> &GetGSURLlist() const{return m_gsurllist;}
//	const std::vector<ablib::string> &GetGVURLlist() const{return m_gvurllist;}

	const TCHAR *GetTmpDir(){return m_tmpdir.c_str();}

	int GetPortNum() const{return m_port;}
	bool IsTeXUrlList() const{return m_isTeXurllist;}
	bool IsDVIOUTUrlList() const{return m_isdviouturllist;}
	bool IsGSUrlList() const{return m_isgsurllist;}
//	bool IsGVUrlList() const{return m_isgvurllist;}
	bool IsDeleteCache() const{return m_isdelcache;}
	bool IsUseNetwork() const{return m_isusenetwork;}
	bool IsWriteINI() const{return m_iswriteini;}
	bool IsWriteHozonDir() const{return m_iswritehozondir;}
	bool IsDLInst() const{return m_isdlinst;}
	bool IsTeXUpdatePath() const{return m_istexupdatepath;}
	const TCHAR *GetRubyOption() const{return m_rubyoption.c_str();}

	bool DoseListUp(const ablib::string &file);
	// 0 = ɂĂȂC1 = ɂĂƎw肳ĂC2 = ׂĂ݂ɂĂ
	int IsSimilarFile(const ablib::string &file1,const ablib::string &file2);
	// lbg[Ñt@CƂăXgAbv邩ǂDiotf/otfdevelƂɎgj
	void SetListUpFile(const TCHAR *key,bool b){m_listupfiles[key] = b;}
	// DoseListUpƂ̈ႢccD
	bool GetListUpFile(const TCHAR *key){ASSERT(m_listupfiles.find(key) != m_listupfiles.end());return m_listupfiles[key];}

	void SetHozonDir(const ablib::string &dir){m_hozonraw = AddYenToDir(dir);m_hozonabs = ToAbsolutePath(m_hozonraw);}
	void SetInstallDir(const ablib::string &dir){m_install = ExpandEnvVar(AddYenToDir(dir));}
	void SetTeXUrl(const TCHAR *url){m_TeXurl = url;}
	void SetProxy(const ablib::string &proxy){m_proxy = proxy;}
//	void SetTeXInstReg(const TCHAR *reg){m_texinstreg = reg;}
	void SetDVIOUTUrl(const TCHAR *url){m_dviouturl = url;}
	void SetGSUrl(const TCHAR *url){m_gsurl = url;}
//	void SetGVUrl(const TCHAR *url){m_gvurl = url;}
//	void SetDVIOUTReg(const TCHAR *reg){m_dvioutreg = reg;}
//	void SetGSReg(const TCHAR *reg){m_gsreg = reg;}
//	void SetGVReg(const TCHAR *reg){m_gvreg = reg;}
	void SetDVIOUTInstallDir(const TCHAR *dir){m_dvioutdir = AddYenToDir(dir);}
	void SetPortNum(int port){m_port = port;}
	void SetIsTeXUrlList(bool b){m_isTeXurllist = b;}
	void SetIsDVIOUTUrlList(bool b){m_isdviouturllist = b;}
	void SetIsGSUrlList(bool b){m_isgsurllist = b;}
//	void SetIsGVUrlList(bool b){m_isgvurllist = b;}
	void SetIsDeleteCache(bool b){m_isdelcache = b;}
	void SetIsUseNetwork(bool b){m_isusenetwork = b;}
//	void SetIsWriteINI(bool b){m_iswriteini = b;}
//	void SetIsWriteHozonDir(bool b){m_iswritehozondir = b;}
	// _E[h=CXg[́CD
	void SetIsDLInst(bool b){m_isdlinst = b;}
	void SetIsTeXUpdatePath(bool b){m_istexupdatepath = b;}

	bool IsIniFileExist();
	bool IsSysIniFileExist();
	void Log(const ablib::string &log);

private:
	ablib::string m_inifile,m_sysinifile,m_install,m_TeXurl,m_proxy,m_texinstreg;
	ablib::string m_hozonraw,m_hozonabs;// ۑfBNg͑΃pX\ɂDhozonraw΁iȂjpXŁChozonabs΃pXɕΐD
	ablib::string m_dviouturl,m_gsurl/*,m_gvurl*/,m_dvioutreg,m_gsreg/*,m_gvreg*/,m_dvioutdir;
	ablib::string m_logfile;
	ablib::string m_rubyoption;
	int m_port;
	bool m_isTeXurllist,m_isdviouturllist,m_isgsurllist/*,m_isgvurllist*/,m_isdlinst,m_isdelcache;
	bool m_isusenetwork;
	bool m_iswriteini,m_iswritehozondir;
	bool m_istexupdatepath;
	std::map<ablib::string,Oniguruma::RegEx> m_fileregs;
	std::map<ablib::string,bool> m_listupfiles;
	std::map<ablib::string,std::vector<ablib::string> > m_similarfile;
	std::vector<ablib::string> m_texurllist,m_dviouturllist,m_gsurllist/*,m_gvurllist*/;

	ablib::string m_tmpdir;

	ablib::string AddYenToDir(const ablib::string &d){
		if(d != _T("") && d[d.length() - 1] != '\\')return d + _T("\\");
		else return d;
	}
	ablib::string ToAbsolutePath(const ablib::string &d);
	ablib::string ExpandEnvVar(const ablib::string &str);

	std::vector<ablib::string> GetKeys(const TCHAR *ini,const TCHAR *sec);// keyꗗ擾D

	// ʎqƐK\֘AÂD
	bool SetFileRegExp(const TCHAR *key,const TCHAR *reg);
	// 悤ȃt@Cݒ肷Dotf/otfdevelƂDkey = u悤ȃt@Cv̎ʎqCfilekey = SetFileRegExpŐݒ肵t@C̎ʎqD
	void AddSimilarFile(const TCHAR *key,const TCHAR *filekey);

};

#endif //__SETTING_H__

